//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "StdAfx.h"
#include "updownclient.h"
#include "emule.h"
#include "UploadQueue.h"
#include "Clientlist.h"
#include "otherfunctions.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

//--- xrmb:hashthieves1 ---
OffenseCounterMap		CUpDownClient::g_mapOffenseCounter;
HashBaseMap				CUpDownClient::g_mapHashBase;

//	members of CUpDownClient
//	which are used by down and uploading functions

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef OLD_SOCKETS_ENABLED
CUpDownClient::CUpDownClient(CClientReqSocket *pRequestSocket)
{
	m_pRequestSocket = pRequestSocket;
	m_pReqPartFile = NULL;
	Init();
}
#endif //OLD_SOCKETS_ENABLED
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CUpDownClient::CUpDownClient(uint16 uPort, uint32 dwClientID, uint32 dwServerIP, uint16 uServerPort, CPartFile *pReqPartFile)
{
#ifdef OLD_SOCKETS_ENABLED
	m_pRequestSocket = NULL;
#endif //OLD_SOCKETS_ENABLED

	Init();

	SetUserID(dwClientID);
	m_uUserPort = uPort;
	m_iSourcesSlot = m_dwUserID % SOURCESSLOTS;
	if (!HasLowID())
	{
		m_strFullUserIP.Format( _T("%i.%i.%i.%i"),
								static_cast<uint8>(m_dwUserID),
								static_cast<uint8>(m_dwUserID >> 8),
								static_cast<uint8>(m_dwUserID >> 16),
								static_cast<uint8>(m_dwUserID >> 24) );
	}
	m_dwServerIP = dwServerIP;
	m_uServerPort = uServerPort;
	m_pReqPartFile = pReqPartFile;
	ReGetClientSoft();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::Init()
{
	EMULE_TRY

	m_strFullUserIP = "";
	m_pCredits = 0;
	m_dwEnteredConnectedState = 0;
	m_uLastPartAsked = 0xFFFF;
	m_dwAvgDownDataRate = 0;
	m_dwAvgUpDataRate = 0;
	m_qwClientSumDLDataRateOverLastNMeasurements = 0;
	m_qwClientSumDLTickOverLastNMeasurements = 0;
	m_dwTransferredInLastPeriod = 0;
	m_uUDPPort = 0;
	m_byteFailedCount = 0;
	m_dwBanTime = 0;
	m_dwMaxSendAllowed = 0;
	m_dwTransferredUp = 0;
	m_dwAskedCount = 0;
	m_dwDownAskedCount = 0;
	m_lUpDataRate = -1;
	m_strUserName = "";
	m_dwUserIP = 0;
	SetUserID(0);
	m_uServerPort = 0;
	m_bIsOnLan = false;
	m_bBanned = false;
	m_iFileListRequested = m_iFileListRequestedSave = 0;
	m_dwLastUpRequest = 0;
	m_bEmuleProtocol = false;
	m_bUsedCompressionDown = false;
	m_bUsedCompressionUp = false;
	m_bCompleteSource = false;
	m_bCommentDirty = false;
	m_bReaskPending = false;
	m_bUDPPending = false;
	m_byteEmuleVersion = 0;
	m_strModVersion = "";
	m_strModExtended = "";
	m_uUserPort = 0;
	m_uPartCount = 0;
	m_uUpPartCount = 0;
	m_pbytePartStatuses = 0;
	m_pbyteUpPartStatuses = 0;
	m_dwLastAskedTime = 0;
	m_eDownloadState = DS_NONE;
	m_dwUploadTime = 0;
	m_dwTransferredDown = 0;
	m_dwDownDataRate = 0;
	m_byteFailedFileRequestsCount = 0;
	m_eUploadState = US_NONE;
	m_dwLastBlockReceived = 0;
	m_byteEmuleVersion = 0;
	m_byteDataCompVer = 0;
	m_dwDataPlusVers = 0;
	m_byteUDPVer = 0;
	m_byteSourceExchangeVer = 0;
	m_byteAcceptCommentVer = 0;
	m_byteExtendedRequestsVer = 0;
	m_byteDataTarodVer = 0;
	m_uRemoteQueueRank = 0;
	m_dwLastSourceRequest = 0;
	m_dwLastSourceAnswer = 0;
	m_uRemoteClientSpeed = 0;
	m_dwCompatibleClient = 0;
	m_bIsHybrid = false;
	m_dwAwayMessageResendCount = 0;
	m_bIsML = false;
	m_pFriend = NULL;
	m_eRating = PF_RATING_NONE;
	m_strComment = "";
	m_dwLastGotULDataTime = 0;
	m_eClientSoft = SO_UNKNOWN;
	m_bRemoteQueueFull = false;
	md4clr(m_userHash);
	SetWaitStartTime();
	m_dwRemoteScore = 0;
	m_uRemoteRatio = 0;
	m_uRemoteBaseModifier = 0;
	m_bRemoteInfoAvailable = false;
	m_bRemoteCommunity = false;
	m_bRemoteCommunityEnabled = false;

#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket != NULL)
	{
		SOCKADDR_IN		sockAddr;

		memset2(&sockAddr, 0, sizeof(sockAddr));

		int		iSockAddrLen = sizeof(sockAddr);

		m_pRequestSocket->GetPeerName(reinterpret_cast<SOCKADDR*>(&sockAddr),&iSockAddrLen);
		m_dwUserIP = sockAddr.sin_addr.S_un.S_addr;
		m_strFullUserIP = inet_ntoa(sockAddr.sin_addr);
	}
#endif //OLD_SOCKETS_ENABLED
	m_iSourcesSlot = 0;
	m_uUpCompleteSourcesCount = 0;
	m_dwUpCompleteSourcesTime = 0;
	m_dwLastRefreshedULDisplayTime = ::GetTickCount();
	m_bScoreBaseIsCached = false;
	m_bCommunityIsCached = false;
	m_bSupportsAskSharedDirs = false;
	md4clr(m_reqFileHash);

	m_dwLastL2HACExec = 0;
	m_dwL2HACTime = 0;
	m_bL2HACEnabled = false;

	m_eSecureIdentState = IS_UNAVAILABLE;
	m_dwLastSignatureIP = 0;
	m_byteSupportSecIdent = 0;
	m_eInfoPacketsReceived = IP_NONE;

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CUpDownClient::~CUpDownClient()
{
	EMULE_TRY

//	AddDebugLogLine(false,_T("%s: Destroying client %s (addr 0x%08X)"),__FUNCTION__,GetUserName(),this);

#if KEEP_BANNED_CLIENTS
//
//	Log deletion of banned client
//
	if (m_bBanned && !g_eMuleApp.m_pGlobPrefs->GetCMNotLog())
	{
	//	Enable cm-logging and set breakpoint here to see from where (shift-f11) it's been deleted
		AddDebugLogLine(false, _T("%s: Deleting banned client '%s' by releasing object"), __FUNCTION__, GetUserName());
	}
#endif

	g_eMuleApp.m_pDownloadList->RemoveSource(this);
	g_eMuleApp.m_pClientList->RemoveClient(this);

	if (m_pFriend != NULL)
	{
		m_pFriend->m_pLinkedClient = NULL;
		g_eMuleApp.m_pFriendList->RefreshFriend(m_pFriend);
		m_pFriend = NULL;
	}
#ifdef OLD_SOCKETS_ENABLED
	g_eMuleApp.m_pListenSocket->DeleteSocket(m_pRequestSocket);
#endif //OLD_SOCKETS_ENABLED
	if (m_pbytePartStatuses != NULL)
	{
		delete[] m_pbytePartStatuses;
		m_pbytePartStatuses	= NULL;
	}
	if (m_pbyteUpPartStatuses != NULL)
	{
		delete[] m_pbyteUpPartStatuses;
		m_pbyteUpPartStatuses = NULL;
	}
	ClearUploadBlockRequests();

	while (!m_downloadBlocksList.IsEmpty())
	{
		delete m_downloadBlocksList.RemoveHead();
	}
	while (!m_requestedFilesList.IsEmpty())
	{
		delete m_requestedFilesList.RemoveHead();
	}
	while (!m_pendingBlocksList.IsEmpty())
	{
		Pending_Block_Struct		*pPending = m_pendingBlocksList.RemoveHead();

		delete pPending->m_pRequestedBlock;
	//	Not always allocated
		if (pPending->m_pZStream)
		{
			inflateEnd(pPending->m_pZStream);
			delete pPending->m_pZStream;
		}
		delete pPending;
	}

	if (m_eRating != PF_RATING_NONE || m_strComment.GetLength() > 0)
	{
		m_eRating = PF_RATING_NONE;
		m_strComment = "";
		m_pReqPartFile->UpdateFileRatingCommentAvail();
	}

	m_averageUDRList.clear();
	m_averageDLDataRateList.clear();
#ifdef OLD_SOCKETS_ENABLED

	DEBUG_ONLY (g_eMuleApp.m_pListenSocket->Debug_ClientDeleted(this));
#endif //OLD_SOCKETS_ENABLED

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CUpDownClient::ProcessHelloPacket(char* pachPacket, uint32 nSize)
{
	EMULE_TRY
	CSafeMemFile data((BYTE*)pachPacket, nSize);
	uint8 hashsize;
	data.Read(&hashsize, 1);
	return ProcessHelloTypePacket(data);
	EMULE_CATCH
	return false;
}

void CUpDownClient::ProcessHelloAnswer(char* pachPacket, uint32 nSize)
{
	EMULE_TRY
	CSafeMemFile data((BYTE*)pachPacket, nSize);
	ProcessHelloTypePacket(data);
	EMULE_CATCH
}

bool CUpDownClient::ProcessHelloTypePacket(CSafeMemFile& data)
{
	EMULE_TRY
	m_bIsHybrid = false;
	m_bIsML = false;
	data.Read(&m_userHash, 16);
	uint32 nUserID;
	data.Read(&nUserID, 4);
	if (!m_dwUserID)
		SetUserID(nUserID);
	data.Read(&m_uUserPort, 2); // hmm clientport is sent twice - why?
	uint32	tagcount;
	data.Read(&tagcount, 4);
	bool crashed = false; //Vorlost
	bool wrong_port = false; // obaldin
	CClientTag* strTemptag;	//eklmn: small tag optimization to prevent memleaks
	for (uint32 i = 0;i < tagcount; i++)
	{
		strTemptag = new CClientTag(data);	//eklmn: small tag optimization to prevent memleaks
		switch (strTemptag->GetSpecialTag())
		{
			case CT_NAME:
			m_strUserName.Empty();	//clear a user name
			if (strTemptag->GetStringValue().IsEmpty())
			{
				crashed = true;
				uchar crashash[16];
				md4cpy(crashash, m_userHash);
				CString buffer = FileHashToString(crashash);
				AddDebugLogLine(false, _T("%s: Invalid user name received! Userhash:%s, IP:%s, Userport:%d"), __FUNCTION__, buffer, m_strFullUserIP, m_uUserPort);
				m_strUserName = _T("[Invalid user name]"); //Vorlost
			}
			else
				m_strUserName.SetString(strTemptag->GetStringValue(), strTemptag->GetStringValue().GetLength()); //eklmn: used CSimpleString class & fuctions
			break;
			case CT_VERSION:
			m_dwClientVersion = strTemptag->GetIntValue();
			break;
			case CT_PORT:
			if (strTemptag->GetIntValue() != m_uUserPort && GetClientSoft() != SO_EDONKEYHYBRID)
			{
				wrong_port = true;
			}
			break;
			case CT_MOD_VERSION:
			{
				m_strModVersion = strTemptag->GetStringValue();
				break;
			}
			case CT_EMULE_RESERVED1:
			case CT_EMULE_RESERVED2:
			case CT_EMULE_RESERVED3:
			case CT_EMULE_RESERVED4:
			case CT_EMULE_RESERVED5:
			case CT_EMULE_RESERVED6:
			case CT_EMULE_RESERVED7:
			case CT_EMULE_RESERVED8:
			case CT_EMULE_RESERVED9:
			case CT_EMULE_UDPPORTS:
			case CT_EMULE_MISCOPTIONS1:
			case CT_EMULE_VERSION:
			case CT_EMULE_RESERVED10:
			case CT_EMULE_RESERVED11:
			case CT_EMULE_RESERVED12:
			case CT_EMULE_RESERVED13:
			case CT_FRIENDSHARING:
			case CT_UNKNOWNx0:
			case CT_UNKNOWNx12:
			case CT_UNKNOWNx13:
			case CT_UNKNOWNx14:
			case CT_UNKNOWNx15:
			case CT_UNKNOWNx16:
			case CT_UNKNOWNx17:
			case CT_UNKNOWNx22:
			case CT_UNKNOWNx63:
			case CT_UNKNOWNx64:
			case CT_UNKNOWNx69:
			case CT_UNKNOWNx88:
			case CT_UNKNOWNx8c:
			case CT_UNKNOWNx8d:
			case CT_UNKNOWNx99:
			case CT_UNKNOWNxbb:
			break;
			default:
			{
				if (!strTemptag->GetStringValue().IsEmpty())
				{
					CString buffer = strTemptag->GetStringValue();
					TagToDebugLogLine(_T("Hello: Unknown eDonkey tag"), buffer, buffer.GetLength(), strTemptag->GetSpecialTag());	// DbT:Logging
				}
				AddDebugLogLine( false, _T("%s: Hello: Unknown eDonkey tag: 0x%x, Intvalue: %d Stringvalue: %s, (client version:%d) %s"),
				                 __FUNCTION__, strTemptag->GetSpecialTag(), strTemptag->GetIntValue(), strTemptag->GetStringValue(), m_dwClientVersion,
				                 m_strUserName );
			}
		}
		delete strTemptag;
		strTemptag = NULL;	//eklmn: small tag optimization to prevent memleaks
	}

//	check server parameters & add it to the list
	data.Read(&m_dwServerIP, 4);
	data.Read(&m_uServerPort, 2);
	if (g_eMuleApp.m_pGlobPrefs->GetAddServersFromConn() && !crashed)
	{  // obaldin: we shouldn't trust the client who tried to crash us
		if (!g_eMuleApp.m_pServerList->GetServerByIP(m_dwServerIP, m_uServerPort))
		{
			in_addr addhost;
			addhost.S_un.S_addr = m_dwServerIP;
			CServer* addsrv = new CServer(m_uServerPort, CString(inet_ntoa(addhost)));
			addsrv->SetListName(addsrv->GetAddress());
			if (!g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.AddServer(addsrv, true))
				delete addsrv;
		}
	}

//	Hybrid now has an extra uint32.. What is it for?
//	Also, many clients seem to send an extra 6? These are not eDonkeys or Hybrids..
	if (data.GetLength() - data.GetPosition() == 4)
	{
		uint32 test;
		data.Read(&test, 4);
		if (test == 'KDLM')
		{
			m_bIsML = true;
		}
		else
		{
			m_bIsHybrid = true;
			m_bSupportsAskSharedDirs = true;
		}
	}
//	7/03/2003 [moosetea] Is this commented out for a reason? it cleans up client version numbers, specifically hybrids in the main client
//if( m_dwClientVersion > 10000 && m_dwClientVersion < 100000 )
//	m_dwClientVersion = m_dwClientVersion - (m_dwClientVersion/10000)*10000;
//if( m_dwClientVersion > 1000 )
//	m_dwClientVersion = m_dwClientVersion - (m_dwClientVersion/1000)*1000;
//if( m_dwClientVersion < 100 )
//	m_dwClientVersion *= 10;

#ifdef OLD_SOCKETS_ENABLED
	if (wrong_port && !m_bIsHybrid)
	{
		CString ip_addr;
		UINT port;
		m_pRequestSocket->GetPeerName(ip_addr, port);
		AddDebugLogLine(false, _T("%s: User %s (client version:%d) IP:%s sent an incorrect user port. Used the real one instead: %d."), __FUNCTION__, m_strUserName, m_dwClientVersion, ip_addr, m_uUserPort);
	}
#endif //OLD_SOCKETS_ENABLED

	SOCKADDR_IN sockAddr;
	memset2(&sockAddr, 0, sizeof(sockAddr));
	uint32 dwSockAddrLen = sizeof(sockAddr);
#ifdef OLD_SOCKETS_ENABLED

	m_pRequestSocket->GetPeerName((SOCKADDR*) & sockAddr, (int*) & dwSockAddrLen);
#endif //OLD_SOCKETS_ENABLED

	m_dwUserIP = sockAddr.sin_addr.S_un.S_addr;
	m_strFullUserIP = inet_ntoa(sockAddr.sin_addr);

//	If lancast is enabled check to see if this client is on the LAN
	m_bIsOnLan = ((g_eMuleApp.m_pGlobPrefs->GetLancastEnabled()) && ((g_eMuleApp.m_pGlobPrefs->GetLancastIP() & g_eMuleApp.m_pGlobPrefs->GetLancastSubnet()) == (m_dwUserIP & g_eMuleApp.m_pGlobPrefs->GetLancastSubnet())));
	if (m_bIsOnLan)
		m_dwUserID = m_dwUserIP;

//	Make sure if this user is a highid user there userid matches there ip address
	if (!HasLowID() && m_dwUserID != m_dwUserIP)
		SetUserID(m_dwUserIP);

//	get client credits
	uchar key[16];
	md4cpy(key, m_userHash);
	m_pCredits = g_eMuleApp.m_pClientCreditList->GetCredit(key);
	if ((m_pFriend = g_eMuleApp.m_pFriendList->LinkFriend(key, m_dwUserIP, m_uUserPort)) != NULL)
	{
		m_pFriend->m_pLinkedClient = this;
		m_pFriend->m_dwHasHash = 1;
		for (int i = 0; i < 16; i++)
			m_pFriend->m_abyUserhash[i] = GetUserHash()[i];
		m_pFriend->m_strName.Format(_T("%s"), m_strUserName);
		m_pFriend->m_dwLastUsedIP = m_dwUserIP;
		m_pFriend->m_nLastUsedPort = m_uUserPort;
		g_eMuleApp.m_pFriendList->RefreshFriend(m_pFriend);
		if (m_eChatState == MS_CONNECTING)
		{
			TCITEM newitem;
			newitem.mask = TCIF_TEXT;
			newitem.pszText = m_strUserName.GetBuffer(256);
			g_eMuleApp.m_pdlgEmule->m_wndChat.chatselector.SetItem(g_eMuleApp.m_pdlgEmule->m_wndChat.chatselector.GetTabByClient(this), &newitem);
		}
	}
	ReGetClientSoft();
//--- xrmb:hashthieves1 ---
//--- detectmystolenhash ---
	uint64 id = GetUID();
	uint32 last_actions = 0;
	uint32 i_TotalClients = 0;
	uint32 i_TotalClientActions = 0;
	uint32 i_TotalActions = g_mapOffenseCounter[0];
	if (g_mapOffenseCounter.Lookup(id, i_TotalClientActions))
		i_TotalClients = g_mapOffenseCounter.GetSize() - 1;
	else
		i_TotalClients = g_mapOffenseCounter.GetSize();
//	now start to check actions
#ifdef OLD_SOCKETS_ENABLED

	if (g_eMuleApp.m_pServerConnect->GetClientID() != m_dwUserID && md4cmp(m_userHash, g_eMuleApp.m_pGlobPrefs->GetUserHash()) == 0 && g_eMuleApp.m_pGlobPrefs->GetMlDonkeyCM())
	{
		Ban(_T("AUTOMATED MESSAGE: You're being banned because your client is leeching!"), GetResString(IDS_BAN_HASHIMP));
		m_bIsHashThief = true;
		last_actions++;
		i_TotalActions++;

		AddDebugLogLine( false, _T("%s: Client '%s' uses my hash, ip %i.%i.%i.%i:%i, suspicious actions: %i (%i in total/%i clients)!"), __FUNCTION__, m_strUserName,
		                 (uint8)m_dwUserIP, (uint8)(m_dwUserIP >> 8), (uint8)(m_dwUserIP >> 16), (uint8)(m_dwUserIP >> 24), m_uUserPort, (i_TotalClientActions + last_actions), i_TotalActions, i_TotalClients );
	}
#endif //OLD_SOCKETS_ENABLED

//--- detect id-changer ---
	uint64 lasthash;
	uint64 thishash = 0;
	for (int i = 0; i < 8; i++)
		thishash += GetUserHash()[i] << (i * 8) ^ GetUserHash()[i + 8] << (i * 8);
	if (g_mapHashBase.Lookup(id, lasthash) && lasthash != thishash)
	{
		m_bIsHashThief = true;
		last_actions++;
		i_TotalActions++;

		AddDebugLogLine( false, _T("%s: Client '%s' changed hash, ip %i.%i.%i.%i:%i, suspicious actions: %i (%i in total/%i clients)!"), __FUNCTION__, m_strUserName,
		                 (uint8)m_dwUserIP, (uint8)(m_dwUserIP >> 8), (uint8)(m_dwUserIP >> 16), (uint8)(m_dwUserIP >> 24), m_uUserPort, (i_TotalClientActions + last_actions), i_TotalActions, i_TotalClients );
	}
	g_mapHashBase[id] = thishash;

//--- famous stolen hashs/names ---
	if (IsStolenName())
	{
		m_bIsHashThief = true;
		last_actions++;
		i_TotalActions++;

		g_eMuleApp.m_pdlgEmule->AddDebugLogLine( false, _T("%s: Client '%s' is known for cheating, ip %i.%i.%i.%i:%i, suspicious actions: %i (%i in total)!"), __FUNCTION__, m_strUserName,
		        (uint8)m_dwUserIP, (uint8)(m_dwUserIP >> 8), (uint8)(m_dwUserIP >> 16), (uint8)(m_dwUserIP >> 24), m_uUserPort, (i_TotalClientActions + last_actions), i_TotalActions );
	}

	if ((i_TotalClientActions + last_actions) >= 3 && g_eMuleApp.m_pGlobPrefs->GetMlDonkeyCM())
	{
		Ban(_T("AUTOMATED MESSAGE: You're being banned because your client is leeching!"), GetResString(IDS_BAN_HASHSTEAL));
	}

	if (last_actions != 0)
	{
		g_mapOffenseCounter[id] = i_TotalClientActions + last_actions;
		g_mapOffenseCounter[0] = i_TotalActions;
	}
//--- :xrmb ---

	m_eInfoPacketsReceived |= IP_EDONKEYPROTPACK;
	if (m_eInfoPacketsReceived == IP_BOTH)
		InfoPacketsReceived();

	return true;

	EMULE_CATCH

	return false;
}

bool CUpDownClient::IsStolenName() const
{
	EMULE_TRY

	if ( !m_strUserName.IsEmpty() && (
         //--- equals ---
	         m_strUserName == "pbwll" ||
	         m_strUserName == "unix user" ||
	         m_strUserName == "http://emule-element.tk" // EC 14.08.03 0-Upload Mod default nickname
         //--- begins with ---
	         || m_strUserName.Find("Odin") != -1
	         || m_strUserName.Find("$GAM3R$") != -1
	         || m_strUserName.Find("G@m3rs Edit") != -1
	         || m_strUserName.Find("G@m3rs Edit") != -1
	         || m_strUserName.Find( "[RAMMSTEIN" ) != -1
	         || m_strUserName.Find("[toXic]") != -1
	         || m_strUserName.Find("Leecha") != -1
	         || m_strUserName.Find("leecha") != -1
	         || m_strUserName.Find("eDevil") != -1
	         || m_strUserName.Find("darkmule") != -1
	         || m_strUserName.Find("DarkMule") != -1
	         || m_strUserName.Find("eVortex") != -1
	         || m_strUserName.Find("|eVorte|X|") != -1
	         || m_strUserName.Find("MISON") != -1
	         || m_strUserName.Find("Mison") != -1 ) )
	{
		return true;
	}

	EMULE_CATCH
	return false;
}

bool CUpDownClient::IsLeecherType() const
{
	EMULE_TRY

	if ( !m_strModVersion.IsEmpty() && (
	         m_strModVersion.Find("eVortex") != -1
	         || m_strModVersion.Find("Mison") != -1 ) )
	{
		return true;
	}

	EMULE_CATCH
	return false;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//v:- eklmn: do something if there is a m_pRequestSocket
void CUpDownClient::SendHelloPacket()
{
	EMULE_TRY

//	if IP is filtered, dont greet him but disconnect...
#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket != NULL)
	{
		SOCKADDR_IN	sockAddr;

		memset2(&sockAddr, 0, sizeof(sockAddr));

		uint32	dwSockAddrLen = sizeof(sockAddr);

		m_pRequestSocket->GetPeerName(reinterpret_cast<SOCKADDR*>(&sockAddr), reinterpret_cast<int*>(&dwSockAddrLen));

		CMemFile	data;
		uint8	hashsize = 16;

		data.Write(&hashsize, 1);
		SendHelloTypePacket(data);

		Packet	*packet = new Packet(&data);

		packet->m_eOpcode = OP_HELLO;
		g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(packet->m_dwSize);
		m_pRequestSocket->SendPacket(packet, true);
	}
#endif //OLD_SOCKETS_ENABLED
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::SendMuleInfoPacket(bool bAnswer)
{
	EMULE_TRY
#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket)
	{
		CMemFile data;
		//header of the info packet
		uint8 uClientVersion = CURRENT_VERSION_SHORT;
		data.Write(&uClientVersion, 1);
		uint8 uProtVersion = EMULE_PROTOCOL;
		data.Write(&uProtVersion, 1);
		uint32 dwTagCount = 10;
		data.Write(&dwTagCount, 4);
		//body of the info packet
		CEmuleTag tag1(ET_COMPRESSION, 1);
		tag1.WriteToFile(data);
		CEmuleTag tag2(ET_UDPVER, 3);	// netwolf: complete sources UDP
		tag2.WriteToFile(data);
		CEmuleTag tag3(ET_UDPPORT, g_eMuleApp.m_pGlobPrefs->GetUDPPort());
		tag3.WriteToFile(data);
		CEmuleTag tag4(ET_SOURCEEXCHANGE, 1);
		tag4.WriteToFile(data);
		CEmuleTag tag5(ET_COMMENTS, 1);
		tag5.WriteToFile(data);
		CEmuleTag tag6(ET_MOD_PLUS, CURRENT_PLUS_VERSION);	// To check for eMulePlus
		tag6.WriteToFile(data);
		CEmuleTag tag7(ET_EXTENDEDREQUEST, 2);
		tag7.WriteToFile(data);
		CEmuleTag tag8(ET_MOD_VERSION, _T(PLUS_VERSION_STR));
		tag8.WriteToFile(data);	 //More harmless than the other 2! :D
		CEmuleTag tag9(ET_L2HAC, FILEREASKTIME);	//<<-- enkeyDEV(th1) -L2HAC-
		tag9.WriteToFile(data);			//<<-- enkeyDEV(th1) -L2HAC-
		CEmuleTag tag10(ET_FEATURES, (uint32)(g_eMuleApp.m_pClientCreditList->CryptoAvailable() ? 3 : 0));
		tag10.WriteToFile(data);
		
		Packet* packet = new Packet(&data, OP_EMULEPROT);
		if (!bAnswer)
			packet->m_eOpcode = OP_EMULEINFO;
		else
			packet->m_eOpcode = OP_EMULEINFOANSWER;

		g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(packet->m_dwSize);
		m_pRequestSocket->SendPacket(packet, true, true);
	}
#endif //OLD_SOCKETS_ENABLED
	EMULE_CATCH
}

void CUpDownClient::ProcessMuleInfoPacket(char* pachPacket, uint32 nSize)
{
	EMULE_TRY
	CSafeMemFile data((BYTE*)pachPacket, nSize);
	m_dwCompatibleClient = 0;
	data.Read(&m_byteEmuleVersion, 1);
	if (m_byteEmuleVersion == 0x2B)
		m_byteEmuleVersion = 0x22;
	uint8 protversion;
	data.Read(&protversion, 1);

//implicitly supported options by older clients
	if (protversion == EMULE_PROTOCOL)
	{
	//in the future do not use version to guess about new features

		if (m_byteEmuleVersion < 0x25 && m_byteEmuleVersion > 0x22)
			m_byteUDPVer = 1;

		if (m_byteEmuleVersion < 0x25 && m_byteEmuleVersion > 0x21)
			m_byteSourceExchangeVer = 1;

		if (m_byteEmuleVersion == 0x24)
			m_byteAcceptCommentVer = 1;

	//	Shared directories are requested from eMule 0.28+ because eMule 0.27 has a bug in
	//	the OP_ASKSHAREDFILESDIR handler, which does not return the shared files for a
	//	directory which has a trailing backslash.
	//	MLdonkey currently does not support shared directories
	//	eMule+ supports shared directories with 1h (0x0108)
		if (m_byteEmuleVersion >= 0x28 && !m_bIsML && (GetPlusVersion() == 0 || GetPlusVersion() >= 0x0108))
			m_bSupportsAskSharedDirs = true;

	}
	else
	{
		return;
	}
	m_bEmuleProtocol = true;

	m_dwL2HACTime = 0;	//<<-- enkeyDEV(th1) -L2HAC-

	uint32 tagcount = 0;
	data.Read(&tagcount, 4);
	CEmuleTag* strTemptag = NULL;
	for (uint32 i = 0;i < tagcount; i++)
	{
		try
		{
		strTemptag = new CEmuleTag(data);
		if (strTemptag)
		{
			switch (strTemptag->GetSpecialTag())
			{
				case ET_COMPRESSION:
				{
					m_byteDataCompVer = strTemptag->GetIntValue();
					break;
				}
				case ET_UDPPORT:
				{
					m_uUDPPort = strTemptag->GetIntValue();
					break;
				}
				case ET_UDPVER:
				{
					m_byteUDPVer = strTemptag->GetIntValue();
					break;
				}
				case ET_SOURCEEXCHANGE:
				{
					m_byteSourceExchangeVer = strTemptag->GetIntValue();
					break;
				}
				case ET_COMMENTS:
				{
					m_byteAcceptCommentVer = strTemptag->GetIntValue();
					break;
				}
				case ET_EXTENDEDREQUEST:
				{
					m_byteExtendedRequestsVer = strTemptag->GetIntValue();
					break ;
				}
				case ET_COMPATIBLECLIENT:
				{
					m_dwCompatibleClient = strTemptag->GetIntValue();
					break;
				}
				case ET_MOD_FEATURESET:
				{
					break;
				}
				case ET_MOD_VERSION:
				{
					m_strModVersion = strTemptag->GetStringValue();
					break;
				}
				case ET_MOD_PROTOCOL:
				{
					m_strModExtended = strTemptag->GetStringValue();
					break;
				}
				case ET_MOD_PLUS:
				{
					m_dwDataPlusVers = strTemptag->GetIntValue();
					break ;
				}
				case ET_MOD_TAROD:
				{
					m_byteDataTarodVer = strTemptag->GetIntValue();
					break;
				}
				case ET_MOD_BOWLFISH:
				case ET_MOD_TAROD_VERSION:
				case ET_MOD_FUSION:
				case ET_MOD_FUSION_VERSION:
				case ET_MOD_Morph:
				case ET_MOD_Morph_VERSION:
				case ET_MOD_MorTillo:
				case ET_MOD_MorTillo_VERSION:
				case ET_MOD_LSD:
				case ET_MOD_LSD_VERSION:
				case ET_MOD_LOVELACE_VERSION:
				case ET_MOD_OXY:
				case ET_MOD_UNKNOWNx12:
				case ET_MOD_UNKNOWNx13:
				case ET_MOD_UNKNOWNx14:
				case ET_MOD_UNKNOWNx17:
				case ET_MOD_UNKNOWNx2F:
				case ET_MOD_UNKNOWNx30:
				case ET_MOD_UNKNOWNx36:
				case ET_MOD_UNKNOWNx3C:
				case ET_MOD_UNKNOWNx41:
				case ET_MOD_UNKNOWNx42:
				case ET_MOD_UNKNOWNx43:
				case ET_MOD_UNKNOWNx50:
				case ET_MOD_UNKNOWNx59:
				case ET_MOD_UNKNOWNx5B:
				case ET_MOD_UNKNOWNx5C:
				case ET_MOD_UNKNOWNx60:
				case ET_MOD_UNKNOWNx64:
				case ET_MOD_UNKNOWNx76:
				case ET_MOD_UNKNOWNx84:
				case ET_MOD_UNKNOWNx85:
				case ET_MOD_UNKNOWNx86:
				case ET_MOD_UNKNOWNx91:
				case ET_MOD_UNKNOWNx92:
				case ET_MOD_UNKNOWNx93:
				case ET_MOD_UNKNOWNxA0:
				case ET_MOD_UNKNOWNxA1:
				case ET_MOD_UNKNOWNxA6:
				case ET_MOD_UNKNOWNxB1:
				case ET_MOD_UNKNOWNxB4:
				case ET_MOD_UNKNOWNxC8:
				case ET_MOD_UNKNOWNxC9:
				case ET_MOD_UNKNOWNxDA:
				{
					break;
				}
				case ET_L2HAC:     	// START enkeyDEV(th1) -L2HAC-
				{
					m_dwL2HACTime = strTemptag->GetIntValue();
					break;		// END enkeyDEV(th1) -L2HAC-
				}
				case ET_INCOMPLETEPARTS:      // enkeyDEV(th1) -ICS-
				{
					break;
				}
				case ET_FEATURES:     	// secure credits (official 0.29b)
				{
				//	Bits 31- 8: 0 - reserved
				//	Bit   7- 0: secure identification
					m_byteSupportSecIdent = strTemptag->GetIntValue() & 3;
					break;
				}
				default:
				{
					if (!strTemptag->GetStringValue().IsEmpty())
					{
//						CString buffer = strTemptag->GetStringValue();
//						TagToDebugLogLine(_T("Process: Unknown eMule tag"), buffer, buffer.GetLength(), strTemptag->GetSpecialTag());	// DbT:Logging
					}
//					AddDebugLogLine( false, _T("%s: Process: Unknown eMule tag: 0x%x, Intvalue: %d Stringvalue: %s User: %s(%s)"),
//					                 __FUNCTION__, strTemptag->GetSpecialTag(), strTemptag->GetIntValue(), strTemptag->GetStringValue(), m_strUserName, GetClientNameAndVersionString(this) );
				}
			}
			delete strTemptag;
			strTemptag = NULL;
		}
	}
		catch (CException* error)
		{
			error->Delete();
			safe_delete(strTemptag);
		}
	}

//	START enkeyDEV(th1) -L2HAC- Enable every emule anyway and disable bad clients
	if (!m_dwL2HACTime)
		m_dwL2HACTime = L2HAC_DEFAULT_EMULE;
	if (m_dwL2HACTime < L2HAC_MIN_TIME || m_dwL2HACTime > L2HAC_MAX_TIME)
		m_dwL2HACTime = 0;
//	END enkeyDEV(th1) -L2HAC-

	if (m_byteDataCompVer == 0)
	{
		m_byteSourceExchangeVer = 0;
		m_byteExtendedRequestsVer = 0;
		m_byteAcceptCommentVer = 0;
		m_uUDPPort = 0;
		m_dwL2HACTime = 0;	//<<-- enkeyDEV(th1) -L2HAC-
	}
//ReGetClientSoft();	// 9/5/2003 [Moosetea] Official client, this messes the stats up, creates lots of invalid edonkey clients
	m_eInfoPacketsReceived |= IP_EMULEPROTPACK;
	if (m_eInfoPacketsReceived == IP_BOTH)
		InfoPacketsReceived();

//	emuleplus supports 'complete sources' with versions 1f and 1g (force ET_EXTENDEDREQUEST v2 for backward compatibility)
	if ((GetPlusVersion() >= 0x0106) && (GetPlusVersion() < 0x0108) && (GetExtendedRequestsVersion() == 1))
		m_byteExtendedRequestsVer = 2;

	EMULE_CATCH
}

void CUpDownClient::SendHelloAnswer()
{
	EMULE_TRY
#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket)
	{
		CMemFile data;
		SendHelloTypePacket(data);
		Packet* packet = new Packet(&data);
		packet->m_eOpcode = OP_HELLOANSWER;
		g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(packet->m_dwSize);
		m_pRequestSocket->SendPacket(packet, true);
	}
#endif //OLD_SOCKETS_ENABLED
	EMULE_CATCH
}

void CUpDownClient::SendHelloTypePacket(CMemFile& data)
{
	EMULE_TRY
//	By Maverick
//	Emulate eDonkey or MlDonkey in case of a connection to a MlDonkey
//	This patch is introduced to conteract the MlDonkey's politics against
//	eMule. (eMules can only occupy 1/3 of the upload queue of a MlDonkey)
	uchar hash[16];
	md4cpy(hash, g_eMuleApp.m_pGlobPrefs->GetUserHash());
//	Checking for MLDonkey does not help anymore since they have removed this feature so
//	we emulate now an eDonkey to all except eMule. Note do not loose a word about this
//	in any forum. Otherwise we have to adapt to them again.
//	Does not help anymore either mlDonkey uses eMule type userhashes
//	Furthermore the servers have a problem with this feature so I had to go back to
//	emulating only with MlDonkey
	if (GetClientSoft() == SO_MLDONKEY && g_eMuleApp.m_pGlobPrefs->GetMlDonkeyCM())		//Cax2 only if enabled
	{
		while ((hash[5] == 14) && (hash[14] = 111))
		{
			uint8	random = rand();
			memcpy2(&hash[5], &random, 1);
			random = rand();
			memcpy2(&hash[14], &random, 1);
		}
	}
	data.Write(hash, 16);
//	END Patch Maverick
#ifdef OLD_SOCKETS_ENABLED

	uint32 clientid = g_eMuleApp.m_pServerConnect->GetClientID();
	data.Write(&clientid, 4);
#endif //OLD_SOCKETS_ENABLED

	uint16 nPort = g_eMuleApp.m_pGlobPrefs->GetListenPort();  //Maverick
	data.Write(&nPort, 2);
	uint32 tagcount = 2;
	data.Write(&tagcount, 4);
	CClientTag* tag = new CClientTag(CT_NAME, g_eMuleApp.m_pGlobPrefs->GetUserNick().GetBuffer());
	tag->WriteToFile(data);
	delete tag;
	tag = new CClientTag(CT_VERSION, EDONKEYVERSION);
	tag->WriteToFile(data);
	delete tag;
//	tag = new CTag(CT_PORT,nPort); //Maverick
//	tag->WriteToFile(data);
//	delete tag;
	uint32 dwIP;
#ifdef OLD_SOCKETS_ENABLED

	if (g_eMuleApp.m_pServerConnect->IsConnected())
	{
		dwIP = g_eMuleApp.m_pServerConnect->GetCurrentServer()->GetIP();
		nPort = g_eMuleApp.m_pServerConnect->GetCurrentServer()->GetPort();
	}
	else
#endif //OLD_SOCKETS_ENABLED

	{
		nPort = 0;
		dwIP = 0;
	}
	data.Write(&dwIP, 4);
	data.Write(&nPort, 2);
	EMULE_CATCH
}

void CUpDownClient::ProcessMuleCommentPacket(char* pachPacket, uint32 nSize)
{
	EMULE_TRY
	if ((m_pReqPartFile != NULL) && (nSize > 2))
	{
		CSafeMemFile data((BYTE*)pachPacket, nSize);
		int length;
		data.Read(&m_eRating, sizeof(m_eRating));
		data.Read(&length, sizeof(length));
		if (length > 50)
			length = 50;
		if (length > 0)
		{
			data.Read(m_strComment.GetBuffer(length + 1), length);
			m_strComment.ReleaseBuffer(length);
		//(SyruS) netwolf commentfilter
			CString strList(g_eMuleApp.m_pGlobPrefs->GetCommentFilter().MakeLower());
			if (!strList.IsEmpty())
			{
				CString lowComment(m_strComment);	//make a copy of casesensitive comment
				lowComment.MakeLower();				//make copy only lowercase to search in
				int curPos = 0;
				CString resToken(strList.Tokenize(_T("|"), curPos));
				while (!resToken.IsEmpty())
				{
					if (lowComment.Find(resToken) > -1)
					{
						AddDebugLogLine(false, _T("%s: Description for file '%s' filtered: %s"), __FUNCTION__, m_strClientFilename, m_strComment);
						m_strComment = "";
						m_eRating = PF_RATING_NONE;
						break;
					}
					resToken = strList.Tokenize(_T("|"), curPos);
				}
			}
			if (!m_strComment.IsEmpty())
			{
				m_pReqPartFile->SetHasComment(true);
				AddDebugLogLine(false, _T("%s: Description for file '%s' received: %s"), __FUNCTION__, m_strClientFilename, m_strComment);
			}
		}
		if (m_eRating != PF_RATING_NONE)
		{
			m_pReqPartFile->SetHasRating(true);
			AddDebugLogLine(false, _T("%s: Rating for file '%s' received: %s"), __FUNCTION__, m_strClientFilename, ::GetRatingString(m_eRating));
		}
		if ((!m_strComment.IsEmpty()) || (m_eRating != PF_RATING_NONE))	// #zegzav:pastcomment
			m_pReqPartFile->RemovePastComment(this, false);
	}
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CUpDownClient::Disconnected(bool bRetryConnection /*=true*/)
{
	bool	bDeleted = false;

	EMULE_TRY

	if (g_eMuleApp.m_pClientList->IsValidClient(this))
	{
	//	If the client is uploading, remove it from the upload queue.
		if (GetUploadState() == US_UPLOADING)
			g_eMuleApp.m_pUploadQueue->RemoveFromUploadQueue(this, ETS_DISCONNECT);
	//	If the client is downloading, leave it on the queue but stop it from downloading
		if (GetDownloadState() == DS_DOWNLOADING)
			SetDownloadState(DS_ONQUEUE);
	//	If the client is requesting a hashset...
		if ((GetDownloadState() == DS_REQHASHSET) && m_pReqPartFile != NULL)
			m_pReqPartFile->m_bHashSetNeeded = true;
		ASSERT(g_eMuleApp.m_pClientList->IsValidClient(this));
	//
	//	Check if this client is needed in any way, if not delete it
	//
		bool bDelete = true;

		switch (m_eUploadState)
		{
			case US_ONUPLOADQUEUE:
			{
				bDelete = false;
			}
		};
		switch (m_eDownloadState)
		{
			case DS_ONQUEUE:
			case DS_TOOMANYCONNS:
			case DS_NONEEDEDPARTS:
			case DS_LOWTOLOWIP:
			{
				bDelete = false;
			}
		};

		switch (m_eUploadState)
		{
			case US_CONNECTING:
			case US_WAITCALLBACK:
			case US_ERROR:
			{
				bDelete = true;
			}
		};
		switch (m_eDownloadState)
		{
			case DS_CONNECTING:
			{
				m_byteFailedCount++;
				if (bRetryConnection && m_byteFailedCount <= 2)
				{
					TryToConnect();
					return bDeleted;
				}
			}
			case DS_WAITCALLBACK:
			case DS_ERROR:
			{
				bDelete = true;
			}
		};
#if KEEP_BANNED_CLIENTS
	//	SyruS no deletion of banned client //this works...
		if (m_bBanned)
		{
			bDelete = false;
			if (!g_eMuleApp.m_pGlobPrefs->GetCMNotLog())
				AddDebugLogLine(false, _T("%s: Keeping banned client '%s' after disconnect"), __FUNCTION__, GetUserName());
		}
#endif
		if (GetChatState() != MS_NONE)
		{
		//	SyruS (0.29c)
			bDelete = false;
			g_eMuleApp.m_pdlgEmule->m_wndChat.chatselector.ConnectingResult(this, false);
		}
#ifdef OLD_SOCKETS_ENABLED
		g_eMuleApp.m_pListenSocket->DeleteSocket(m_pRequestSocket);
#endif //OLD_SOCKETS_ENABLED

		if (m_iFileListRequested)
		{
			AddDebugLogLine(false, _T("%s: ") + ::GetResString(IDS_SHAREDFILES_FAILED), __FUNCTION__, GetUserName());
			m_iFileListRequested = m_iFileListRequestedSave = 0;
		}
		if (m_pFriend)
		{
			g_eMuleApp.m_pFriendList->RefreshFriend(m_pFriend);
		}

		if (bDelete)
		{
			delete this;
			bDeleted = true;
		}
		else
		{
			g_eMuleApp.m_pClientList->UpdateClient(this);
			m_dwEnteredConnectedState = 0;
		}
	}
	else
	{
		AddDebugLogLine(false, _T("%s: Invalid client."), __FUNCTION__);
	}

	EMULE_CATCH

	return bDeleted;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CUpDownClient::TryToConnect(bool bIgnoreMaxCon)
{
	EMULE_TRY
#ifdef OLD_SOCKETS_ENABLED
	if (g_eMuleApp.m_pListenSocket->TooManySockets() && !bIgnoreMaxCon && !(m_pRequestSocket && m_pRequestSocket->IsConnected()))
	{
		Disconnected();
		return false;
	}
//	BavarianSnail - filter LowIDs separately from HighIDs
	if (m_dwUserIP > 0)
	{
	//	case 1: it's a Client with known IP, always test m_dwUserIP instead of m_dwUserID
		if (g_eMuleApp.m_pIPFilter->IsFiltered(m_dwUserIP))
		{
			AddDebugLogLine(false, _T("%s: Filtered (don't connect): %s %s"), __FUNCTION__, GetFullIP(), g_eMuleApp.m_pIPFilter->GetLastHit());
		//	Disconnect and don't retry.
			Disconnected(false);
			g_eMuleApp.stat_filteredclients++;
			return false;
		}
	}
	else
	{
		if ((unsigned)m_dwUserID > 16777215)
		{
		//	case 2: it's HighID with m_dwUserIP empty, test m_dwUserID instead
			if (g_eMuleApp.m_pIPFilter->IsFiltered(m_dwUserID))
			{
				AddDebugLogLine(false, _T("%s: Filtered (don't connect): %s %s"), __FUNCTION__, GetFullIP(), g_eMuleApp.m_pIPFilter->GetLastHit());
				Disconnected(false);
				g_eMuleApp.stat_filteredclients++;
				return false;
			}
		}
		else
		{
		//	case 3: it's a LowID without known IP, cannot test yet
		//	AddDebugLogLine(false,_T("%s: Cannot filter LowID (no IP yet): m_uUserID %u m_dwUserIP %u GetFullIP %s"), __FUNCTION__, m_dwUserID,m_dwUserIP,GetFullIP());
		}
	}
//	-BavarianSnail
	if ((g_eMuleApp.m_pServerConnect->GetClientID() < 0x1000000) && HasLowID())
	{
		if (GetDownloadState() == DS_CONNECTING)
			SetDownloadState(DS_LOWTOLOWIP);
		else if (GetDownloadState() == DS_REQHASHSET)
		{
			SetDownloadState(DS_ONQUEUE);
			m_pReqPartFile->m_bHashSetNeeded = true;
		}
		if (GetUploadState() == US_CONNECTING)
			Disconnected(false);
		//Never connect lowID to lowID
		return false;
	}
#endif //OLD_SOCKETS_ENABLED

#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket == NULL)
	{
		m_pRequestSocket = new CClientReqSocket(g_eMuleApp.m_pGlobPrefs, this);
		if (!m_pRequestSocket->Create())
		{
			m_pRequestSocket->Safe_Delete();
			return true;
		}
	}
	else if (!m_pRequestSocket->IsConnected())
	{
		m_pRequestSocket->Safe_Delete();
		m_pRequestSocket = new CClientReqSocket(g_eMuleApp.m_pGlobPrefs, this);
		if (!m_pRequestSocket->Create())
		{
			m_pRequestSocket->Safe_Delete();
			return true;
		}
	}
	else
	{
		ConnectionEstablished();
		return true;
	}
#endif //OLD_SOCKETS_ENABLED
//	MOD Note: Do not change this part - Merkur
	if (HasLowID())
	{
		if (GetDownloadState() == DS_CONNECTING)
			SetDownloadState(DS_WAITCALLBACK);
		if (GetUploadState() == US_CONNECTING)
		{
			Disconnected();
			return false;
		}

#ifdef OLD_SOCKETS_ENABLED
		if (g_eMuleApp.m_pServerConnect->IsLocalServer(m_dwServerIP, m_uServerPort))
		{
			Packet * packet = new Packet(OP_CALLBACKREQUEST, 4);
			memcpy2(packet->m_pcBuffer, &m_dwUserID, 4);
			g_eMuleApp.m_pUploadQueue->AddUpDataOverheadServer(packet->m_dwSize);
			g_eMuleApp.m_pServerConnect->SendPacket(packet);
		}
		else
		{
			if (GetUploadState() == US_NONE && (!GetRemoteQueueRank() || m_bReaskPending))
			{
				g_eMuleApp.m_pDownloadQueue->RemoveSource(this);
				Disconnected();
				return false;
			}
			else
			{
				if (GetDownloadState() == DS_WAITCALLBACK)
				{
					m_bReaskPending = true;
					SetDownloadState(DS_ONQUEUE);
				}
			}
		}
#endif //OLD_SOCKETS_ENABLED

	}
//	MOD Note - end
	else
	{
#ifdef OLD_SOCKETS_ENABLED
		m_pRequestSocket->Connect(GetFullIP(), GetUserPort());
#endif //OLD_SOCKETS_ENABLED

		SendHelloPacket();
	}
	return true;

	EMULE_CATCH
	return false;
}

void CUpDownClient::ConnectionEstablished()
{
	EMULE_TRY
	m_byteFailedCount = 0;
//	ok we have a connection, lets see if we want anything from this client
	if (GetChatState() == MS_CONNECTING)
		g_eMuleApp.m_pdlgEmule->m_wndChat.chatselector.ConnectingResult(this, true);
	switch (GetDownloadState())
	{
		case DS_CONNECTING:
		case DS_WAITCALLBACK:
		m_bReaskPending = false;
		SetDownloadState(DS_CONNECTED);
		SendFileRequest();
	}
	if (m_bReaskPending)
	{
		m_bReaskPending = false;
		if (GetDownloadState() != DS_NONE && GetDownloadState() != DS_DOWNLOADING)
		{
			SetDownloadState(DS_CONNECTED);
			SendFileRequest();
		}
	}
	switch (GetUploadState())
	{
		case US_CONNECTING:
		case US_WAITCALLBACK:
		if (g_eMuleApp.m_pUploadQueue->IsDownloading(this))
		{
			SetUploadState(US_UPLOADING);
			Packet* packet = new Packet(OP_ACCEPTUPLOADREQ);
			g_eMuleApp.m_pUploadQueue->AddUpDataOverheadFileRequest(packet->m_dwSize);
#ifdef OLD_SOCKETS_ENABLED

			m_pRequestSocket->SendPacket(packet, true);
#endif //OLD_SOCKETS_ENABLED

			SetLastGotULData();	//eklmn: set Upload Timer
		}
	}
	if (m_iFileListRequested == 1)
	{
		Packet * packet = new Packet(m_bSupportsAskSharedDirs ? OP_ASKSHAREDDIRS : OP_ASKSHAREDFILES);
		g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(packet->m_dwSize);
#ifdef OLD_SOCKETS_ENABLED

		m_pRequestSocket->SendPacket(packet, true, true);
#endif //OLD_SOCKETS_ENABLED

	}
	EMULE_CATCH
}

int CUpDownClient::GetHashType()
{
	if (m_userHash[5] == 13 && m_userHash[14] == 110)
		return SO_OLDEMULE;
	else if (m_userHash[5] == 14 && m_userHash[14] == 111)
		return SO_EMULE;
	else if (m_userHash[5] == 'M' && m_userHash[14] == 'L')
		return SO_MLDONKEY;
	else
		return SO_UNKNOWN;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::ReGetClientSoft()
{
	EMULE_TRY

//	If this client hasn't been contacted, it is SO_UNKNOWN
	if (m_strUserName.IsEmpty())
	{
		m_eClientSoft = SO_UNKNOWN;
		return;
	}

//	What is this client's hash type
	int		iHashType = GetHashType();

	switch (iHashType)
	{
	//	If the client is an old emule...
		case SO_OLDEMULE:
		{
			m_eClientSoft = SO_OLDEMULE;
			break;
		}
	//	If the client is an Ml donkey...
		case SO_MLDONKEY:
		{
			m_eClientSoft = SO_MLDONKEY;
			break;
		}
	//	If the client is an Emule compatible client...
		case SO_EMULE:
		{
			if (m_byteEmuleVersion != 0x99)
			{
				CString		strTemp;

				strTemp.Format("%02X", m_byteEmuleVersion);
				m_dwClientVersion = _tstoi(strTemp.GetBuffer()) * 10;
			}
			switch (m_dwCompatibleClient)
			{
				case 0:
				case 3: // unknown
				case 10: // unknown
				case 20: // unknown
				{
					m_eClientSoft = SO_EMULE;
					break;
				}
				case 1:
				{
					m_eClientSoft = SO_CDONKEY;
					break;
				}
				case 2:
				{
					m_eClientSoft = SO_LMULE;
					break;
				}
				case 4:
				{
					m_eClientSoft = SO_SHAREAZA;
					break;
				}
				default:
				{
					if (m_bIsML)
					{
						m_eClientSoft = SO_MLDONKEY;
					}
					else if (m_bIsHybrid)
					{
						m_eClientSoft = SO_EDONKEYHYBRID;
					}
					else
					{
						m_eClientSoft = SO_EMULE;
						AddDebugLogLine(false, "%s: New Compatible ClientSoft ET_COMPATIBLECLIENT = %i client will be listed as an emule ", __FUNCTION__, m_dwCompatibleClient);
					}
				}
			} // end: switch m_dwCompatibleClient
			break;
		}
		default:
		{
		//	If the client is an Ml donkey
			if (m_bIsML)
				m_eClientSoft = SO_MLDONKEY;
		//	We're left with donkeys and Hybrids
			if (m_bIsHybrid)
				m_eClientSoft = SO_EDONKEYHYBRID;
			else
				m_eClientSoft = SO_EDONKEY;
		}
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CUpDownClient::RequestSharedFileList()
{
	EMULE_TRY
	if (m_iFileListRequested == 0)
	{
		AddDebugLogLine(true, IDS_SHAREDFILES_REQUEST, GetUserName());
		m_iFileListRequested = m_iFileListRequestedSave = 1;
		TryToConnect(true);
	}
	EMULE_CATCH
}

void CUpDownClient::ProcessSharedFileList(char* pachPacket, uint32 nSize, LPCTSTR pszDirectory)
{
	EMULE_TRY
	if (m_iFileListRequested > 0)
	{
		bool bFirstDir = (m_iFileListRequested == m_iFileListRequestedSave);
		m_iFileListRequested--;
		g_eMuleApp.m_pSearchList->ProcessSearchAnswer(pachPacket, nSize, this, pszDirectory, bFirstDir);
	}
	EMULE_CATCH
}

CString CUpDownClient::GetUploadFileInfo()
{
	if (this == NULL)
		return _T("");
	CString sRet;

//	build info text and display it
	sRet.Format(GetResString(IDS_USERINFO), GetUserName(), GetUserID());
	CKnownFile* file = g_eMuleApp.m_pSharedFilesList->GetFileByID(this->m_reqFileHash);
	if (file)
	{
		sRet += GetResString(IDS_SF_REQUESTED) + CString(file->GetFileName()) + _T("\n");
		CString stat;
		stat.Format( GetResString(IDS_FILESTATS_SESSION) + GetResString(IDS_FILESTATS_TOTAL),
		             file->statistic.GetAccepts(), file->statistic.GetRequests(), CastItoXBytes(file->statistic.GetTransferred()),
		             file->statistic.GetAllTimeAccepts(), file->statistic.GetAllTimeRequests(), CastItoXBytes(file->statistic.GetAllTimeTransferred()) );
		sRet += stat;
	}
	else
	{
		sRet += GetResString(IDS_REQ_UNKNOWNFILE);
	}
	return sRet;

	return _T("");
}

void CUpDownClient::SetUserHash(uchar* m_achstrTempUserHash)
{
	if (m_achstrTempUserHash == NULL)
	{
		md4clr(m_userHash);
		return;
	}
	md4cpy(m_userHash, m_achstrTempUserHash);
}

//BEGIN Improved Tooltips
CString CUpDownClient::GetUploadFileInfo4Tooltips()
{
	EMULE_TRY
	if (this == NULL)
		return _T("");
	CString sRet;

//	build info text and display it
	sRet.Format(GetResString(IDS_TT_USERINFO), GetUserName(), GetUserID());
	CKnownFile* file = g_eMuleApp.m_pSharedFilesList->GetFileByID(this->m_reqFileHash);
	if (file)
	{
		CString sFileName;
		sFileName.Format(GetResString(IDS_TT_REQUESTED), CString(file->GetFileName()));

		CString stat;
		stat.Format( sFileName + GetResString(IDS_TT_FILESTATS_SESSION) + GetResString(IDS_TT_FILESTATS_TOTAL),
		             file->statistic.GetAccepts(), file->statistic.GetRequests(), CastItoXBytes(file->statistic.GetTransferred()),
		             file->statistic.GetAllTimeAccepts(), file->statistic.GetAllTimeRequests(), CastItoXBytes(file->statistic.GetAllTimeTransferred()) );
		sRet += stat;
	}
	else
	{
		sRet += GetResString(IDS_REQ_UNKNOWNFILE);
	}
	return sRet;

	EMULE_CATCH

	return _T("");
}
//END Improved Tooltips

void CUpDownClient::SendPublicKeyPacket()
{
#ifdef DEBUG_SHOW_SECUREID
	DEBUG_ONLY(g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Sending public key to '%s'", __FUNCTION__, GetUserName()));
#endif
//	send our public key to the client who requested it
#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket == NULL || m_pCredits == NULL || m_eSecureIdentState != IS_KEYANDSIGNEEDED)
	{
		ASSERT (false);
		return;
	}
#endif //OLD_SOCKETS_ENABLED
	if (!g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		return;

	Packet* packet = new Packet(OP_PUBLICKEY, g_eMuleApp.m_pClientCreditList->GetPubKeyLen() + 1, OP_EMULEPROT);
	g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(packet->m_dwSize);
	memcpy2(packet->m_pcBuffer + 1, g_eMuleApp.m_pClientCreditList->GetPublicKey(), g_eMuleApp.m_pClientCreditList->GetPubKeyLen());
	packet->m_pcBuffer[0] = g_eMuleApp.m_pClientCreditList->GetPubKeyLen();
#ifdef OLD_SOCKETS_ENABLED

	m_pRequestSocket->SendPacket(packet, true, true);
#endif //OLD_SOCKETS_ENABLED

	m_eSecureIdentState = IS_SIGNATURENEEDED;
}

void CUpDownClient::SendSignaturePacket()
{
//	signate the public key of this client and send it
#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket == NULL || m_pCredits == NULL || m_eSecureIdentState == 0)
	{
		ASSERT (false);
		return;
	}
#endif //OLD_SOCKETS_ENABLED

	if (!g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		return;
	if (m_pCredits->GetSecIDKeyLen() == 0)
		return; // We don't have his public key yet, will be back here later
#ifdef DEBUG_SHOW_SECUREID

	DEBUG_ONLY(g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Sending signature key to '%s'", __FUNCTION__, GetUserName()));
#endif
//	do we have a challenge value received (actually we should if we are in this function)
	if (m_pCredits->m_dwCryptRndChallengeFrom == 0)
	{
		g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Want to send signature but challenge value is invalid ('%s')", __FUNCTION__, GetUserName());
		return;
	}
//	v2
//	we will use v1 as default, except if only v2 is supported
	bool bUseV2;
	if ((m_byteSupportSecIdent & 1) == 1)
		bUseV2 = false;
	else
		bUseV2 = true;

	uint8 byChaIPKind = 0;
	uint32 ChallengeIP = 0;
#ifdef OLD_SOCKETS_ENABLED

	if (bUseV2)
	{
		if (g_eMuleApp.m_pServerConnect->GetClientID() == 0 || g_eMuleApp.m_pServerConnect->IsLowID())
		{
		//	we cannot do not know for sure our public ip, so use the remote clients one
			ChallengeIP = GetIP();
			byChaIPKind = CRYPT_CIP_REMOTECLIENT;
		}
		else
		{
			ChallengeIP = g_eMuleApp.m_pServerConnect->GetClientID();
			byChaIPKind = CRYPT_CIP_LOCALCLIENT;
		}
	}
//end v2
#endif //OLD_SOCKETS_ENABLED
	uchar achBuffer[250];
	uint8 siglen = g_eMuleApp.m_pClientCreditList->CreateSignature(m_pCredits, achBuffer, 250, ChallengeIP, byChaIPKind);
	if (siglen == 0)
	{
		ASSERT (false);
		return;
	}
	Packet* packet = new Packet(OP_SIGNATURE, siglen + 1 + ((bUseV2) ? 1 : 0), OP_EMULEPROT);
	g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(packet->m_dwSize);
	memcpy2(packet->m_pcBuffer + 1, achBuffer, siglen);
	packet->m_pcBuffer[0] = siglen;
	if (bUseV2)
		packet->m_pcBuffer[1 + siglen] = byChaIPKind;
#ifdef OLD_SOCKETS_ENABLED

	m_pRequestSocket->SendPacket(packet, true, true);
#endif //OLD_SOCKETS_ENABLED

	m_eSecureIdentState = IS_ALLREQUESTSSEND;
}

void CUpDownClient::ProcessPublicKeyPacket(uchar* pachPacket, uint32 nSize)
{
//	g_eMuleApp.m_pClientList->AddTrackClient(this);
#ifdef DEBUG_SHOW_SECUREID
	DEBUG_ONLY(g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Receiving public key from '%s'", __FUNCTION__, GetUserName()));
#endif

#ifdef OLD_SOCKETS_ENABLED
	if ( m_pRequestSocket == NULL || m_pCredits == NULL || pachPacket[0] != nSize - 1
	     || nSize == 0 || nSize > 250 )
	{
		ASSERT (false);
		return;
	}
#endif //OLD_SOCKETS_ENABLED
	if (!g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		return;
//	the function will handle everything (mulitple key etc)
	if (m_pCredits->SetSecureIdent(pachPacket + 1, pachPacket[0]))
	{
	//	if this client wants a signature, now we can send him one
		if (m_eSecureIdentState == IS_SIGNATURENEEDED)
		{
			SendSignaturePacket();
		}
		else if (m_eSecureIdentState == IS_KEYANDSIGNEEDED)
		{
		//	something is wrong
			g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Invalid State error: IS_KEYANDSIGNEEDED in ProcessPublicKeyPacket", __FUNCTION__);
		}
	}
	else
	{
		g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Failed to use new received public key", __FUNCTION__);
	}
}

void CUpDownClient::ProcessSignaturePacket(uchar* pachPacket, uint32 nSize)
{
#ifdef DEBUG_SHOW_SECUREID
	DEBUG_ONLY(g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Receiving signature from '%s'", __FUNCTION__, GetUserName()));
#endif
//	here we spread the good guys from the bad ones ;)

#ifdef OLD_SOCKETS_ENABLED
	if (m_pRequestSocket == NULL || m_pCredits == NULL || nSize == 0 || nSize > 250)
	{
		ASSERT (false);
		return;
	}
#endif //OLD_SOCKETS_ENABLED

	uint8 byChaIPKind;
	if (pachPacket[0] == nSize - 1)
		byChaIPKind = 0;
	else if (pachPacket[0] == nSize - 2 && (m_byteSupportSecIdent & 2) > 0) //v2
		byChaIPKind = pachPacket[nSize - 1];
	else
	{
		ASSERT (false);
		return;
	}

	if (!g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		return;

//	we accept only one signature per IP, to avoid floods which need a lot cpu time for cryptfunctions
	if (m_dwLastSignatureIP == GetIP())
	{
		g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Received multiple signatures from one client", __FUNCTION__);
		return;
	}
//	also make sure this client has a public key
	if (m_pCredits->GetSecIDKeyLen() == 0)
	{
		g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Received signature for client without public key", __FUNCTION__);
		return;
	}
//	and one more check: did we ask for a signature and sent a challange packet?
	if (m_pCredits->m_dwCryptRndChallengeFor == 0)
	{
		g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Received signature for client with invalid challenge value ('%s')", __FUNCTION__, GetUserName());
		return;
	}

	if (g_eMuleApp.m_pClientCreditList->VerifyIdent(m_pCredits, pachPacket + 1, pachPacket[0], GetIP(), byChaIPKind))
	{
	//	result is saved in function abouve
	//g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "'%s' has passed the secure identification, V2 State: %i", GetUserName(), byChaIPKind);
	}
#ifdef DEBUG_SHOW_SECUREID
	else
		g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: '%s' has failed the secure identification, V2 State: %i", __FUNCTION__, GetUserName(), byChaIPKind);
#endif

	m_dwLastSignatureIP = GetIP();
}

void CUpDownClient::SendSecIdentStatePacket()
{
//	check if we need public key and signature
	uint8 nValue = 0;
	if (m_pCredits)
	{
		if (g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		{
			if (m_pCredits->GetSecIDKeyLen() == 0)
				nValue = IS_KEYANDSIGNEEDED;
			else if (m_dwLastSignatureIP != GetIP())
				nValue = IS_SIGNATURENEEDED;
		}
		if (nValue == 0)
		{
#ifdef DEBUG_SHOW_SECUREID
			DEBUG_ONLY(g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Not sending SecIdentState Packet, because State is Zero", __FUNCTION__));
#endif

			return;
		}
	//	crypt: send random data to sign
		uint32 dwRandom = rand() + 1;
		m_pCredits->m_dwCryptRndChallengeFor = dwRandom;
#ifdef DEBUG_SHOW_SECUREID

		DEBUG_ONLY(g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Sending SecIdentState Packet, state: %i (to '%s')", __FUNCTION__, nValue, GetUserName()));
#endif

		Packet* packet = new Packet(OP_SECIDENTSTATE, 5, OP_EMULEPROT);
		g_eMuleApp.m_pUploadQueue->AddUpDataOverheadOther(packet->m_dwSize);
		packet->m_pcBuffer[0] = nValue;
		memcpy2(packet->m_pcBuffer + 1, &dwRandom, sizeof(dwRandom));
#ifdef OLD_SOCKETS_ENABLED

		m_pRequestSocket->SendPacket(packet, true, true);
#endif //OLD_SOCKETS_ENABLED

	}
}

void CUpDownClient::ProcessSecIdentStatePacket(uchar* pachPacket, uint32 nSize)
{
	if (nSize != 5)
		return;
	if (!m_pCredits)
		return;

	switch (pachPacket[0])
	{
		case 0:
		m_eSecureIdentState = IS_UNAVAILABLE;
		break;
		case 1:
		m_eSecureIdentState = IS_SIGNATURENEEDED;
		break;
		case 2:
		m_eSecureIdentState = IS_KEYANDSIGNEEDED;
		break;
	}
	uint32 dwRandom;
	memcpy2(&dwRandom, pachPacket + 1, 4);
	m_pCredits->m_dwCryptRndChallengeFrom = dwRandom;
#ifdef DEBUG_SHOW_SECUREID

	DEBUG_ONLY(g_eMuleApp.m_pdlgEmule->AddDebugLogLine(false, "%s: Received SecIdentState Packet, state: %i", __FUNCTION__, pachPacket[0]));
#endif
}

void CUpDownClient::InfoPacketsReceived()
{
//	indicates that both Information Packets has been received
//	needed for actions, which process data from both packets
	ASSERT (m_eInfoPacketsReceived == IP_BOTH);
	m_eInfoPacketsReceived = IP_NONE;

	if (m_byteSupportSecIdent)
	{
		SendSecIdentStatePacket();
	}
}

