// CDScores.cpp : implementation file
//

#include "stdafx.h"
#include "CDScores.h"
#include "..\UpDownClient.h"
#include "..\eMule.h"


// CCDScores dialog

IMPLEMENT_DYNCREATE(CCDScores, CPropertyPage)

CCDScores::CCDScores() : CPropertyPage(CCDScores::IDD)
{
	//{{AFX_DATA_INIT(CCDScores)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CCDScores::~CCDScores()
{
}

void CCDScores::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCDScores)
	DDX_Control(pDX, IDC_SCORES_LBL, m_ctrlScores);
	DDX_Control(pDX, IDC_REMOTESCORES_LBL, m_ctrlRemoteScores);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_DLUPMODIFIER_VAL, m_ctrlDlUpModifier);
	DDX_Control(pDX, IDC_COMMUNITYUSER_VAL, m_ctrlCommunityUser);
	DDX_Control(pDX, IDC_RATING_VAL, m_ctrlRating);
	DDX_Control(pDX, IDC_UPQUEUESCORE_VAL, m_ctrlUpQueueScore);
	DDX_Control(pDX, IDC_QUEUETIME_VAL, m_ctrlQueueTime);
	DDX_Control(pDX, IDC_REMCOMMUNITY_VAL, m_ctrlRemCommunityUser);
	DDX_Control(pDX, IDC_REMDLUPMODIFIER_VAL, m_ctrlRemDlUpModifier);
	DDX_Control(pDX, IDC_REMRATING_VAL, m_ctrlRemRating);
	DDX_Control(pDX, IDC_REMUPQUEUESCORE_VAL, m_ctrlRemUpQueueScore);
}


BEGIN_MESSAGE_MAP(CCDScores, CPropertyPage)
	//{{AFX_MSG_MAP(CCDScores)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CCDScores message handlers

BOOL CCDScores::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	Localize();
	Update();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CCDScores::Update(void)
{
	EMULE_TRY

	if(m_pClient == NULL)
		return;

	if(!::IsWindow(GetSafeHwnd()))
		return;


	if(g_eMuleApp.m_pGlobPrefs->CommunityEnabled())
	{
		if(m_pClient->IsCommunity())
		{
			m_ctrlCommunityUser.SetWindowText(::GetResString(IDS_YES));
		}
		else
		{
			m_ctrlCommunityUser.SetWindowText(::GetResString(IDS_NO));		
		}
	}	
	else
	{		
		m_ctrlCommunityUser.SetWindowText(::GetResString(IDS_DISABLED));
	}

	CString strBuffer;

	if(m_pClient->Credits())
	{
		strBuffer.Format(_T("%.1f"), (double)m_pClient->Credits()->GetScoreRatio(m_pClient->GetIP()));
		m_ctrlDlUpModifier.SetWindowText(strBuffer);
	}
	else
	{
		m_ctrlDlUpModifier.SetWindowText(_T("?"));
	}

	bool bLoadedSourceName = false ;
	if(m_pClient->GetUserName())
	{
		bLoadedSourceName = (_tcsstr(m_pClient->GetUserName(), ::GetResString(IDS_LOADEDSOURCE)) != NULL) || 
							(_tcsstr(m_pClient->GetUserName(), ::GetResString(IDS_EXCHANGEDSOURCE)) != NULL) ;
	}

	if(m_pClient->GetUserName() && !bLoadedSourceName)
	{
		strBuffer.Format(_T("%.1f"), (double)m_pClient->GetScore(false, m_pClient->IsDownloading(), true));
		m_ctrlRating.SetWindowText(strBuffer);
	}
	else
	{	
		m_ctrlRating.SetWindowText(_T("?"));
	}

	if(m_pClient->GetUploadState() != US_NONE)
	{
		strBuffer.Format(_T("%u"), m_pClient->GetScore(false, m_pClient->IsDownloading(), false));
		m_ctrlUpQueueScore.SetWindowText(strBuffer);
	}
	else
	{	
		m_ctrlUpQueueScore.SetWindowText(_T("-"));
	}

	if(m_pClient->GetDownloadState() == DS_ONQUEUE)
	{	
		m_ctrlQueueTime.SetWindowText(::CastSecondsToHM(m_pClient->GetQueueWaitTime() / 1000));
	}
	else
	{	
		m_ctrlQueueTime.SetWindowText(_T("-"));
	}
	

    if(m_pClient->IsRemoteInfoAvaiable())
	{
		if(!m_pClient->GetRemoteCommunityEnabled()) 
		{	
			m_ctrlRemCommunityUser.SetWindowText(::GetResString(IDS_DISABLED));
		}
		else if(m_pClient->GetRemoteCommunity()) 
		{
			m_ctrlRemCommunityUser.SetWindowText(::GetResString(IDS_YES));
		}
		else
		{	
			m_ctrlRemCommunityUser.SetWindowText(::GetResString(IDS_NO));
		}

		strBuffer.Format(_T("%0.1f"), m_pClient->GetRemoteBaseModifier());
		m_ctrlRemDlUpModifier.SetWindowText(strBuffer);

		strBuffer.Format(_T("%ld"), m_pClient->GetRemoteRatio());
		m_ctrlRemRating.SetWindowText(strBuffer);
		
		strBuffer.Format(_T("%ld"), m_pClient->GetRemoteScore());
		m_ctrlRemUpQueueScore.SetWindowText(strBuffer);
	}
	else
	{
		m_ctrlRemCommunityUser.SetWindowText(::GetResString(IDS_DISABLED));

		if(m_pClient->Credits())
		{
			strBuffer.Format(_T("%0.1f"), m_pClient->GetRemoteBaseModifier());
			m_ctrlRemDlUpModifier.SetWindowText(strBuffer);
			strBuffer.Format(_T("%ld"), m_pClient->GetRemoteRatio());
			m_ctrlRemRating.SetWindowText(strBuffer);
			strBuffer.Format(_T("%ld"),m_pClient->GetRemoteScore());
			m_ctrlRemUpQueueScore.SetWindowText(strBuffer);
		}
		else
		{
			m_ctrlRemDlUpModifier.SetWindowText(_T("?"));
			m_ctrlRemRating.SetWindowText(_T("?"));
			m_ctrlRemUpQueueScore.SetWindowText(_T("?"));
		}
	}

	EMULE_CATCH
}

void CCDScores::Localize(void)
{
	EMULE_TRY

	if(GetSafeHwnd())
	{
		GetDlgItem(IDC_SCORES_LBL)->SetWindowText(GetResString(IDS_CD_SCORES));
		GetDlgItem(IDC_COMMUNITYUSER_LBL)->SetWindowText(GetResString(IDS_COMUSER));
		GetDlgItem(IDC_DLUPMODIFIER_LBL)->SetWindowText(GetResString(IDS_CD_MOD));
		GetDlgItem(IDC_RATING_LBL)->SetWindowText(GetResString(IDS_QL_RATING) + _T(":"));
		GetDlgItem(IDC_UPQUEUESCORE_LBL)->SetWindowText(GetResString(IDS_CD_USCORE));
		GetDlgItem(IDC_QUEUETIME_LBL)->SetWindowText(GetResString(IDS_QUEUETIMELBL));

		GetDlgItem(IDC_REMOTESCORES_LBL)->SetWindowText(GetResString(IDS_INFLST_REMOTE_SCORES));
		GetDlgItem(IDC_REMCOMMUNITY_LBL)->SetWindowText(GetResString(IDS_COMUSER));
		GetDlgItem(IDC_REMDLUPMODIFIER_LBL)->SetWindowText(GetResString(IDS_CD_MOD));
		GetDlgItem(IDC_REMRATING_LBL)->SetWindowText(GetResString(IDS_QL_RATING) + _T(":"));
		GetDlgItem(IDC_REMUPQUEUESCORE_LBL)->SetWindowText(GetResString(IDS_CD_USCORE));
	}

	EMULE_CATCH
}
