//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once
#include "StdAfx.h"
#include "partfile.h"
#include "opcodes.h"
#include "types.h"
#include "SharedFileList.h"
#include "preferences.h"
#include "sourcesaver.h" //<<-- enkeyDEV(Ottavio84) -New SLS-
#include "WebServer.h" // kuchin
#include "Loggable.h"

class CClientSource;
class CHostnameSourceWnd;
class CDownloadQueue : public CLoggable
{
	friend class CHashFileThread;
	//friend class CServerSocket;
	friend class CWebServer; // kuchin
public:
			CDownloadQueue(CPreferences* in_prefs,CSharedFileList* in_sharedfilelist);
		   ~CDownloadQueue();
	void	Process();
	void	Init();
	void	AddSearchToDownload(CSearchFile* toadd,EnumCategories eCatID = CAT_NONE);
	void	AddSearchToDownload(CString link,EnumCategories eCatID = CAT_NONE);
	void	AddFileLinkToDownload(class CED2KFileLink* pLink,EnumCategories eCatID=CAT_NONE);
	bool	FileExists(const uchar* fileid);
	bool	IsInDLQueue(CKnownFile* totest);
	CPartFile*	GetFileByID(const uchar* filehash);
	CPartFile*	GetFileByIndex(int index);
	CUpDownClient* CheckAndAddSource(CPartFile *pSenderFile, uint32 dwUserIP, uint16 nUserPort, uint32 dwServerIP, uint16 nServerPort, bool bSaveSources = true); //modified for saving sources (by Mr.Fry)
	bool 	CheckAndAddKnownSource(CPartFile* pPartFile, CUpDownClient* pKnownSource);
	bool	RemoveSource(CUpDownClient* toremove, bool updatewindow = true);
	void	DeleteAll();
	void	ResumeFiles();
	void	RemoveFile(CPartFile* toremove);
	uint32	GetDataRate()			{return m_iAverageDataRate;}
	void	SortByPriority();

	CServer*		pCurUDPServer;
	void	StopUDPRequests();
	
	void		GetDownloadStats(uint16 sources[], uint64  data[]);
	void	AddPartFilesToShare();
	void	AddDownload(CPartFile* newfile);
	CUpDownClient* 	GetDownloadClientByIP(uint32 dwIP);
	CUpDownClient* GetDownloadClientByIP_UDP(uint32 dwIP, uint16 nUDPPort);
	void	UpdateDisplayedInfo(CUpDownClient *pSource,boolean force=false);
	void	AddDownDataOverheadSourceExchange(uint32 data, uint32 dummy=0)	{ m_nDownDataRateMSOverhead += data;
															  m_nDownDataOverheadSourceExchange += data;
															  m_nDownDataOverheadSourceExchangePackets++;}
	void	AddDownDataOverheadFileRequest(uint32 data, uint32 dummy=0)		{ m_nDownDataRateMSOverhead += data;
															  m_nDownDataOverheadFileRequest += data;
															  m_nDownDataOverheadFileRequestPackets++;}
	void	AddDownDataOverheadServer(uint32 data, uint32 dummy=0)			{ m_nDownDataRateMSOverhead += data;
															  m_nDownDataOverheadServer += data;
															  m_nDownDataOverheadServerPackets++;}
	void	AddDownDataOverheadOther(uint32 data, uint32 dummy=0)			{ m_nDownDataRateMSOverhead += data;
															  m_nDownDataOverheadOther += data;
															  m_nDownDataOverheadOtherPackets++;}
	uint32	GetDownDataRateOverhead()					{return m_nDownDataRateOverhead;}
	uint64	GetDownDataOverheadSourceExchange()			{return m_nDownDataOverheadSourceExchange;}
	uint64	GetDownDataOverheadFileRequest()			{return m_nDownDataOverheadFileRequest;}
	uint64	GetDownDataOverheadServer()					{return m_nDownDataOverheadServer;}
	uint64	GetDownDataOverheadOther()					{return m_nDownDataOverheadOther;}
	uint64	GetDownDataOverheadSourceExchangePackets()	{return m_nDownDataOverheadSourceExchangePackets;}
	uint64	GetDownDataOverheadFileRequestPackets()		{return m_nDownDataOverheadFileRequestPackets;}
	uint64	GetDownDataOverheadServerPackets()			{return m_nDownDataOverheadServerPackets;}
	uint64	GetDownDataOverheadOtherPackets()			{return m_nDownDataOverheadOtherPackets;}
	void	CompDownDataRateOverhead();

	int		GetFileCount() 								{return m_partFileList.GetCount();} 	// added by FoRcHa
	int     GetTransferringFiles();														// added by FoRcHa	
	int     GetPausedFileCount();														// added by Purity
	void	StartNextFile(EnumCategories eCatID); 												// Added by Tarod
	// v:- ekmn: A4AF management
	CPartFile* 	GetA4AFAutoFile()						{return m_A4AF_auto_file;}
	void 		SetA4AFAutoFile(CPartFile* file)	;
	// ^:- ekmn: A4AF management
	void AddClientHostnameToResolve(CTypedPtrList<CPtrList, CClientSource*>* pLink);
	void ResolveNextSourceHostname();
	void    SourceHostnameResolved(WPARAM wp, LPARAM lp);
	CString	GetUDPSearchStatus();

	void	ResetCatParts(int cat);
	void	SetCatPrio(int cat, uint8 newprio);
	void	SetCatStatus(int cat, int newstatus);
	void	SetAutoCat(CPartFile* newfile);

	void SetRequiredSourcesRefresh(CPartFile* pFile)		{if (!m_LocalServerSourcesReqQueue.Find(pFile)) m_LocalServerSourcesReqQueue.AddTail(pFile);}
	void ResetLastTCPRequestTime()						{m_dwLastTCPSourcesRequestTime = 0;}
	void 		SetLastTCPSrcReqServer(CServer* pServer)		{if (pServer) m_pLastTCPSrcReqServer = pServer;}
	CServer*		GetLastTCPSrcReqServer()						{return m_pLastTCPSrcReqServer;}

protected:
	bool	SendNextUDPPacket();
	CSourceSaver m_sourcesaver; //<<-- enkeyDEV(Ottavio84) -New SLS-

private:
	list<uint64>		m_averageDataRateList;	//Cax2 - memory optimization
	list<DWORD>			m_averageTickList;	//Cax2 - memory optimization
	CTypedPtrList<CPtrList, CPartFile*> m_partFileList;
	CSharedFileList	   *m_pSharedFileList;
	CPreferences	   *m_pPrefs;
	uint16				m_iNumFilesReady;		// *NOT USED*
	uint32				m_iDataRate;
	
	uint32				m_dwLastUDPSearchTime;
	uint32				m_dwLastUDPStatTime;
	CPartFile*			m_pLastUDPSearchedFile;
	uint8				m_iUDCounter;

	uint32				m_nDownDataRateOverhead;
	uint32				m_nDownDataRateMSOverhead;
	uint64				m_nDownDataOverheadSourceExchange;
	uint64				m_nDownDataOverheadSourceExchangePackets;
	uint64				m_nDownDataOverheadFileRequest;
	uint64				m_nDownDataOverheadFileRequestPackets;
	uint64				m_nDownDataOverheadServer;
	uint64				m_nDownDataOverheadServerPackets;
	uint64				m_nDownDataOverheadOther;
	uint64				m_nDownDataOverheadOtherPackets;

	CList<int,int>		m_averageDDROList;	//Down Data Rate Overhead

 	DWORD				m_dwLastRefreshedDLDisplayTime;
    uint32				m_iAverageDataRate;
	//--- xrmb:keepPartFileStats ---
	uint32				m_lastPartFileStatsSave;

	void				SaveAllPartFileStats();
	//--- :xrmb ---
	// START enkeyDEV(kei-kun) -hostname sources in ED2K superLink-  
	CTypedPtrList<CPtrList, CClientSource*>		hostnameResolveQueue;
	CHostnameSourceWnd	*m_wndHSCallback;
	char				hostentBuffer[MAXGETHOSTSTRUCT];
	int8				sourceHostnameResolveRetry;
	bool				m_bIsResolving;
	// END enkeyDEV(kei-kun) -hostname sources in ED2K superLink-
	bool				m_bIsInitialized;
	// v1:- ekmn: A4AF management
	CPartFile		   *m_A4AF_auto_file;

	CTypedPtrList<CPtrList, CPartFile*>	m_LocalServerSourcesReqQueue;
	DWORD			m_dwLastTCPSourcesRequestTime;
	CServer*			m_pLastTCPSrcReqServer;
};

// START - enkeyDEV(kei-kun) -hostname sources in ED2K superLink-
class CHostnameSourceWnd : public CWnd
{
public:
					CHostnameSourceWnd();

CDownloadQueue	   *m_pOwner;

protected:
DECLARE_MESSAGE_MAP()

afx_msg LRESULT		OnSourceHostnameResolved(WPARAM wParam,LPARAM lParam);  
};
// END - enkeyDEV(kei-kun) -hostname sources in ED2K superLink-
