// PPgScheduler.cpp : implementation file

#include "stdafx.h"
#include "emule.h"
#include "PPgScheduler.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgScheduler dialog

IMPLEMENT_DYNAMIC(CPPgScheduler, CPropertyPage)
CPPgScheduler::CPPgScheduler()
	: CPropertyPage(CPPgScheduler::IDD)
	, schedulerEnabled(FALSE)
	, exceptMonday(FALSE)
	, exceptTuesday(FALSE)
	, exceptWednesday(FALSE)
	, exceptThursday(FALSE)
	, exceptFriday(FALSE)
	, exceptSaturday(FALSE)
	, exceptSunday(FALSE)
	, shift1Down(_T(""))
	, shift1Up(_T(""))
	, shift1Conn(_T(""))
	, shift1Conn5Sec(_T(""))
	, shift2Up(_T(""))
	, shift2Down(_T(""))
	, shift2Conn(_T(""))
	, shift2Conn5Sec(_T(""))
	, schift1Desc(_T(""))
	, schift2Desc(_T(""))
	, kb1Desc(_T(""))
	, kb2Desc(_T(""))
	, timeDesc(_T(""))
	, downDesc(_T(""))
	, upDesc(_T(""))
	, connDesc(_T(""))
	, conn5Desc(_T(""))
	, frmDesc(_T(""))
{
}

CPPgScheduler::~CPPgScheduler()
{
}

void CPPgScheduler::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SCH_SHIFT1_TIME, shift1TimeCombo); // DonGato
	DDX_Control(pDX, IDC_SCH_SHIFT2_TIME, shift2TimeCombo); // DonGato
	DDX_Check(pDX, IDC_SCH_ENABLED, schedulerEnabled);
	DDX_Check(pDX, IDC_SCH_EXCEPT_MON, exceptMonday);
	DDX_Check(pDX, IDC_SCH_EXCEPT_TUE, exceptTuesday);
	DDX_Check(pDX, IDC_SCH_EXCEPT_WED, exceptWednesday);
	DDX_Check(pDX, IDC_SCH_EXCEPT_THU, exceptThursday);
	DDX_Check(pDX, IDC_SCH_EXCEPT_FRI, exceptFriday);
	DDX_Check(pDX, IDC_SCH_EXCEPT_SAT, exceptSaturday);
	DDX_Check(pDX, IDC_SCH_EXCEPT_SUN, exceptSunday);
	DDX_Text(pDX, IDC_SCH_SHIFT1_DOWN, shift1Down);
	DDX_Text(pDX, IDC_SCH_SHIFT1_UP, shift1Up);
	DDX_Text(pDX, IDC_SCH_SHIFT1_CONN, shift1Conn);
	DDX_Text(pDX, IDC_SCH_SHIFT1_5SEC, shift1Conn5Sec);
	DDX_Text(pDX, IDC_SCH_SHIFT2_UP, shift2Up);
	DDX_Text(pDX, IDC_SCH_SHIFT2_DOWN, shift2Down);
	DDX_Text(pDX, IDC_SCH_SHIFT2_CONN, shift2Conn);
	DDX_Text(pDX, IDC_SCH_SHIFT2_5SEC, shift2Conn5Sec);
	DDX_Control(pDX, IDC_SCH_EXCEPT_MON, exceptMondayCheck);
	DDX_Control(pDX, IDC_SCH_EXCEPT_TUE, exceptTuesdayCheck);
	DDX_Control(pDX, IDC_SCH_EXCEPT_WED, exceptWednesdayCheck);
	DDX_Control(pDX, IDC_SCH_EXCEPT_THU, exceptThursdayCheck);
	DDX_Control(pDX, IDC_SCH_EXCEPT_FRI, exceptFridayCheck);
	DDX_Control(pDX, IDC_SCH_EXCEPT_SAT, exceptSaturdayCheck);
	DDX_Control(pDX, IDC_SCH_EXCEPT_SUN, exceptSundayCheck);
	DDX_Control(pDX, IDC_SCH_ENABLED, schedulerEnabledCheck);
	DDX_Control(pDX, IDC_SCH_SHIFT1_DOWN, shift1DownEdit);
	DDX_Control(pDX, IDC_SCH_SHIFT1_UP, shift1UpEdit);
	DDX_Control(pDX, IDC_SCH_SHIFT1_CONN, shift1ConnEdit);
	DDX_Control(pDX, IDC_SCH_SHIFT1_5SEC, shift1Conn5SecEdit);
	DDX_Control(pDX, IDC_SCH_SHIFT2_UP, shift2UpEdit);
	DDX_Control(pDX, IDC_SCH_SHIFT2_DOWN, shift2DownEdit);
	DDX_Control(pDX, IDC_SCH_SHIFT2_CONN, shift2ConnEdit);
	DDX_Control(pDX, IDC_SCH_SHIFT2_5SEC, shift2Conn5SecEdit);
	DDX_Text(pDX, IDC_SCH_SHIFT1, schift1Desc);
	DDX_Text(pDX, IDC_SCH_SHIFT2, schift2Desc);
	DDX_Text(pDX, IDC_SCH_KB1, kb1Desc);
	DDX_Text(pDX, IDC_SCH_KB2, kb2Desc);
	DDX_Text(pDX, IDC_SCH_TIME, timeDesc);
	DDX_Text(pDX, IDC_SCH_DOWN, downDesc);
	DDX_Text(pDX, IDC_SCH_UP, upDesc);
	DDX_Text(pDX, IDC_SCH_CONN, connDesc);
	DDX_Text(pDX, IDC_SCH_5SEC, conn5Desc);
	DDX_Text(pDX, IDC_SCH_FRM, frmDesc);
}

BEGIN_MESSAGE_MAP(CPPgScheduler, CPropertyPage)
	ON_BN_CLICKED(IDC_SCH_ENABLED, OnBnClickedSCHEnabled)
	ON_CBN_SELCHANGE(IDC_SCH_SHIFT1_TIME, OnCbnSelchangeShift1Time)
	ON_CBN_SELCHANGE(IDC_SCH_SHIFT2_TIME, OnCbnSelchangeShift2Time)
	ON_EN_CHANGE(IDC_SCH_SHIFT1_UP, OnSettingsChange)
	ON_EN_CHANGE(IDC_SCH_SHIFT1_DOWN, OnSettingsChange)
	ON_EN_CHANGE(IDC_SCH_SHIFT1_CONN, OnSettingsChange)
	ON_EN_CHANGE(IDC_SCH_SHIFT1_5SEC, OnSettingsChange)
	ON_EN_CHANGE(IDC_SCH_SHIFT2_UP, OnSettingsChange)
	ON_EN_CHANGE(IDC_SCH_SHIFT2_DOWN, OnSettingsChange)
	ON_EN_CHANGE(IDC_SCH_SHIFT2_CONN, OnSettingsChange)
	ON_EN_CHANGE(IDC_SCH_SHIFT2_5SEC, OnSettingsChange)
	ON_BN_CLICKED(IDC_SCH_EXCEPT_MON, OnSettingsChange)
	ON_BN_CLICKED(IDC_SCH_EXCEPT_TUE, OnSettingsChange)
	ON_BN_CLICKED(IDC_SCH_EXCEPT_WED, OnSettingsChange)
	ON_BN_CLICKED(IDC_SCH_EXCEPT_THU, OnSettingsChange)
	ON_BN_CLICKED(IDC_SCH_EXCEPT_FRI, OnSettingsChange)
	ON_BN_CLICKED(IDC_SCH_EXCEPT_SAT, OnSettingsChange)
	ON_BN_CLICKED(IDC_SCH_EXCEPT_SUN, OnSettingsChange)
END_MESSAGE_MAP()

BOOL CPPgScheduler::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("0:00")),0);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("0:30")),1800);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("1:00")),3600);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("1:30")),5400);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("2:00")),7200);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("2:30")),9000);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("3:00")),10800);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("3:30")),12600);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("4:00")),14400);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("4:30")),16200);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("5:00")),18000);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("5:30")),19800);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("6:00")),21600);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("6:30")),23400);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("7:00")),25200);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("7:30")),27000);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("8:00")),28800);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("8:30")),30600);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("9:00")),32400);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("9:30")),34200);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("10:00")),36000);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("10:30")),37800);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("11:00")),39600);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("11:30")),41400);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("12:00")),43200);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("12:30")),45000);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("13:00")),46800);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("13:30")),48600);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("14:00")),50400);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("14:30")),52200);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("15:00")),54000);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("15:30")),55800);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("16:00")),57600);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("16:30")),59400);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("17:00")),61200);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("17:30")),63000);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("18:00")),64800);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("18:30")),66600);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("19:00")),68400);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("19:30")),70200);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("20:00")),72000);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("20:30")),73800);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("21:00")),75600);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("21:30")),77400);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("22:00")),79200);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("22:30")),81000);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("23:00")),82800);
	shift1TimeCombo.SetItemData(shift1TimeCombo.AddString(_T("23:30")),84600);

	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("0:00")),0);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("0:30")),1800);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("1:00")),3600);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("1:30")),5400);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("2:00")),7200);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("2:30")),9000);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("3:00")),10800);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("3:30")),12600);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("4:00")),14400);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("4:30")),16200);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("5:00")),18000);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("5:30")),19800);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("6:00")),21600);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("6:30")),23400);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("7:00")),25200);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("7:30")),27000);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("8:00")),28800);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("8:30")),30600);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("9:00")),32400);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("9:30")),34200);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("10:00")),36000);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("10:30")),37800);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("11:00")),39600);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("11:30")),41400);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("12:00")),43200);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("12:30")),45000);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("13:00")),46800);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("13:30")),48600);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("14:00")),50400);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("14:30")),52200);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("15:00")),54000);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("15:30")),55800);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("16:00")),57600);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("16:30")),59400);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("17:00")),61200);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("17:30")),63000);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("18:00")),64800);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("18:30")),66600);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("19:00")),68400);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("19:30")),70200);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("20:00")),72000);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("20:30")),73800);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("21:00")),75600);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("21:30")),77400);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("22:00")),79200);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("22:30")),81000);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("23:00")),82800);
	shift2TimeCombo.SetItemData(shift2TimeCombo.AddString(_T("23:30")),84600);

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgScheduler::LoadSettings(void)
{
	if (::IsWindow(m_hWnd))
	{
		for(int i = 0; i != shift1TimeCombo.GetCount(); i++)
		{
			if(shift1TimeCombo.GetItemData(i) == m_pPrefs->GetSCHShift1())
			{
				shift1TimeCombo.SetCurSel(i);
				break;
			}
		}

		for(int i = 0; i != shift2TimeCombo.GetCount(); i++)
		{
			if(shift2TimeCombo.GetItemData(i) == m_pPrefs->GetSCHShift2())
			{
				shift2TimeCombo.SetCurSel(i);
				break;
			}
		}

		if(m_pPrefs->GetSCHShift1Upload() == 0xFFFF)
			shift1Up = _T("0");
		else		
			shift1Up.Format(_T("%d"), m_pPrefs->GetSCHShift1Upload());

		if(m_pPrefs->GetSCHShift1Download() == 0xFFFF)
			shift1Down = _T("0");
		else		
			shift1Down.Format(_T("%d"), m_pPrefs->GetSCHShift1Download());
			
		shift1Conn.Format(_T("%d"), m_pPrefs->GetSCHShift1conn());
		shift1Conn5Sec.Format(_T("%d"), m_pPrefs->GetSCHShift15sec());
		
		if(m_pPrefs->GetSCHShift2Upload() == 0xFFFF)
			shift2Up = _T("0");
		else		
			shift2Up.Format(_T("%d"), m_pPrefs->GetSCHShift2Upload());			
		

		if(m_pPrefs->GetSCHShift2Download() == 0xFFFF)
			shift2Down = _T("0");
		else		
			shift2Down.Format(_T("%d"), m_pPrefs->GetSCHShift2Download());

		shift2Conn.Format(_T("%d"), m_pPrefs->GetSCHShift2conn());
		shift2Conn5Sec.Format(_T("%d"), m_pPrefs->GetSCHShift25sec());
	
		exceptMonday = m_pPrefs->IsSCHExceptMon();
		exceptTuesday = m_pPrefs->IsSCHExceptTue();
		exceptWednesday = m_pPrefs->IsSCHExceptWed();
		exceptThursday = m_pPrefs->IsSCHExceptThu();
		exceptFriday = m_pPrefs->IsSCHExceptFri();
		exceptSaturday = m_pPrefs->IsSCHExceptSat();
		exceptSunday = m_pPrefs->IsSCHExceptSun();

		schedulerEnabled = m_pPrefs->IsSCHEnabled();

		UpdateData(FALSE);

		OnBnClickedSCHEnabled();

		SetModified(FALSE);
	}
}

BOOL CPPgScheduler::OnApply()
{	
	if(m_bModified)
	{
		UpdateData(TRUE);

		if(shift1Up.GetLength() != 0)
		{
			int i = _tstoi(shift1Up);
			m_pPrefs->SetSCHShift1Upload((i != 0) ? i : 0xFFFF);
		}
		if(shift1Down.GetLength() != 0)
		{
			int i = _tstoi(shift1Down);
			m_pPrefs->SetSCHShift1Download((i != 0) ? i : 0xFFFF);
		}
		g_eMuleApp.m_pUploadQueue->SCHShift1UploadCheck();

		if(shift1Conn.GetLength() != 0)
		{
			int i = _tstoi(shift1Conn);
			m_pPrefs->SetSCHShift1conn((i != 0) ? i : 0xFFFF);
		}
		if(shift1Conn5Sec.GetLength() != 0)
		{
			int i = _tstoi(shift1Conn5Sec);
			m_pPrefs->SetSCHShift15sec((i != 0) ? i : 0xFFFF);
		}

		if(shift2Up.GetLength() != 0)
		{
			int i = _tstoi(shift2Up);
			m_pPrefs->SetSCHShift2Upload((i != 0) ? i : 0xFFFF);
		}
		if(shift2Down.GetLength() != 0)
		{
			int i = _tstoi(shift2Down);
			m_pPrefs->SetSCHShift2Download((i != 0) ? i : 0xFFFF);
		}
		g_eMuleApp.m_pUploadQueue->SCHShift2UploadCheck();

		if(shift2Conn.GetLength() != 0)
		{
			int i = _tstoi(shift2Conn);
			m_pPrefs->SetSCHShift2conn((i != 0) ? i : 0xFFFF);
		}
		if(shift2Conn5Sec.GetLength() != 0)
		{
			int i = _tstoi(shift2Conn5Sec);
			m_pPrefs->SetSCHShift25sec((i != 0) ? i : 0xFFFF);
		}

		if (shift1TimeCombo.GetCurSel() != CB_ERR){
			m_pPrefs->SetSCHShift1(shift1TimeCombo.GetItemData(shift1TimeCombo.GetCurSel()));
		}
		if (shift2TimeCombo.GetCurSel() != CB_ERR){
			m_pPrefs->SetSCHShift2(shift2TimeCombo.GetItemData(shift2TimeCombo.GetCurSel()));
		}

		m_pPrefs->SetSCHExceptMon(exceptMonday);
		m_pPrefs->SetSCHExceptTue(exceptTuesday);
		m_pPrefs->SetSCHExceptWed(exceptWednesday);
		m_pPrefs->SetSCHExceptThu(exceptThursday);
		m_pPrefs->SetSCHExceptFri(exceptFriday);
		m_pPrefs->SetSCHExceptSat(exceptSaturday);
		m_pPrefs->SetSCHExceptSun(exceptSunday);

		m_pPrefs->SetSCHEnabled(schedulerEnabled);

		SetModified(FALSE);
	}
	return CPropertyPage::OnApply();
}

void CPPgScheduler::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_SCHEDULER));
		schift1Desc = GetResString(IDS_SCH_SHIFT1);
		schift2Desc = GetResString(IDS_SCH_SHIFT2);
		kb1Desc = GetResString(IDS_KBYTESEC);
		kb2Desc = GetResString(IDS_KBYTESEC);
		timeDesc = GetResString(IDS_TIME);
		downDesc = GetResString(IDS_PW_CON_DOWNLBL);
		upDesc = GetResString(IDS_PW_CON_UPLBL);
		connDesc = GetResString(IDS_PW_MAXC);
		conn5Desc = GetResString(IDS_MAXCON5_TEXT);
		frmDesc = GetResString(IDS_SCH_EXCEPT);
		exceptMondayCheck.SetWindowText(GetResString(IDS_SCH_EXCEPT_MON));
		exceptTuesdayCheck.SetWindowText(GetResString(IDS_SCH_EXCEPT_TUE));
		exceptWednesdayCheck.SetWindowText(GetResString(IDS_SCH_EXCEPT_WED));
		exceptThursdayCheck.SetWindowText(GetResString(IDS_SCH_EXCEPT_THU));
		exceptFridayCheck.SetWindowText(GetResString(IDS_SCH_EXCEPT_FRI));
		exceptSaturdayCheck.SetWindowText(GetResString(IDS_SCH_EXCEPT_SAT));
		exceptSundayCheck.SetWindowText(GetResString(IDS_SCH_EXCEPT_SUN));
		schedulerEnabledCheck.SetWindowText(GetResString(IDS_ENABLED));

		UpdateData(FALSE);
	}
}

void CPPgScheduler::OnBnClickedSCHEnabled()
{
	UpdateData(TRUE);

	shift1TimeCombo.EnableWindow(schedulerEnabled);
	shift1UpEdit.EnableWindow(schedulerEnabled);
	shift1DownEdit.EnableWindow(schedulerEnabled);
	shift1ConnEdit.EnableWindow(schedulerEnabled);
	shift1Conn5SecEdit.EnableWindow(schedulerEnabled);
	shift2TimeCombo.EnableWindow(schedulerEnabled);
	shift2UpEdit.EnableWindow(schedulerEnabled);
	shift2DownEdit.EnableWindow(schedulerEnabled);
	shift2ConnEdit.EnableWindow(schedulerEnabled);
	shift2Conn5SecEdit.EnableWindow(schedulerEnabled);
	exceptMondayCheck.EnableWindow(schedulerEnabled);
	exceptTuesdayCheck.EnableWindow(schedulerEnabled);
	exceptWednesdayCheck.EnableWindow(schedulerEnabled);
	exceptThursdayCheck.EnableWindow(schedulerEnabled);
	exceptFridayCheck.EnableWindow(schedulerEnabled);
	exceptSaturdayCheck.EnableWindow(schedulerEnabled);
	exceptSundayCheck.EnableWindow(schedulerEnabled);

	SetModified();
}
