#pragma once

#include "ArrowCombo.h"
#include "afxwin.h"
// CPPgSorting dialog

class CPPgSorting : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgSorting)

public:
	CPPgSorting();
	virtual ~CPPgSorting();
	void SetPrefs(CPreferences* in_prefs) {	m_pPrefs = in_prefs; }

// Dialog Data
	enum { IDD = IDD_PPG_SORTING };
	virtual BOOL OnInitDialog();
	virtual BOOL OnApply();
	void Localize(void);
	afx_msg void OnBnClickedUseSort();
	afx_msg void OnBnClickedSortSources2Box();
	afx_msg void OnCbnSelchangeSortServers()		{ SetModified(); }
	afx_msg void OnCbnSelchangeSortFiles()			{ SetModified(); }
	afx_msg void OnCbnSelchangeSortDownloads()		{ SetModified(); }
	afx_msg void OnCbnSelchangeSortSources1()		{ SetModified(); }
	afx_msg void OnCbnSelchangeSortSources2()		{ SetModified(); }
	afx_msg void OnCbnSelchangeSortUploads()		{ SetModified(); }
	afx_msg void OnCbnSelchangeSortQueue()			{ SetModified(); }
	afx_msg void OnCbnSelchangeSortSearch()			{ SetModified(); }
	afx_msg void OnCbnSelchangeSortIrc()			{ SetModified(); }
	afx_msg void OnCbnSelchangeSortClientList()		{ SetModified(); }
	afx_msg void OnBnClickedUpdateQueueList()		{ SetModified(); }
protected:
	CPreferences *m_pPrefs;	
	bool m_bModified;
	
	void SetModified(BOOL bChanged = TRUE)
	{
		m_bModified = bChanged;
		CPropertyPage::SetModified(bChanged);
	}

	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	DECLARE_MESSAGE_MAP()
private:
	void LoadSettings(void);
	
	
protected:
	BOOL updateQueue;
	BOOL bUseSorting;
	BOOL bUseSourcesSorting;
private:
	CButton updateQueueCheck;
	CButton sortSources2Check;
	CButton useItCheck;
	CArrowCombo serverColsCombo;
	CArrowCombo fileColsCombo;
	CArrowCombo downloadColsCombo;
	CArrowCombo uploadColsCombo;
	CArrowCombo queueColsCombo;
	CArrowCombo searchColsCombo;
	CArrowCombo ircColsCombo;
	CArrowCombo clientListColsCombo;
	CArrowCombo sourceCols1Combo;
	CArrowCombo sourceCols2Combo;
	CString sortServersDesc;
	CString sortDownloadsDesc;
	CString sortUploadsDesc;
	CString sortQueueDesc;
	CString sortSearchDesc;
	CString sortIrcDesc;
	CString sortClientListDesc;
	CString sortFilesDesc;
	CString sortSources1Desc;
	CString sortGrpDesc;
};
