#pragma once

#include "preferences.h"
#include "afxwin.h"
#include "FontPreviewCombo.h"

// CPPgWindow dialog

class CPPgWindow : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgWindow)

public:
	CPPgWindow();
	virtual ~CPPgWindow();
	void SetPrefs(CPreferences* in_prefs) {	m_pPrefs = in_prefs; }

// Dialog Data
	enum { IDD = IDD_PPG_WINDOW };
protected:
	CPreferences *m_pPrefs;
	
	bool m_bModified;
	void SetModified(BOOL bChanged = TRUE)
	{
		m_bModified = bChanged;
		CPropertyPage::SetModified(bChanged);
	}
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	void LoadSettings(void);
	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	void Localize(void);
	virtual BOOL OnApply();
	afx_msg void OnEnChangeStartMin()					{ SetModified(); }
	afx_msg void OnBnClickedMintray()					{ SetModified(); }
	afx_msg void OnBnClickedExit()						{ SetModified(); }
	afx_msg void OnBnClickedBringtoforeground()			{ SetModified(); }
	afx_msg void OnBnClickedCbTbnClosetotray()  		{ SetModified(); }
	afx_msg void OnCbnSelchangeUsedFont()  				{ SetModified(); }
	afx_msg void OnCbnSelchangeUsedfontsize()			{ SetModified(); }
	afx_msg void OnBnClickedShowRateOnTitle()			{ SetModified(); }
	afx_msg void OnBnClickedSpeedMeter()				{ SetModified(); }
	afx_msg void OnBnClickedA4AF()						{ SetModified(); }
	afx_msg void OnBnClickedAvgDataRate()				{ SetModified(); }
	afx_msg void OnBnClickedShowFileType()				{ SetModified(); }
	afx_msg void OnBnClickedTransferredOnCompleted()	{ SetModified(); }
	afx_msg void OnBnClickedDownloadPercentage()		{ SetModified(); }
	afx_msg void OnBnClickedShowPausedGray()			{ SetModified(); }
	afx_msg void OnBnClickedShowFileStatusIcons()		{ SetModified(); }
protected:
	BOOL startMin;
	BOOL minTray;
	BOOL closeToTray;
	BOOL promptOnExit;
	BOOL bringToForeground;
	BOOL showRateOnTitle;
	BOOL showSpeedMeterOnToolbar;
	BOOL showA4AF;
	BOOL showAvgDataRate;
	BOOL showFileTypeIcons;
	BOOL showTransferredOnCompleted;
	BOOL showDownloadPercentage;
	BOOL showPausedGray;
	BOOL showFileStatusIcons;
private:
	CFontPreviewCombo	fontPreviewCombo;
	CComboBox			fontSizeCombo;
	CButton startMinCheck;
	CButton minTrayCheck;
	CButton closeToTrayCheck;
	CButton promptOnExitCheck;
	CButton bringToForegroundCheck;
	CButton showRateOnTitleCheck;
	CButton showSpeedMeterOnToolbarCheck;
	CButton showA4AFCheck;
	CButton showAvgDataRateCheck;
	CButton showFileTypeIconsCheck;
	CButton showTransferredOnCompletedCheck;
	CButton showDownloadPercentageCheck;
	CButton showPausedGrayCheck;
	CButton showFileStatusIconsCheck;
	CString usedFontDesc;
};
