//	PreferencesDlg.cpp : implementation file
//

//#region headers
#include "stdafx.h"
#include "emule.h"
#include "PreferencesDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif
//#endregion headers

//#region message map
BEGIN_MESSAGE_MAP(CPreferencesDlg, CPropertySheet)
	ON_WM_DESTROY()
	ON_LBN_SELCHANGE(IDC_PREFS_LISTBOX, OnSelChanged)
	ON_COMMAND(ID_APPLY_NOW, OnApplyNow)
	ON_COMMAND(IDOK, OnOk)
END_MESSAGE_MAP()
//#endregion

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CPreferencesDlg::CPreferencesDlg()
{
	m_bIsVisible = false;
//#region OLD
#ifdef OLD
	m_psh.dwFlags = PSH_PROPSHEETPAGE;
	m_proppageGeneral.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageConnection.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageProxy.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageServer.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageAdvanced.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageBackup.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageDirectories.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageFiles.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageIRC.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageHTTPD.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageStats.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageMessaging.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageNotify.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageSMTP.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageModPT.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageScheduler.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageShortcuts.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageSorting.m_psp.dwFlags = PSP_USECALLBACK;
	m_proppageWindow.m_psp.dwFlags = PSP_USECALLBACK;
#endif OLD
//#endregion
	EnableStackedTabs(FALSE);

	AddPage(&m_proppageGeneral);
	AddPage(&m_proppageConnection);
	AddPage(&m_proppageProxy);
	AddPage(&m_proppageServer);
	AddPage(&m_proppageAdvanced);
	AddPage(&m_proppageBackup);
	AddPage(&m_proppageDirectories);
	AddPage(&m_proppageFiles);
	AddPage(&m_proppageIRC);
	AddPage(&m_proppageHTTPD);
	AddPage(&m_proppageStats);
	AddPage(&m_proppageMessaging);
	AddPage(&m_proppageNotify);
	AddPage(&m_proppageSMTP);
	AddPage(&m_proppageModPT);
	AddPage(&m_proppageScheduler);
	AddPage(&m_proppageShortcuts);
	AddPage(&m_proppageSorting);
	AddPage(&m_proppageWindow);
	m_dwActiveWnd = 0;

	m_imageList.Create(16, 16, ILC_COLOR32 | ILC_MASK, 0, 10);
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_GENERAL), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_CONNECTION), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_PROXY), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_SERVER), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_ADVANCED), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_BACKUP), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_FOLDERS), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_FILES), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_IRC), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_WEBSERVER), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_STATISTICS), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_MPENDING), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_NOTIFICATIONS), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_SMTP), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_MODPT), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_SCHEDULER), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_SHORTCUTS),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_SORTING), 16, 16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_PREF_WINDOW), 16, 16));
	LoadImgLstIcon(NULL, 0, 0);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CPreferencesDlg::~CPreferencesDlg()
{
	m_imageList.DeleteImageList();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
INT_PTR CPreferencesDlg::DoModal()
{
	if (!m_bIsVisible)
	{
		m_bIsVisible = true;
		return CPropertySheet::DoModal();
	}
	else
		return FALSE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPreferencesDlg::OnDestroy()
{
	m_bIsVisible = false;
	CPropertySheet::OnDestroy();
	m_dwActiveWnd = GetActiveIndex();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPreferencesDlg::OnApplyNow()
{
	Default();

	m_pPrefs->Save();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPreferencesDlg::OnOk()
{
	Default();

	m_pPrefs->Save();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CPreferencesDlg::OnInitDialog()
{
	m_listBox.CreateEx(WS_EX_CLIENTEDGE, _T("Listbox"), 0, WS_VSCROLL | WS_CHILD | WS_VISIBLE | LBS_NOTIFY | WS_TABSTOP | LBS_HASSTRINGS | LBS_OWNERDRAWVARIABLE | WS_BORDER, CRect(0, 0, 0, 0), this, IDC_PREFS_LISTBOX);
	::SendMessage(m_listBox.m_hWnd, WM_SETFONT, (WPARAM) ::GetStockObject(DEFAULT_GUI_FONT), 0);

	m_listBox.SetImageList(&m_imageList);

	BOOL bResult = CPropertySheet::OnInitDialog();

	SetActivePage(m_dwActiveWnd);

	Localize();

	m_listBox.SetFocus();

	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPreferencesDlg::OnSelChanged()
{
	int curSel = m_listBox.GetCurSel();
	SetActivePage(curSel);
	CString currenttext;
	m_listBox.GetText(curSel, currenttext);
	CString title = GetResString(IDS_EM_PREFS);
	title.Remove('&');
	SetWindowText(title + _T(": ") + currenttext);
//	SetIcon(m_imageList.ExtractIcon(curSel),FALSE);
	m_listBox.SetFocus();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CPreferencesDlg::Localize()
{
	m_proppageGeneral.Localize();
	m_proppageConnection.Localize();
	m_proppageProxy.Localize();    // Maverick
	m_proppageServer.Localize();
	m_proppageAdvanced.Localize();
	m_proppageBackup.Localize(); //N@boleo
	m_proppageDirectories.Localize();
	m_proppageFiles.Localize();
	m_proppageIRC.Localize();
	m_proppageHTTPD.Localize();
	m_proppageStats.Localize();
	m_proppageMessaging.Localize(); //<<-- enkeyDEV(kei-kun) -Messaging preferences-
	m_proppageNotify.Localize();
	m_proppageSMTP.Localize();
	m_proppageModPT.Localize();
	m_proppageScheduler.Localize();
	m_proppageShortcuts.Localize();
	m_proppageSorting.Localize();
	m_proppageWindow.Localize();

	CStringArray buffer;
	buffer.Add(GetResString(IDS_PW_GENERAL));
	buffer.Add(GetResString(IDS_PW_CONNECTION));
	buffer.Add(GetResString(IDS_PW_PROXY));  // Maverick
	buffer.Add(GetResString(IDS_PW_SERVER));
	buffer.Add(GetResString(IDS_PW_ADVANCED));
	buffer.Add(GetResString(IDS_PW_BACKUP)); //N@boleo
	buffer.Add(GetResString(IDS_PW_DIR));
	buffer.Add(GetResString(IDS_PW_FILES));
	buffer.Add(GetResString(IDS_IRC));
	buffer.Add(GetResString(IDS_PW_HTTPD));
	buffer.Add(GetResString(IDS_STATSSETUPINFO));
	buffer.Add(GetResString(IDS_PW_IM_OPTIONS));  //<<-- enkeyDEV(kei-kun) -Messaging preferences-
	buffer.Add(GetResString(IDS_PW_EKDEV_OPTIONS));
	buffer.Add(GetResString(IDS_PW_SMTP));
	buffer.Add(GetResString(IDS_PW_MODPT));
	buffer.Add(GetResString(IDS_PW_SCHEDULER));
	buffer.Add(GetResString(IDS_PW_SHORTCUTS));
	buffer.Add(GetResString(IDS_PW_SORTING));
	buffer.Add(GetResString(IDS_PW_WINDOW));

	m_listBox.ResetContent();
	int width = 0;
	CClientDC dc(this);
	CFont * f = m_listBox.GetFont();
	CFont * pOldFont = dc.SelectObject(f);
	CSize sz;
	for (int i = 0; i < GetPageCount(); i++)
	{
		m_listBox.AddString(buffer[i], i);
		sz = dc.GetTextExtent(buffer[i]);
		if (sz.cx > width)
			width = sz.cx;
	}
	dc.SelectObject(pOldFont);
	width += 60;
	CRect rectOld;
	m_listBox.GetWindowRect(&rectOld);
	int xoffset, yoffset;
	if (IsWindowVisible())
	{
		yoffset = 0;
		xoffset = width - rectOld.Width();
	}
	else
	{
		xoffset = width - rectOld.Width() + 10;
		GetActivePage()->GetWindowRect(rectOld);
		ScreenToClient (rectOld);
		yoffset = -rectOld.top;
	}
	GetWindowRect(rectOld);
	SetWindowPos(NULL, 0, 0, rectOld.Width() + xoffset, rectOld.Height() + yoffset, SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE);
	CTabCtrl* tab = GetTabControl();
	tab->GetWindowRect (rectOld);
	ScreenToClient (rectOld);
	tab->SetWindowPos(NULL, rectOld.left + xoffset, rectOld.top + yoffset, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
	CPropertyPage* activepage = GetActivePage();
	activepage->GetWindowRect(rectOld);
	ScreenToClient (rectOld);
	activepage->SetWindowPos(NULL, rectOld.left + xoffset, rectOld.top + yoffset, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
	GetClientRect(rectOld);
	m_listBox.SetWindowPos(NULL, 6, 6, width, rectOld.Height() - 12, SWP_NOZORDER | SWP_NOACTIVATE);
	int _PropSheetButtons[] = {IDOK, IDCANCEL, ID_APPLY_NOW, IDHELP };
	CWnd* PropSheetButton;
	for (int i = 0; i < sizeof (_PropSheetButtons) / sizeof(_PropSheetButtons[0]); i++)
	{
		if (PropSheetButton = GetDlgItem(_PropSheetButtons[i]))
		{
			PropSheetButton->GetWindowRect (rectOld);
			ScreenToClient (rectOld);
			PropSheetButton->SetWindowPos (NULL, rectOld.left + xoffset, rectOld.top + yoffset, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
		}
	}
	tab->ShowWindow(SW_HIDE);
	m_listBox.SetCurSel(GetActiveIndex());
	OnSelChanged();
	CenterWindow();
	Invalidate();
	RedrawWindow();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
