//--- xrmb:parttraffic ---
//--- there are so many changes in here, maybe its easier to exchange the whole file ---

//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "stdafx.h"
#include "emule.h"
#include "SharedFilesCtrl.h"
#include "otherfunctions.h"
#include "CommentDialog.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#if JUMPSTART
#define MP_JUMPSTART 14791
#endif

// #define _SHOW_UNOFFERED_FILES_

//--- minimum repaint time for a trafficbar (ms) ---
#define SFL_BARUPDATE 1000

//--- it's much easier to use this with other mods ---
enum
{ 
	SFL_COLUMN_FILENAME=0, 
	SFL_COLUMN_FILESIZE, 
	SFL_COLUMN_TYPE, 
	SFL_COLUMN_PRIORITY, 
	SFL_COLUMN_PERMISSION, 
	SFL_COLUMN_FILEID, 
	SFL_COLUMN_REQUESTS, 
	SFL_COLUMN_ACCEPTED, 
	SFL_COLUMN_TRANSFERRED, 
	SFL_COLUMN_PARTTRAFFIC, 
	SFL_COLUMN_UPLOADS, 
	SFL_COLUMN_COMPLETESRC,
};

#define sortcmp(a, b) ((a)==(b))?0: (((a)<(b))?-1:1)

#define GrayIt(gray, color) gray?(0x444444+0x010101*((GetRValue(color)*30+GetGValue(color)*59+GetBValue(color)*11)/0xFF)):color

IMPLEMENT_DYNAMIC(CSharedFilesCtrl, CMuleListCtrl)

BEGIN_MESSAGE_MAP(CSharedFilesCtrl, CMuleListCtrl)
	ON_WM_CONTEXTMENU()
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDoubleClick)
	ON_NOTIFY_REFLECT(LVN_GETDISPINFO, OnGetDispInfo)
END_MESSAGE_MAP()

//--- static members ---
uint8	CSharedFilesCtrl::m_p2p[8];
bool	CSharedFilesCtrl::m_sortParts=false;

CSharedFilesCtrl::CSharedFilesCtrl() : m_pSCM(NULL)
{
	EMULE_TRY

	m_statusWidth=-1;

	SetColoring(0);
	SetDisplay(0, false);

	//--- xrmb:allyaknow ---
	m_allYaKnow=false;
	//--- :xrmb ---
	
	//--- i wrote my own little sort helper ---
	m_listSorter.init(12);

	m_listSorter.item(SFL_COLUMN_FILESIZE)->set(1, true);
	m_listSorter.item(SFL_COLUMN_PRIORITY)->set(1, true);
	m_listSorter.item(SFL_COLUMN_REQUESTS)->set(2, true);
	m_listSorter.item(SFL_COLUMN_ACCEPTED)->set(2, true);
	m_listSorter.item(SFL_COLUMN_TRANSFERRED)->set(2, true);
	m_listSorter.item(SFL_COLUMN_PARTTRAFFIC)->set(2, true);
	m_listSorter.item(SFL_COLUMN_UPLOADS)->set(2, true);
	m_listSorter.item(SFL_COLUMN_COMPLETESRC)->set(2,true);		// netwolf: complete sources (zegzav )

	//--- fast prio 2 prio converter, need because the prios are messed up a little bit ---
	m_p2p[PR_VERYLOW]	= 0;
	m_p2p[PR_LOW]		= 1;
	m_p2p[PR_NORMAL]	= 2;
	m_p2p[PR_HIGH]		= 3;
	m_p2p[PR_VERYHIGH]	= 4;
	m_p2p[PR_AUTO]		= 5;
#if JUMPSTART
	m_p2p[PR_JUMPSTART]	= 6;
#endif

	EMULE_CATCH
}

CSharedFilesCtrl::~CSharedFilesCtrl()
{
	if(m_pSCM)
		delete m_pSCM;
}

void CSharedFilesCtrl::Init()
{
	EMULE_TRY

	SetColoring(g_eMuleApp.m_pGlobPrefs->GetUpbarColor());
	SetDisplay(g_eMuleApp.m_pGlobPrefs->GetUpbarStyle(), false);

	//--- that seems to be the way to make taller item :) (i hate mfc... honestly i don't understand mfc :) ---
	CImageList ilDummyImageList;
	ilDummyImageList.Create(1, 17, ILC_COLOR, 1, 1); 
	SetImageList(&ilDummyImageList, LVSIL_SMALL);

	SetExtendedStyle(LVS_EX_FULLROWSELECT);
	ModifyStyle(LVS_SINGLESEL,0);

	//--- in the official emule source the is a unlogical value at the end (for me :) ---
	InsertColumn(SFL_COLUMN_FILENAME, GetResString(IDS_DL_FILENAME), LVCFMT_LEFT, 250);
	InsertColumn(SFL_COLUMN_FILESIZE, GetResString(IDS_DL_SIZE), LVCFMT_RIGHT, 100);
	InsertColumn(SFL_COLUMN_TYPE, GetResString(IDS_TYPE), LVCFMT_LEFT, 50);
	InsertColumn(SFL_COLUMN_PRIORITY, GetResString(IDS_PRIORITY), LVCFMT_LEFT, 70);
	InsertColumn(SFL_COLUMN_PERMISSION, GetResString(IDS_PERMISSION), LVCFMT_LEFT, 100);
	InsertColumn(SFL_COLUMN_FILEID,	GetResString(IDS_FILEID), LVCFMT_LEFT, 220);
	InsertColumn(SFL_COLUMN_REQUESTS, GetResString(IDS_SF_REQUESTS), LVCFMT_LEFT, 100);
	InsertColumn(SFL_COLUMN_ACCEPTED, GetResString(IDS_SF_ACCEPTS),	LVCFMT_LEFT, 100);
	InsertColumn(SFL_COLUMN_TRANSFERRED, GetResString(IDS_SF_TRANSFERRED), LVCFMT_LEFT, 120);
	InsertColumn(SFL_COLUMN_COMPLETESRC, GetResString(IDS_SF_COMPLETESRC), LVCFMT_LEFT, 100);

	//--- these are my columns ---
	InsertColumn(SFL_COLUMN_PARTTRAFFIC,GetResString(IDS_SF_PARTTRAFFIC),LVCFMT_LEFT, 120);
	InsertColumn(SFL_COLUMN_UPLOADS,GetResString(IDS_SF_COLUPLOADS),LVCFMT_LEFT, 120);

	LoadSettings(CPreferences::TABLE_SHARED);

	if (g_eMuleApp.m_pGlobPrefs->DoUseSort())
	{
		SortInit(g_eMuleApp.m_pGlobPrefs->GetFileSortCol());
	}
	else
	{
		uint32		dwSortCode = g_eMuleApp.m_pGlobPrefs->GetColumnSortItem(CPreferences::TABLE_SHARED);

		dwSortCode |= g_eMuleApp.m_pGlobPrefs->GetColumnSortAscending(CPreferences::TABLE_SHARED) ? MLC_SORTASC : MLC_SORTDESC;

		SortInit(dwSortCode);
	}

	EMULE_CATCH
}

void CSharedFilesCtrl::SortInit(int iSortCode) // Cax2 sortdlg
{ 
	EMULE_TRY

	//get the sort column
	int iSortColumn = (iSortCode & MLC_COLUMNMASK);
	//get sort order
	bool bSortAscending = (iSortCode & MLC_SORTDESC) == 0;
	// check alternative order
	bool	bSortAlt = (iSortCode & MLC_SORTALT) != 0;

	SetSortArrow(iSortColumn, bSortAscending);
	m_listSorter.clicked(iSortColumn);
	m_listSorter.item(iSortColumn)->sortIt(bSortAlt ? 2:1, bSortAscending);
//	AddLogLine(true, "sort column %i, direction %s, level %i bSortDesc is: %i", m_listSorter.selected(), m_listSorter.dir()?"ascending":"descending", m_listSorter.level(),bReverse);
	SortItems(&SortProc, (LPARAM)&m_listSorter);

	EMULE_CATCH
}

void CSharedFilesCtrl::Localize() 
{
	EMULE_TRY

	if (GetSafeHwnd())
	{
		CHeaderCtrl* pHeaderCtrl = GetHeaderCtrl();
		HDITEM hdi;
		hdi.mask = HDI_TEXT;
		CString strRes;

		strRes = GetResString(IDS_DL_FILENAME);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_FILENAME, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DL_SIZE);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_FILESIZE, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_TYPE);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_TYPE, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_PRIORITY);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_PRIORITY, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_PERMISSION);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_PERMISSION, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_FILEID);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_FILEID, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_SF_REQUESTS);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_REQUESTS, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_SF_ACCEPTS);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_ACCEPTED, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_SF_TRANSFERRED);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_TRANSFERRED, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_SF_COMPLETESRC);	//netwolf: zegzav complete sources
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_COMPLETESRC, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_SF_PARTTRAFFIC);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_PARTTRAFFIC, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_SF_COLUPLOADS);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(SFL_COLUMN_UPLOADS, &hdi);
		strRes.ReleaseBuffer();

		// DonGato: localization fix
		if(m_allYaKnow)
			ShowKnownList();
		else
			ShowFileList(g_eMuleApp.m_pSharedFilesList);
	}

	EMULE_CATCH
}

void CSharedFilesCtrl::ShowFileList(CSharedFileList* in_sflist)
{
	EMULE_TRY

	SetRedraw(false);

	DeleteAllItems();
	CCKey bufKey;
	CKnownFile* cur_file;
	for(POSITION pos = in_sflist->m_mapSharedFiles.GetStartPosition();pos != 0;)
	{
		in_sflist->m_mapSharedFiles.GetNextAssoc(pos, bufKey, cur_file);
		ShowFile(cur_file, false);
	}	
	ShowFilesCount();

	SetRedraw(true);

	//--- xrmb:allyaknow ---
	m_allYaKnow=false;
	//--- :xrmb ---

	EMULE_CATCH
}

//--- xrmb:allyaknow ---
void CSharedFilesCtrl::ShowKnownList()
{
	EMULE_TRY

	CKnownFileList* list=g_eMuleApp.m_pKnownFilesList;

	SetRedraw(false);

	DeleteAllItems();

	uint32 records=list->GetCount();
	for(uint32 i=0; i<records; i++) 
	{
		ShowFile(list->ElementAt(i), false);
	}

	SetRedraw(true);

	m_allYaKnow=true;

	EMULE_CATCH
}
//--- :xrmb ---

void CSharedFilesCtrl::UpdateFile(CKnownFile* file, uint32 itemnr, bool resort)
{
	EMULE_TRY

	if(file == NULL)
		return;

	//--- like everywhere else i replace the columnumbers ---
	CString buffer;

	SetItemText(itemnr,SFL_COLUMN_FILESIZE,CastItoXBytes(file->GetFileSize()));
	SetItemText(itemnr,SFL_COLUMN_TYPE,file->GetFileType(true));

	
	// Modified by Tarod for UAP
	if (file->IsAutoPrioritized())
	{
		if (file->GetPriority() == PR_NORMAL)
			SetItemText(itemnr,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOAUTONORMAL));
		else if (file->GetPriority() == PR_HIGH)
			SetItemText(itemnr,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOAUTOHIGH));
		else if (file->GetPriority() == PR_VERYHIGH)
			SetItemText(itemnr,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOAUTORELEASE));
	} 
	else 
	{
		CString sPriority;
		if (file->GetPriority() == PR_VERYLOW)
			sPriority = GetResString(IDS_PRIOVERYLOW);
		else if (file->GetPriority() == PR_LOW)
			sPriority = GetResString(IDS_PRIOLOW);
		else if (file->GetPriority() == PR_NORMAL)
			sPriority = GetResString(IDS_PRIONORMAL);
		else if (file->GetPriority() == PR_HIGH)
			sPriority = GetResString(IDS_PRIOHIGH);
		else if (file->GetPriority() == PR_VERYHIGH)
			sPriority = GetResString(IDS_PRIORELEASE);
#if JUMPSTART
		if (file->GetJumpstartEnabled()) {
			buffer.Format(_T("%s[%s]"), GetResString(IDS_PRIOJUMPSTART),sPriority);
			sPriority = buffer; //added BavarianSnail
		}
#endif
		SetItemText(itemnr,SFL_COLUMN_PRIORITY, sPriority);
	}

	/*if (file->GetPermissions() == PERM_NOONE)
		SetItemText(itemnr,SFL_COLUMN_PERMISSION,"Hidden");
	else if (file->GetPermissions() == PERM_FRIENDS)
		SetItemText(itemnr,SFL_COLUMN_PERMISSION,"Friends Only");
	else
		SetItemText(itemnr,SFL_COLUMN_PERMISSION,"Public Shared");*/
	SetItemText(itemnr,SFL_COLUMN_PERMISSION,GetResString(IDS_FSTATUS_PUBLIC));	
	SetItemText(itemnr,SFL_COLUMN_FILEID,FileHashToString(file->GetFileHash()));

	uint64 a=file->statistic.GetRequests();			//katsyonak - 4GB bugfix
	uint64 b=file->statistic.GetAllTimeRequests();
	if(a || b)
		buffer.Format(_T("%I64u (%I64u)"), a, b);	//Cax2 - display bugfix
	else
		buffer = _T("");
	SetItemText(itemnr, SFL_COLUMN_REQUESTS, buffer);

	a=file->statistic.GetAccepts();
	b=file->statistic.GetAllTimeAccepts();
	if(a || b)
		buffer.Format(_T("%I64u (%I64u)"), a, b);	//Cax2 - display bugfix
	else
		buffer = _T("");
	SetItemText(itemnr, SFL_COLUMN_ACCEPTED, buffer);
	
	a=file->statistic.GetTransferred();
	b=file->statistic.GetAllTimeTransferred();
	if(a || b)
	{
		buffer.Format(_T("%s (%s)"), CastItoXBytes(a), CastItoXBytes(b));
	}
	else
		buffer = _T("");
	SetItemText(itemnr, SFL_COLUMN_TRANSFERRED, buffer);

	//--- upload column text, or no text if 0 ---
	a=file->GetFileSize();
	b=file->statistic.GetAllTimeTransferred();
	double	cr=file->statistic.GetCompleteReleases();
	if(a && cr+b!=0.0 )
		buffer.Format(_T("%0.2f (%0.2f)"), cr, (double)b/a);
	else
		buffer = _T("");
	SetItemText(itemnr,SFL_COLUMN_UPLOADS,buffer);

	//--- kids/parts open? ---
	sfl_itemdata* itemdataParent=(sfl_itemdata*)GetItemData(itemnr);
	if(itemdataParent->isOpen)
	{
		//--- update all parts ---
		for(uint16 part=0; part<itemdataParent->parts; part++)
		{
			sfl_itemdata* itemdata=(sfl_itemdata*)GetItemData(itemnr+1+part);

			//--- xrmb:partprio ---
			switch(file->GetPartStatus(itemdata->part)) 
			{
			case PR_PART_ON:
				SetItemText(itemnr+1+part, SFL_COLUMN_PRIORITY, _T(""));
				break;
			
			case PR_PART_HIDDEN:
				SetItemText(itemnr+1+part, SFL_COLUMN_PRIORITY, GetResString(IDS_HIDDEN));
				break;

			case PR_PART_OFF:
				SetItemText(itemnr+1+part, SFL_COLUMN_PRIORITY, GetResString(IDS_SF_BLOCKED));
				break;
			}

			/*
			switch(file->GetPartPriority(itemdata->part)) 
			{
			case PR_VERYLOW:
				SetItemText(itemnr+1+part, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIOVERYLOW));
				break;

			case PR_LOW:
				SetItemText(itemnr+1+part, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIOLOW));
				break;

			case PR_NORMAL:
				SetItemText(itemnr+1+part, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIONORMAL));
				break;

			case PR_HIGH:
				SetItemText(itemnr+1+part, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIOHIGH));
				break;

			case PR_VERYHIGH:
				SetItemText(itemnr+1+part, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIORELEASE));
				break;
			}
			*/
			//--- :xrmb ---

			//--- column accepted ---
			uint32	as=file->statistic.GetPartAccepted(itemdata->part, true);
			uint32	a=file->statistic.GetPartAccepted(itemdata->part, false);
			if(as || a)
				buffer.Format(_T("%i (%i)"), as, a);
			else
				buffer = _T("");
			SetItemText(itemnr+1+part, SFL_COLUMN_ACCEPTED, buffer);

			//--- column transferred ---
			uint32 ts=file->GetPartTraffic(itemdata->part, true);
			uint32 t=file->GetPartTraffic(itemdata->part);
			if(ts || t)
			{
				buffer.Format(_T("%s (%s)"), CastItoXBytes(ts), CastItoXBytes(t));
			}
			else
				buffer = _T("");
			SetItemText(itemnr+1+part, SFL_COLUMN_TRANSFERRED, buffer);

			//--- column complete releases ---
			double	cr=file->statistic.GetCompletePartReleases(itemdata->part);
			if(ts || cr!=0.0)
				buffer.Format(_T("%0.2f (%0.2f)"), cr, (double)t/file->GetPartSize(itemdata->part));
			else
				buffer = _T("");
			SetItemText(itemnr+1+part, SFL_COLUMN_UPLOADS, buffer);

			//--- redraw bar ---
			//itemdata->repaintBar=true;
		}
	}

	// netwolf: completesrc (zegzav) - BEGIN
	if (file->IsPartFile())
	{
		buffer.Format(_T("%u"), ((CPartFile*)file)->GetCompleteSourcesCount());
	}
	else
	{
		uint16 nCompleteSourcesCountLo, nCompleteSourcesCountHi;
		file->GetCompleteSourcesRange(&nCompleteSourcesCountLo, &nCompleteSourcesCountHi);
		if (nCompleteSourcesCountLo == 0)
		{
			if (nCompleteSourcesCountHi == 0)
				buffer= _T("");
			else
				buffer.Format(_T("< %u"), nCompleteSourcesCountHi);
		}
		else if (nCompleteSourcesCountLo == nCompleteSourcesCountHi)
			buffer.Format(_T("%u"), nCompleteSourcesCountLo);
		else
			buffer.Format(_T("%u - %u"), nCompleteSourcesCountLo, nCompleteSourcesCountHi);
	}
	SetItemText(itemnr,SFL_COLUMN_COMPLETESRC,buffer);
	// netwolf: completesrc (zegzav) - END

	//--- good time for a resort ---

	//	MOREVIT - Ok, a little kludgy but this should prevent resorts during extended selection
	//		causing the selection to be cleared.
	bool	isShift = GetAsyncKeyState(VK_SHIFT) < 0;

	if (resort && !isShift)
		SortItems(&SortProc, (LPARAM)&m_listSorter);

	EMULE_CATCH
}

void CSharedFilesCtrl::ShowFile(CKnownFile* file, bool resort)
{
	ShowFile(file, GetItemCount(), resort);
}

void CSharedFilesCtrl::ShowFile(CKnownFile* file, uint32 itemnr, bool resort)
{
	EMULE_TRY

	if(file == NULL)
		return;

	sfl_itemdata	*itemdata=new sfl_itemdata;
	
	itemdata->isFile=true;
	itemdata->isOpen=false;
	itemdata->knownFile=file;
	itemdata->part=0;
	itemdata->parts=0;
	
	itemnr=InsertItem(LVIF_TEXT|LVIF_PARAM, itemnr, LPSTR_TEXTCALLBACK, 0, 0, 0, (LPARAM)itemdata);
	UpdateFile(file, itemnr, resort);
	ShowFilesCount();

	EMULE_CATCH
}

void CSharedFilesCtrl::RemoveFile(CKnownFile *toRemove) 
{
	EMULE_TRY

	if(toRemove == NULL)
		return;

	sfl_itemdata*	itemdata;
	for(int nItem=0; nItem<GetItemCount(); nItem++)
	{
		itemdata=(sfl_itemdata*)GetItemData(nItem);
		if(itemdata->isFile && itemdata->knownFile==toRemove)
		{
			//--- delete all part-childs ---
			if(itemdata->isOpen)
			{
				for(uint16 part=0; part<itemdata->parts; part++)
				{
					sfl_itemdata* itemdataPart=(sfl_itemdata*)GetItemData(nItem+1);
					if (itemdataPart->isFile) break;	//Cax2 14/01/03	bugfix
					SetItemData(nItem+1, NULL);
					DeleteItem(nItem+1);
					if(itemdataPart) delete itemdataPart;
				}
			}

			SetItemData(nItem, NULL);
			DeleteItem(nItem);
			if(itemdata) delete itemdata;
		}
	}
	ShowFilesCount();

	EMULE_CATCH
}

BOOL CSharedFilesCtrl::DeleteAllItems()
{
	EMULE_TRY

	sfl_itemdata *itemdata;
	for(int i=GetItemCount(); i>0; i--)
	{
		itemdata=(sfl_itemdata *)GetItemData(i-1);
		SetItemData(i-1, NULL);
		//DeleteItem(i-1);
		if(itemdata) delete itemdata;
	}
	return CListCtrl::DeleteAllItems();
	//return true;

	EMULE_CATCH

	return false;
}

void CSharedFilesCtrl::OnContextMenu(CWnd* pWnd, CPoint point)
{
	EMULE_TRY
	
	if(m_pSCM)
	{
		delete m_pSCM;
		m_pSCM=NULL;
	}

	int iSel = GetSelectionMark();

	if (iSel == -1)
		return;

	sfl_itemdata *itemdata=(sfl_itemdata *)GetItemData(iSel);

	bool justOne=(GetSelectedCount()==1); //Cax2 faster code
	bool None=(GetSelectedCount()==0);

	CTitleMenu	   	m_SharedFilesMenu;
	CMenu		   	m_menuPriority;
	CMenu		   	m_PermMenu;
	CMenu			m_ed2kMenu;
	CMenu			scm;

	m_SharedFilesMenu.CreatePopupMenu();
	//--- xrmb:allyaknow ---
	if(m_allYaKnow)
		m_SharedFilesMenu.AddMenuTitle(GetResString(IDS_KNOWNFILES));
	else
	//--- :xrmb ---
		m_SharedFilesMenu.AddMenuTitle(GetResString(IDS_SHAREDFILES));
	
	// add priority switcher
	//--- xrmb:allyaknow ---
	if(!None)
	{
		if(m_allYaKnow==false)
		{
		//--- :xrmb ---
			if(itemdata->isFile)
			{
				m_menuPriority.CreateMenu();
				m_menuPriority.AppendMenu(MF_STRING,MP_PRIOVERYLOW,GetResString(IDS_PRIOVERYLOW));
				m_menuPriority.AppendMenu(MF_STRING,MP_PRIOLOW,GetResString(IDS_PRIOLOW));
				m_menuPriority.AppendMenu(MF_STRING,MP_PRIONORMAL,GetResString(IDS_PRIONORMAL));
				m_menuPriority.AppendMenu(MF_STRING,MP_PRIOHIGH, GetResString(IDS_PRIOHIGH));
				m_menuPriority.AppendMenu(MF_STRING,MP_PRIOVERYHIGH, GetResString(IDS_PRIORELEASE));
				m_menuPriority.AppendMenu(MF_STRING,MP_PRIOAUTO, GetResString(IDS_PRIOAUTO));
#if JUMPSTART
				if(!itemdata->knownFile->IsPartFile()) {
	                m_menuPriority.AppendMenu(MF_STRING|MF_SEPARATOR);
					m_menuPriority.AppendMenu(MF_STRING,MP_JUMPSTART, _T("Jumpstart"));
					m_menuPriority.CheckMenuItem(MP_JUMPSTART,itemdata->knownFile->GetJumpstartEnabled()?MF_CHECKED:MF_UNCHECKED);
				}
#endif
				m_SharedFilesMenu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_menuPriority.m_hMenu, GetResString(IDS_PRIORITY));
			}
			else
			{
				m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_PARTON, GetResString(IDS_SF_PARTON));
				m_SharedFilesMenu.EnableMenuItem(MP_SFL_PARTON,itemdata->knownFile->IsPartFile() ? MF_GRAYED:MF_ENABLED);
				m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_PARTHIDDEN, GetResString(IDS_SF_PARTHIDDEN));
				m_SharedFilesMenu.EnableMenuItem(MP_SFL_PARTHIDDEN,itemdata->knownFile->IsPartFile() ? MF_GRAYED:MF_ENABLED);
				m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_PARTOFF, GetResString(IDS_SF_PARTOFF));
				m_SharedFilesMenu.EnableMenuItem(MP_SFL_PARTOFF,itemdata->knownFile->IsPartFile() ? MF_GRAYED:MF_ENABLED);
			}

			if(itemdata->isFile)
			{
				// add permission switcher
				m_PermMenu.CreateMenu();
				m_PermMenu.AppendMenu(MF_STRING,MP_PERMNONE,	GetResString(IDS_FSTATUS_LOCKED));
				m_PermMenu.AppendMenu(MF_STRING,MP_PERMFRIENDS,	GetResString(IDS_FSTATUS_FRIENDSONLY));
				m_PermMenu.AppendMenu(MF_STRING,MP_PERMALL,		GetResString(IDS_FSTATUS_PUBLIC));

				// todo enable when it works
				//m_SharedFilesMenu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_PermMenu.m_hMenu, (LPCTSTR)"Permissions");
				m_SharedFilesMenu.EnableMenuItem((UINT_PTR)m_menuPriority.m_hMenu,None ? MF_GRAYED:MF_ENABLED);
				m_SharedFilesMenu.AppendMenu(MF_STRING|MF_SEPARATOR);
				if(justOne && !itemdata->knownFile->IsPartFile())
				{
					CString buffer = itemdata->knownFile->GetPath();				
					if (buffer.Right(1) != '\\')
						buffer += '\\';
					buffer += itemdata->knownFile->GetFileName();
					m_pSCM = new CShellContextMenu(m_hWnd,buffer);				
					scm.CreateMenu();
					m_pSCM->SetMenu(&scm);
					m_SharedFilesMenu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)scm.m_hMenu, GetResString(IDS_SHELLCONTEXT));
				}
				else
					m_SharedFilesMenu.AppendMenu(MF_STRING|MF_GRAYED,NULL, GetResString(IDS_SHELLCONTEXT));
				m_SharedFilesMenu.AppendMenu(MF_STRING,MP_OPENFOLDER, GetResString(IDS_OPENFOLDER) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexShOpenFolder),SSP_TAB_PREFIX));
				m_SharedFilesMenu.EnableMenuItem(MP_OPENFOLDER,((itemdata->knownFile->IsPartFile() || !(justOne)) ? MF_GRAYED:MF_ENABLED));
				m_SharedFilesMenu.AppendMenu(MF_STRING,MP_CMT, GetResString(IDS_CMT_ADD) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexShComments),SSP_TAB_PREFIX));
				m_SharedFilesMenu.EnableMenuItem(MP_CMT,(justOne) ? MF_ENABLED:MF_GRAYED);
				m_SharedFilesMenu.CheckMenuItem(MP_CMT, itemdata->knownFile->GetFileComment().IsEmpty() ? MF_UNCHECKED:MF_CHECKED);
				m_SharedFilesMenu.AppendMenu(MF_STRING,MP_FAKE_REPORT,GetResString(IDS_FAKE_REPORT)); //FakeCheck
			}

			//This menu option is is for testing..
			//m_SharedFilesMenu.AppendMenu(MF_STRING,Irc_SetSendLink,GetResString(IDS_IRC_ADDLINKTOIRC)); 
			
			m_SharedFilesMenu.AppendMenu(MF_STRING|MF_SEPARATOR); 

			//--- context menu for a shared file ---
			if(itemdata->isFile)
			{
				if(justOne)
					m_menuPriority.EnableMenuItem(MP_PRIOAUTO,((g_eMuleApp.m_pGlobPrefs->IsUAPEnabled()) && (itemdata->knownFile->IsPartFile())) ? MF_ENABLED:MF_GRAYED);
				else
					m_menuPriority.EnableMenuItem(MP_PRIOAUTO,g_eMuleApp.m_pGlobPrefs->IsUAPEnabled() ? MF_ENABLED:MF_GRAYED);
			}

			//--- context menu for a part of a file ---
			else
			{
				//--- feel free to add something ---
			}

		//--- xrmb:allyaknow ---
		}
		//--- :xrmb ---
	}

	m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_CLEARALLSTATS, GetResString(IDS_SF_RESETALLSTATS));
	m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_CLEARSTATS, GetResString(IDS_SF_RESETSESSTATS));

	//--- xrmb:allyaknow ---
	m_SharedFilesMenu.AppendMenu(MF_STRING|MF_SEPARATOR); 
	if(m_allYaKnow)
	{
		m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_DELKNOWN, GetResString(IDS_SF_DELETE));
		m_SharedFilesMenu.AppendMenu(MF_STRING|MF_SEPARATOR); 
		m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_MERGEKNOWN, GetResString(IDS_SF_MERGE));
		m_SharedFilesMenu.AppendMenu(MF_STRING|MF_SEPARATOR); 
		m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_ALLYAKNOW, GetResString(IDS_SF_SHOWALLSF));
	}
	else
		m_SharedFilesMenu.AppendMenu(MF_STRING, MP_SFL_ALLYAKNOW, GetResString(IDS_SF_SHOWALLKF));
	//--- :xrmb ---

	if(!None)
	{
		m_SharedFilesMenu.AppendMenu(MF_STRING|MF_SEPARATOR); 

		m_ed2kMenu.CreateMenu();
		m_ed2kMenu.AppendMenu(MF_STRING,MP_GETED2KLINK, GetResString(IDS_DL_LINK1) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexShED2KLink),SSP_TAB_PREFIX));
		m_ed2kMenu.AppendMenu(MF_STRING,MP_GETHTMLED2KLINK, GetResString(IDS_DL_LINK2) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexShED2kLinkHtml),SSP_TAB_PREFIX));
		m_ed2kMenu.AppendMenu(MF_STRING,MP_GETSOURCEED2KLINK, GetResString(IDS_CREATESOURCELINK) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexShED2kLinkSource),SSP_TAB_PREFIX));
		m_SharedFilesMenu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_ed2kMenu.m_hMenu, GetResString(IDS_ED2KLINKFIX));
		m_SharedFilesMenu.EnableMenuItem((UINT_PTR)m_ed2kMenu.m_hMenu,None ? MF_GRAYED:MF_ENABLED);
	}

	int counter;
	CMenu m_menuWeb;
	m_menuWeb.CreateMenu();
	UpdateURLMenu(m_menuWeb,counter);
	UINT flag2;
	flag2=(counter==0) ? MF_GRAYED:MF_STRING;

	if(!None)
	{
		m_SharedFilesMenu.AppendMenu(flag2|MF_POPUP,(UINT_PTR)m_menuWeb.m_hMenu, GetResString(IDS_WEBSERVICES));
		m_SharedFilesMenu.EnableMenuItem((UINT_PTR)m_menuWeb.m_hMenu,justOne ? MF_ENABLED:MF_GRAYED);
	}

	m_SharedFilesMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON,point.x,point.y,this);
	m_menuWeb.DestroyMenu();
	m_SharedFilesMenu.DestroyMenu();

	if(m_pSCM)
		m_pSCM->CleanUp();

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CSharedFilesCtrl::OnWndMsg(UINT iMessage,WPARAM wParam, LPARAM lParam, LRESULT *pResult)
{
	BOOL		bHandled = FALSE;

	EMULE_TRY

	switch (iMessage)
	{
		case WM_SFL_UPDATEOFFEREDITEMS:
		{
			UpdateOfferedItems();
			bHandled = true;
			break;
		}
		case WM_SFL_UPDATEITEM:
		{
			CKnownFile		*pKnownFile = reinterpret_cast<CKnownFile*>(lParam);
			bool			bResort = static_cast<bool>(wParam);

			UpdateItem(pKnownFile,bResort);
			bHandled = true;
			break;
		}
	}

	EMULE_CATCH

	if (!bHandled)
	{
		bHandled = CMuleListCtrl::OnWndMsg(iMessage,wParam,lParam,pResult);
	}

	return bHandled;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CSharedFilesCtrl::OnCommand(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	CString buffer = _T("");
	int iSel = GetSelectionMark();
	if (iSel == -1)
		return false;

	sfl_itemdata* itemdata=(sfl_itemdata*)GetItemData(iSel);
	CKnownFile* file=itemdata->knownFile;
		if (wParam>=MP_WEBURL && wParam<=MP_WEBURL+64) {
			RunURL(file, g_eMuleApp.m_strWebServiceURLArray.GetAt(wParam-MP_WEBURL) );
		}

	// for multiple selections 
	UINT selectedCount = GetSelectedCount(); 
	CArray<CKnownFile*,CKnownFile*> selectedList;
	POSITION pos=GetFirstSelectedItemPosition();
	while(pos)
	{
		int iSel=GetNextSelectedItem(pos);
		itemdata=(sfl_itemdata*)GetItemData(iSel);

		//--- file selection? ---
		if(itemdata->isFile)
		{
			selectedList.Add(itemdata->knownFile);
		}
	}

	switch (wParam)
	{
		case Irc_SetSendLink:
				if(selectedCount > 1) break;
				g_eMuleApp.m_pdlgEmule->m_wndIRC.SetSendFileString(file->CreateED2kLink());
				break;
		case MP_GETED2KLINK:
				{
					CString str;
					while(selectedList.GetCount())
					{
						str += selectedList.ElementAt(0)->CreateED2kLink();
						selectedList.RemoveAt(0);
						if(!selectedList.IsEmpty())
							str += "\n";
					}
					g_eMuleApp.CopyTextToClipboard(str);
					break;
				}

		case MP_GETHTMLED2KLINK:
				{
					CString str;
					while(selectedList.GetCount())
					{
						str += selectedList.ElementAt(0)->CreateHTMLED2kLink();
						selectedList.RemoveAt(0);
						if(!selectedList.IsEmpty())
							str += "\n";
					}
				    g_eMuleApp.CopyTextToClipboard(str);
					break;
				}

		case MP_GETSOURCEED2KLINK:
				{
#ifdef OLD_SOCKETS_ENABLED
					if (g_eMuleApp.m_pServerConnect->IsConnected() || !g_eMuleApp.m_pServerConnect->IsLowID())
					{
						CString str;
						while(selectedList.GetCount())
						{
							str += selectedList.ElementAt(0)->CreateED2kSourceLink();
							selectedList.RemoveAt(0);
							if(!selectedList.IsEmpty())
								str += "\n";
						}
					    g_eMuleApp.CopyTextToClipboard(str);
					}
					else
#endif //OLD_SOCKETS_ENABLED
						AfxMessageBox(GetResString(IDS_SOURCELINKFAILED));
				}
				break;
				//MORPH START - Added by milobac, FakeCheck, FakeReport, Auto-updating
		case MP_FAKE_REPORT:
			{
				if(selectedCount > 1)
				{
					POSITION pos = this->GetFirstSelectedItemPosition();
					while( pos != NULL )
					{
						file = (CKnownFile*)this->GetItemData(GetNextSelectedItem(pos));
					}
					break; 
				}
				ShellExecute(NULL, NULL, "http://donkeyfakes.gambri.net/report/index.php?link2="+file->CreateED2kLink(), NULL, g_eMuleApp.m_pGlobPrefs->GetAppDir(), SW_SHOWDEFAULT);
				break;
			}
		case MP_OPEN:
			{
				if(selectedCount > 1) break;
				buffer.Format(_T("%s\\%s"),file->GetPath(),file->GetFileName());
				AddLogLine( false, buffer);
				ShellOpenFile(buffer);				
			}
			break; 

		case MP_OPENFOLDER:
			{
				if(selectedCount > 1) break;
				ShellOpenFile(file->GetPath());
			}
			break;

		case MP_CMT: 
			{ 
				if(selectedCount > 1) break;
				CCommentDialog dialog(file); 
				dialog.DoModal(); 
   			} 
			break; 

		//--- xrmb:allyaknow ---
		case MP_SFL_ALLYAKNOW:
			if(m_allYaKnow)
				ShowFileList(g_eMuleApp.m_pSharedFilesList);
			else
				ShowKnownList();
			break;

		case MP_SFL_MERGEKNOWN:
			DeleteAllItems();
			g_eMuleApp.m_pKnownFilesList->merge();
			ShowKnownList();
			break;

		case MP_SFL_DELKNOWN:
			{
				//--- TODO: ask if really delete ---
				while(selectedList.GetCount())
				{
					RemoveFile(selectedList.ElementAt(0));
					g_eMuleApp.m_pKnownFilesList->RemoveFile(selectedList.ElementAt(0));
					selectedList.RemoveAt(0);
				}
			}
			break;
		//--- :xrmb ---

		case MP_SFL_CLEARSTATS:
		case MP_SFL_CLEARALLSTATS:
			{
				//--- TODO: ask if really erase ---

				bool		all=(wParam==MP_SFL_CLEARALLSTATS);
				CKnownFile	*lastfile=NULL;

				POSITION	pos=GetFirstSelectedItemPosition();
				while(pos)
				{
					int iSel=GetNextSelectedItem(pos);

					itemdata=(sfl_itemdata*)GetItemData(iSel);
					file=itemdata->knownFile;

					//--- file selection? ---
					if(itemdata->isFile)
						itemdata->knownFile->statistic.resetStats(all);

					//--- part selection ---
					else
						itemdata->knownFile->statistic.resetPartTraffic(itemdata->part, all);

					if(file!=lastfile)
					{
						if(lastfile)
							UpdateItem(lastfile, false);
						lastfile=file;
					}
				}

				if(lastfile)
					UpdateItem(lastfile, true);
				RedrawItems(0, GetItemCount());
			}
			break;

		case MP_PRIOVERYLOW:
		case MP_PRIOLOW:
		case MP_PRIONORMAL:
		case MP_PRIOHIGH:
		case MP_PRIOVERYHIGH:
		case MP_PRIOAUTO:
			{
				POSITION pos = GetFirstSelectedItemPosition();
				while(pos != NULL)
				{ 
					int iSel=this->GetNextSelectedItem(pos);

					itemdata=(sfl_itemdata*)GetItemData(iSel);
					file=itemdata->knownFile;

					//--- is there a part in selection? ---
					if(itemdata->isFile)
					{
						file->SetAutoPriority(false);

						switch (wParam) 
						{
							case MP_PRIOVERYLOW: 
								file->SetPriority(PR_VERYLOW);
								#if JUMPSTART
								if (file->GetJumpstartEnabled()) 
									buffer.Format(_T("%s[%s]"),GetResString(IDS_PRIOJUMPSTART),GetResString(IDS_PRIOVERYLOW));
								else
								#endif
									buffer.Format(_T("%s"),GetResString(IDS_PRIOVERYLOW));					
								//SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOVERYLOW));
								break;
							case MP_PRIOLOW:
								file->SetPriority(PR_LOW);
								#if JUMPSTART
								if (file->GetJumpstartEnabled()) 
									buffer.Format(_T("%s[%s]"),GetResString(IDS_PRIOJUMPSTART),GetResString(IDS_PRIOLOW));
								else
								#endif
									buffer.Format(_T("%s"),GetResString(IDS_PRIOLOW));
								//SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOLOW));
								break;

							case MP_PRIONORMAL:
								file->SetPriority(PR_NORMAL);
								#if JUMPSTART
								if (file->GetJumpstartEnabled()) 
									buffer.Format(_T("%s[%s]"),GetResString(IDS_PRIOJUMPSTART),GetResString(IDS_PRIONORMAL));
								else
								#endif
									buffer.Format(_T("%s"),GetResString(IDS_PRIONORMAL));
								//SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIONORMAL));
								break;	

							case MP_PRIOHIGH:
								file->SetPriority(PR_HIGH);
								#if JUMPSTART
								if (file->GetJumpstartEnabled()) 
									buffer.Format(_T("%s[%s]"),GetResString(IDS_PRIOJUMPSTART),GetResString(IDS_PRIOHIGH));
								else
								#endif
									buffer.Format(_T("%s"),GetResString(IDS_PRIOHIGH));
								//SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOHIGH));
								break;

							case MP_PRIOVERYHIGH:
								file->SetPriority(PR_VERYHIGH);
								#if JUMPSTART
								if (file->GetJumpstartEnabled()) 
									buffer.Format(_T("%s[%s]"),GetResString(IDS_PRIOJUMPSTART),GetResString(IDS_PRIORELEASE));
								else
								#endif
									buffer.Format(_T("%s"),GetResString(IDS_PRIORELEASE));
								//SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIORELEASE));
								break;

							case MP_PRIOAUTO:
								if (file->IsPartFile())
								{
									file->SetAutoPriority(true);
									file->UpdateUploadAutoPriority(); 
									switch(file->GetPriority())
									{
										case PR_VERYHIGH:
											#if JUMPSTART
											if (file->GetJumpstartEnabled()) 
												buffer.Format(_T("%s[%s]"),GetResString(IDS_PRIOJUMPSTART),GetResString(IDS_PRIOAUTORELEASE));
											else
											#endif
												buffer.Format(_T("%s"),GetResString(IDS_PRIOAUTORELEASE));
											//SetItemText(iSel, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIOAUTORELEASE));
											break;

										case PR_HIGH:
											#if JUMPSTART
											if (file->GetJumpstartEnabled()) 
												buffer.Format(_T("%s[%s]"),GetResString(IDS_PRIOJUMPSTART),GetResString(IDS_PRIOAUTOHIGH));
											else
											#endif
												buffer.Format(_T("%s"),GetResString(IDS_PRIOAUTOHIGH));
											//SetItemText(iSel, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIOAUTOHIGH));
											break;
							
										case PR_NORMAL:
											#if JUMPSTART
											if (file->GetJumpstartEnabled()) 
												buffer.Format(_T("%s[%s]"),GetResString(IDS_PRIOJUMPSTART),GetResString(IDS_PRIOAUTONORMAL));
											else
											#endif
												buffer.Format(_T("%s"),GetResString(IDS_PRIOAUTONORMAL));
											//SetItemText(iSel, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIOAUTONORMAL));
											break;
									}
								}
								break;
						}

						SetItemText(iSel,SFL_COLUMN_PRIORITY, buffer);
						
					}
					//--- xrmb:partprio ---
					/*
					else
					{
						switch(wParam)
						{
						case MP_PRIOVERYLOW:
							file->SetPartPriority(itemdata->part, PR_VERYLOW);
							SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOVERYLOW));
							break;

						case MP_PRIOLOW:
							file->SetPartPriority(itemdata->part, PR_LOW);
							SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOLOW));
							break;

						case MP_PRIONORMAL:
							file->SetPartPriority(itemdata->part, PR_NORMAL);
							SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIONORMAL));
							break;	

						case MP_PRIOHIGH:
							file->SetPartPriority(itemdata->part, PR_HIGH);
							SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOHIGH));
							break;

						case MP_PRIOVERYHIGH:
							file->SetPartPriority(itemdata->part, PR_VERYHIGH);
							SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIORELEASE));
							break;
						}
					}
				*/
				//--- :xrmb ---
				}
			}	
			break;
	
		//--- xrmb:partprio ---
		case MP_SFL_PARTON:
		case MP_SFL_PARTOFF:
		case MP_SFL_PARTHIDDEN:
			{
				uint8	setTo;
				switch(wParam)
				{
					case MP_SFL_PARTON:
						setTo=PR_PART_ON;
						break;

					case MP_SFL_PARTOFF:
						setTo=PR_PART_OFF;
						break;

					case MP_SFL_PARTHIDDEN:
						setTo=PR_PART_HIDDEN;
						break;

				}

				POSITION pos=GetFirstSelectedItemPosition();
				while(pos)
				{
					int iSel=GetNextSelectedItem(pos);
					itemdata=(sfl_itemdata*)GetItemData(iSel);
					file=itemdata->knownFile;
					if(itemdata->isFile==false)
					{
						if(file->IsPartFile()==false) 
						{
							file->SetPartStatus(itemdata->part, setTo);
							switch(setTo)
							{
								case PR_PART_ON:
									SetItemText(iSel, SFL_COLUMN_PRIORITY, _T(""));
									break;

								case PR_PART_OFF:
									SetItemText(iSel, SFL_COLUMN_PRIORITY, _T("blocked"));
									break;

								case PR_PART_HIDDEN:
									SetItemText(iSel, SFL_COLUMN_PRIORITY, _T("hidden"));
									break;
							}
						}
					}
				}	
				RedrawItems(0, GetItemCount());
			}
			break;
		//--- :xrmb ---

		case MP_PERMNONE:
			if (((CPartFile*)file)->IsPartFile())
				AfxMessageBox(GetResString(IDS_ERR_NOPRIMCHANGE));
			else
			{	
				file->SetPermissions(PERM_NOONE);
				SetItemText(iSel,SFL_COLUMN_PERMISSION,GetResString(IDS_HIDDEN));
			}
			break;

		case MP_PERMFRIENDS:
			if (((CPartFile*)file)->IsPartFile())
				AfxMessageBox(GetResString(IDS_ERR_NOPRIMCHANGE));
			else
			{	
				file->SetPermissions(PERM_FRIENDS);
				SetItemText(iSel,SFL_COLUMN_PERMISSION,GetResString(IDS_FSTATUS_FRIENDSONLY));	
			}
			break;

		case MP_PERMALL:
			file->SetPermissions(PERM_ALL);
			SetItemText(iSel, SFL_COLUMN_PERMISSION, GetResString(IDS_FSTATUS_PUBLIC));
			break;
#if JUMPSTART
        case MP_JUMPSTART:
			{
				BOOL alreadyasked = FALSE;
				BOOL alreadynotified = FALSE;
				INT msgyes = 0;
				POSITION pos = GetFirstSelectedItemPosition();
				while(pos != NULL)
				{ 
					int iSel=this->GetNextSelectedItem(pos);

					itemdata=(sfl_itemdata*)GetItemData(iSel);
					file=itemdata->knownFile;

					//--- is there a part in selection? ---
					if(itemdata->isFile && !itemdata->knownFile->IsPartFile())
					{
						if(file->GetJumpstartEnabled())
						{
							if(alreadyasked != TRUE)
							{
								msgyes = AfxMessageBox(GetResString(IDS_JS_DISABLE), MB_YESNO|MB_ICONEXCLAMATION|MB_DEFBUTTON2);
								alreadyasked = TRUE;
							}

							if(msgyes == IDYES)
							{
								file->SetJumpstartEnabled(false);
								switch(file->GetPriority())
								{
									case PR_VERYLOW:
										SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOVERYLOW));
										break;
									case PR_LOW:
										SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOLOW));
										break;
									case PR_NORMAL:
										if (file->IsAutoPrioritized())
											SetItemText(iSel, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIOAUTONORMAL));
										else
											SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIONORMAL));
										break;	
									case PR_HIGH:
										if (file->IsAutoPrioritized())
											SetItemText(iSel, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIOAUTOHIGH));
										else
											SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIOHIGH));
										break;
									case PR_VERYHIGH:
										if (file->IsAutoPrioritized())
											SetItemText(iSel, SFL_COLUMN_PRIORITY, GetResString(IDS_PRIOAUTORELEASE));
										else
											SetItemText(iSel,SFL_COLUMN_PRIORITY,GetResString(IDS_PRIORELEASE));
										break;
								}
							}
						} 
						else
						{
							if(file->IsJsComplete())
							{
								if(alreadynotified != TRUE)
								{
									AfxMessageBox(GetResString(IDS_JS_COMPLETE), MB_OK|MB_ICONSTOP);
									alreadynotified = TRUE;
								}
							}
							else
							{
								file->SetJumpstartEnabled(true);
								switch(file->GetPriority())
								{
									case PR_VERYLOW:
										buffer.Format(_T("%s[%s]"),GetResString(IDS_PRIOJUMPSTART), GetResString(IDS_PRIOVERYLOW));
										break;
									case PR_LOW:
										buffer.Format(_T("%s[%s]"),GetResString(IDS_PRIOJUMPSTART), GetResString(IDS_PRIOLOW));
										break;
									case PR_NORMAL:
										buffer.Format(_T("%s[%s]"),GetResString(IDS_PRIOJUMPSTART), GetResString(IDS_PRIONORMAL));
										break;	
									case PR_HIGH:
										buffer.Format(_T("%s[%s]"),GetResString(IDS_PRIOJUMPSTART), GetResString(IDS_PRIOHIGH));
										break;
									case PR_VERYHIGH:
										buffer.Format(_T("%s[%s]"),GetResString(IDS_PRIOJUMPSTART), GetResString(IDS_PRIORELEASE));
										break;
								}
								SetItemText(iSel,SFL_COLUMN_PRIORITY, buffer);
							}
						}
					}
				}
			}
			break;
#endif
		default:
			if(m_pSCM)
				if(m_pSCM->IsMenuCommand(wParam))
					m_pSCM->InvokeCommand(wParam, file);
			break;
	}

	return true;

	EMULE_CATCH

	return false;
}

//--- i replaced the sorting, too much hassles ---
void CSharedFilesCtrl::OnColumnClick( NMHDR* pNMHDR, LRESULT* pResult)
{
	EMULE_TRY

	NMLISTVIEW* pNMListView = (NMLISTVIEW*)pNMHDR;
	m_listSorter.clicked(pNMListView->iSubItem);
	SetSortArrow(pNMListView->iSubItem, m_listSorter.arrow());	
	
	m_sortParts=GetAsyncKeyState(VK_SHIFT) < 0;

	SortItems(&SortProc, (LPARAM)&m_listSorter);	
	g_eMuleApp.m_pGlobPrefs->SetColumnSortItem(CPreferences::TABLE_SHARED, pNMListView->iSubItem);
	g_eMuleApp.m_pGlobPrefs->SetColumnSortAscending(CPreferences::TABLE_SHARED, m_listSorter.dir());
	*pResult = 0;

	EMULE_CATCH
}

int CSharedFilesCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	EMULE_TRY

	//--- it happens :( ---
	if(lParam1==NULL || lParam2==NULL || lParamSort==NULL)
		return 0;

	CListCtrlSorter*	listSorter=(CListCtrlSorter*)lParamSort;
	int tmp;	//Cax2 patch 05/01/03
	sfl_itemdata*	item1;
	sfl_itemdata*	item2;
	if(listSorter->dir())
	{ 
		item1=(sfl_itemdata*)lParam1;
		item2=(sfl_itemdata*)lParam2;	
	}
	else
	{
		item1=(sfl_itemdata*)lParam2;
		item2=(sfl_itemdata*)lParam1;	
	}

	CKnownFile* knownfile1=item1->knownFile;
	CKnownFile* knownfile2=item2->knownFile;	

	//--- it happens :( ---
	if(knownfile1==NULL || knownfile2==NULL)
	        	return 0; 

	//--- some parts to compare? and from same file ---
	if(item1->isFile==false && item2->isFile==false && item1->knownFile==item2->knownFile)
	{
		//--- shiftkey down ---
		if(g_eMuleApp.m_pGlobPrefs->DoUsePT() && m_sortParts)		//Cax2 bugfix 09/01/03
		{
			switch(listSorter->level())
			{
				case 1:
					switch(listSorter->selected())
					{
						case SFL_COLUMN_TRANSFERRED:
							{
								uint32 pt1=knownfile1->GetPartTraffic(item1->part, true);
								uint32 pt2=knownfile2->GetPartTraffic(item2->part, true);

								if(pt1==0 && pt2==0)
								{
									pt1=knownfile1->GetPartTraffic(item1->part);
									pt2=knownfile2->GetPartTraffic(item2->part);

									if(pt1==0 && pt2==0)
										return sortcmp(item1->part, item2->part);

									if(pt1==0)
										return listSorter->dir()?1:-1;

									if(pt2==0)
										return listSorter->dir()?-1:1;

									return sortcmp(pt1, pt2);
								}

								if(pt1==0)
									return listSorter->dir()?1:-1;

								if(pt2==0)
									return listSorter->dir()?-1:1;

								return sortcmp(pt1, pt2);
							}
							break;

						case SFL_COLUMN_PARTTRAFFIC:
						case SFL_COLUMN_UPLOADS:
							return sortcmp(knownfile1->statistic.GetCompletePartReleases(item1->part),
								       knownfile2->statistic.GetCompletePartReleases(item2->part));
							break;

						default:
							return sortcmp(item1->part, item2->part);
					}
					break;

				case 2:
					switch(listSorter->selected())
					{
						case SFL_COLUMN_TRANSFERRED:
							{
								uint32 pt1=knownfile1->GetPartTraffic(item1->part);
								uint32 pt2=knownfile2->GetPartTraffic(item2->part);

								if(pt1==0 && pt2==0)
									return sortcmp(item1->part, item2->part);

								if(pt1==0)
									return listSorter->dir()?1:-1;

								if(pt2==0)
									return listSorter->dir()?-1:1;

								return sortcmp(pt1, pt2);
							}
							break;

						case SFL_COLUMN_PARTTRAFFIC:
						case SFL_COLUMN_UPLOADS:
							{
								double d1=(double)knownfile1->GetPartTraffic(item1->part)/knownfile1->GetPartSize(item1->part);
								double d2=(double)knownfile2->GetPartTraffic(item2->part)/knownfile2->GetPartSize(item2->part);

								return sortcmp(d1, d2);
							}

						default:  
								return sortcmp(item1->part, item2->part);
					}
					break;
			}
		}

		//--- no shift key down, no sorting ---
		else
		{
			if(listSorter->dir())
				return sortcmp(item1->part, item2->part);
			else
				return sortcmp(item2->part, item1->part);
		}
	}

	//--- some other compare ---
	else
	{
		switch(listSorter->level())
		{
			case 1:
				switch(listSorter->selected())
				{
					case SFL_COLUMN_FILENAME:
						return _tcsicmp(knownfile1->GetFileName(), knownfile2->GetFileName());

					case SFL_COLUMN_FILESIZE:
						return sortcmp(knownfile1->GetFileSize(), knownfile2->GetFileSize());

					case SFL_COLUMN_TYPE:
						return _tcsicmp(knownfile1->GetFileType(true), knownfile2->GetFileType(true));

					case SFL_COLUMN_PRIORITY:
						return sortcmp(m_p2p[knownfile1->GetPriority()], m_p2p[knownfile2->GetPriority()]);

					case SFL_COLUMN_PERMISSION:
						return sortcmp(knownfile1->GetPermissions(), knownfile2->GetPermissions());

					case SFL_COLUMN_FILEID:
						return memcmp(knownfile1->GetFileHash(), knownfile2->GetFileHash(), 16);

					case SFL_COLUMN_REQUESTS:
						tmp=sortcmp(knownfile1->statistic.GetRequests(), knownfile2->statistic.GetRequests());
						return (tmp!=0)?tmp:sortcmp(knownfile1->statistic.GetAllTimeRequests(), knownfile2->statistic.GetAllTimeRequests());

					case SFL_COLUMN_ACCEPTED:
						tmp=sortcmp(knownfile1->statistic.GetAccepts(), knownfile2->statistic.GetAccepts());
						return (tmp!=0)?tmp:sortcmp(knownfile1->statistic.GetAllTimeAccepts(), knownfile2->statistic.GetAllTimeAccepts());

					case SFL_COLUMN_TRANSFERRED:
						tmp=sortcmp(knownfile1->statistic.GetTransferred(), knownfile2->statistic.GetTransferred());
						return (tmp!=0)?tmp:sortcmp(knownfile1->statistic.GetAllTimeTransferred(), knownfile2->statistic.GetAllTimeTransferred());

					case SFL_COLUMN_COMPLETESRC:
						{
							double f1= CompleteSourcesCmpValue(knownfile1, false);
							double f2= CompleteSourcesCmpValue(knownfile2, false);
							return sortcmp(f1, f2);	// netwolf: complete sources (zegzav )
						}
					case SFL_COLUMN_PARTTRAFFIC:
					case SFL_COLUMN_UPLOADS:
						{
							tmp=sortcmp(knownfile1->statistic.GetCompleteReleases(), knownfile2->statistic.GetCompleteReleases());
							if (tmp!=0) return tmp;

							double d1=(double)knownfile1->statistic.GetAllTimeTransferred()/knownfile1->GetFileSize();
							double d2=(double)knownfile2->statistic.GetAllTimeTransferred()/knownfile2->GetFileSize();
							return sortcmp(d1, d2);
						}					}

			case 2:
				switch(listSorter->selected())
				{
					case SFL_COLUMN_REQUESTS:
						return sortcmp(knownfile1->statistic.GetAllTimeRequests(), knownfile2->statistic.GetAllTimeRequests());

					case SFL_COLUMN_ACCEPTED:
						return sortcmp(knownfile1->statistic.GetAllTimeAccepts(), knownfile2->statistic.GetAllTimeAccepts());

					case SFL_COLUMN_TRANSFERRED:
						return sortcmp(knownfile1->statistic.GetAllTimeTransferred(), knownfile2->statistic.GetAllTimeTransferred());

					case SFL_COLUMN_COMPLETESRC:
						{
							double f1= CompleteSourcesCmpValue(knownfile1, true);
							double f2= CompleteSourcesCmpValue(knownfile2, true);
							return sortcmp(f1, f2);	// netwolf: complete sources (zegzav )
						}

					case SFL_COLUMN_PARTTRAFFIC:
					case SFL_COLUMN_UPLOADS:
						{
							double d1=(double)knownfile1->statistic.GetAllTimeTransferred()/knownfile1->GetFileSize();
							double d2=(double)knownfile2->statistic.GetAllTimeTransferred()/knownfile2->GetFileSize();

							return sortcmp(d1, d2);
						}
				}
		}
	}

	EMULE_CATCH

	return 0;
}

void CSharedFilesCtrl::UpdateItem(CKnownFile* toupdate, bool resort)
{
	if (!::IsWindow(m_hWnd))	//fix crash at exit [TwoBottle Mod]
		return;

	EMULE_TRY
	
	if(toupdate == NULL)
		return;

	sfl_itemdata*	itemdata;
	for(int i=0; i<GetItemCount(); i++)
	{
		itemdata=(sfl_itemdata*)GetItemData(i);
		if(itemdata->isFile && itemdata->knownFile==toupdate)
		{
			UpdateFile(toupdate, i, resort);
			Update(i);
			RedrawItems(i,i); // Lord KiRon
			//--- it creates a flickering for me ---
			//g_eMuleApp.m_pdlgEmule->m_wndSharedFiles.Check4StatUpdate(toupdate);

			return;
		}
	}

	EMULE_CATCH
}

void CSharedFilesCtrl::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	EMULE_TRY

	if (!lpDrawItemStruct->itemData)
		return;

	sfl_itemdata*	itemdata=(sfl_itemdata*)lpDrawItemStruct->itemData;
	CKnownFile*		file=itemdata->knownFile;
	CDC* odc = CDC::FromHandle(lpDrawItemStruct->hDC);
	int iODC = odc->SaveDC();
	UINT			iCalcFlag = (DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX|DT_END_ELLIPSIS);

	if (IsRightToLeftLanguage())
		iCalcFlag |= DT_RTLREADING;

	if((lpDrawItemStruct->itemAction | ODA_SELECT) &&
		(lpDrawItemStruct->itemState & ODS_SELECTED)) 
	{
		if(GetFocus()==this)
			odc->SetBkColor(m_crHighlight);
		else
			odc->SetBkColor(m_crNoHighlight);
	}  
	else
		odc->SetBkColor(GetBkColor());

	CMemDC dc(odc, &CRect(lpDrawItemStruct->rcItem));
	int iDC = dc.SaveDC();
	CFont	*oldFont=dc->SelectObject(GetFont());

	//--- xrmb:allyaknow ---
	if(m_allYaKnow)
	{
		if(file->GetSharedFile()==false)
			dc->SetTextColor(::GetSysColor(COLOR_GRAYTEXT));
		else
			dc->SetTextColor(::GetSysColor(COLOR_WINDOWTEXT));
	}
	//--- :xrmb ---
	else
	{
	#ifdef _SHOW_UNOFFERED_FILES_
		if ((!file->GetOfferedToServer()) && (g_eMuleApp.m_pServerConnect->IsConnected()))
			dc->SetTextColor(RGB(224,32,32));
		else
	#endif
			dc->SetTextColor(::GetSysColor(COLOR_WINDOWTEXT));
	}

	RECT cur_rec;
	memcpy2(&cur_rec, &lpDrawItemStruct->rcItem, sizeof(RECT));

	CHeaderCtrl *pHeaderCtrl = GetHeaderCtrl();
	int iCount = pHeaderCtrl->GetItemCount();
	int iImage;

	//--- all 0.. columns ---
	for(int c = 0; c < iCount; c++)
	{
		//--- get real column, may its moved ---
		int cc = pHeaderCtrl->OrderToIndex(c);

		//--- if the column is hidden, dont do anything ---
		if(IsColumnHidden(cc))
			continue;

 		if(cc)
			cur_rec.left = cur_rec.right;
		cur_rec.right = cur_rec.left + GetColumnWidth(cc);
		cur_rec.left += 4;

		//--- is it a file? ---
		if(itemdata->isFile)
		{
		//--- 0..8 are the emule classic columns ---
			switch(cc)
			{
				case SFL_COLUMN_FILENAME:

					// File Type
					if(g_eMuleApp.m_pGlobPrefs->ShowFileTypeIcon())
					{
						iImage = g_eMuleApp.GetFileTypeSystemImageIdx(file->GetFileName());
						if (g_eMuleApp.GetSystemImageList() != NULL)
							::ImageList_Draw(g_eMuleApp.GetSystemImageList(), iImage, dc->GetSafeHdc(), cur_rec.left, cur_rec.top, ILD_TRANSPARENT);
						cur_rec.left += 16 + 3;
					}

				case SFL_COLUMN_TYPE:
				case SFL_COLUMN_PRIORITY:
				case SFL_COLUMN_PERMISSION:
				case SFL_COLUMN_FILEID:
				case SFL_COLUMN_REQUESTS:
				case SFL_COLUMN_COMPLETESRC: //netwolf: complete sources
				case SFL_COLUMN_ACCEPTED:
				case SFL_COLUMN_TRANSFERRED:
				case SFL_COLUMN_UPLOADS:
					dc->DrawText(GetItemText(lpDrawItemStruct->itemID, cc), -1, &cur_rec, DT_LEFT | iCalcFlag);    
                    break; 

				case SFL_COLUMN_FILESIZE:
					dc->DrawText(GetItemText(lpDrawItemStruct->itemID, cc), -1, &cur_rec, DT_RIGHT | iCalcFlag);    
                    break; 

				case SFL_COLUMN_PARTTRAFFIC:	//--- part traffic ---		
					if (g_eMuleApp.m_pGlobPrefs->DoUsePT()) //Cax2 05/01/03
					{
						cur_rec.bottom--;
						cur_rec.top++;

						// added
						int iWidth = cur_rec.right - cur_rec.left-4; 
						int iHeight = cur_rec.bottom - cur_rec.top;

						if(iWidth>0)
						{
							//--- old bar draw ---
							cdcStatus.CreateCompatibleDC(&dc); 

							//--- the bar is not initalized yet? ---
							if(status==(HBITMAP)NULL)
							{
								status.CreateCompatibleBitmap(&dc, iWidth, iHeight); 
								m_statusWidth=iWidth;
							}
							else
							{
								//--- the we do it this way ---
								if(iWidth!=m_statusWidth)
								{
									status.DeleteObject();
									status.CreateCompatibleBitmap(&dc, iWidth, iHeight); 
									m_statusWidth=iWidth;
								}
							}

							CBitmap *oldBitmap=cdcStatus.SelectObject(&status); 

							RECT rec_status; 
							rec_status.left = 0; 
							rec_status.top = 0; 
							rec_status.bottom = iHeight; 
							rec_status.right = iWidth; 
							if(DrawStatusBarFile(&cdcStatus, &rec_status, file->statistic))
								dc->BitBlt(cur_rec.left, cur_rec.top, iWidth, iHeight,  &cdcStatus, 0, 0, SRCCOPY); 

							cdcStatus.SelectObject(oldBitmap);

							cdcStatus.DeleteDC();
						}

						//added end
						cur_rec.bottom++;
						cur_rec.top--;
					}
					break;
			}
		}

		//--- it is a part of a file ---
		else
		{
			//--- 0..8 are the emule classic columns ---
			switch(cc)
			{
				case SFL_COLUMN_FILENAME:
					dc->DrawText(GetItemText(lpDrawItemStruct->itemID, cc), -1, &cur_rec, DT_RIGHT | iCalcFlag);
					break;

				case SFL_COLUMN_PRIORITY:
				case SFL_COLUMN_ACCEPTED:
				case SFL_COLUMN_TRANSFERRED:
				case SFL_COLUMN_UPLOADS:
				case SFL_COLUMN_COMPLETESRC: // netwolf: complete sources (zegzav )
					dc->DrawText(GetItemText(lpDrawItemStruct->itemID, cc), -1, &cur_rec, /*DT_RIGHT*/DT_LEFT | iCalcFlag);
					break;

				case SFL_COLUMN_PARTTRAFFIC:	//--- part traffic ---		
					if (g_eMuleApp.m_pGlobPrefs->DoUsePT())	//Cax2 05/01/03
					{
						cur_rec.bottom--;
						cur_rec.top++;

						// added
						int iWidth = cur_rec.right - cur_rec.left-4; 
						int iHeight = cur_rec.bottom - cur_rec.top;

						if(iWidth>0)
						{
							//--- old bar draw ---
							cdcStatus.CreateCompatibleDC(&dc); 

							//--- the bar is not initalized yet? ---
							if(status==(HBITMAP)NULL)
							{
								status.CreateCompatibleBitmap(&dc, iWidth, iHeight); 
								m_statusWidth=iWidth;
							}
							else
							{
								//--- the we do it this way ---
								if(iWidth!=m_statusWidth)
								{
									status.DeleteObject();
									status.CreateCompatibleBitmap(&dc, iWidth, iHeight); 
									m_statusWidth=iWidth;
								}
							}
							CBitmap *oldBitmap=cdcStatus.SelectObject(&status); 

							RECT rec_status; 
							rec_status.left = 0; 
							rec_status.top = 0; 
							rec_status.bottom = iHeight; 
							rec_status.right = iWidth; 
							if(DrawStatusBarPart(&cdcStatus, &rec_status, file->statistic, itemdata->part))
								dc->BitBlt(cur_rec.left, cur_rec.top, iWidth, iHeight, &cdcStatus, 0, 0, SRCCOPY); 

							cdcStatus.SelectObject(oldBitmap);

							cdcStatus.DeleteDC();
						}

						//added end
						cur_rec.bottom++;
						cur_rec.top--;
					}
					break;
			}
		}
	}

	//--- draw rectangle around selected item ---
	if(lpDrawItemStruct->itemState & ODS_FOCUS)
	{
		RECT focus_rec;
		focus_rec.top    = lpDrawItemStruct->rcItem.top;
		focus_rec.bottom = lpDrawItemStruct->rcItem.bottom;
		focus_rec.left   = lpDrawItemStruct->rcItem.left + 1;
		focus_rec.right  = lpDrawItemStruct->rcItem.right - 1;
		if(GetFocus()==this)
		{
			brush.CreateSolidBrush(m_crFocusLine);
			m_pOldBrush = dc->SelectObject(&brush);		//eklmn: select a new brush
			dc->FrameRect(&focus_rec, &brush);
			dc->SelectObject(m_pOldBrush);	//eklmn: recover an old brush
		}
		else
		{
			m_pOldBrush = dc->SelectObject(&brush);		//eklmn: select a new brush
			brush.CreateSolidBrush(m_crNoFocusLine);
			dc->FrameRect(&focus_rec, &brush);
			dc->SelectObject(m_pOldBrush);	//eklmn: recover an old brush
		}
		brush.DeleteObject();
	}

	dc->SelectObject(oldFont);
	dc.RestoreDC(iDC);
	odc->RestoreDC(iODC);

	EMULE_CATCH
}

bool CSharedFilesCtrl::DrawStatusBarFile(CDC* dc, RECT* rect, const CFileStatistic& statistic)
{ 
	EMULE_TRY

	int	available, use;
	available=use=(rect->right-rect->left+1);
	uint32	fs=statistic.fileParent->GetFileSize();
	if(fs<PARTSIZE)
		use=max(1, available*((double)fs/PARTSIZE));

	RECT r;
	r.top=rect->top;
	r.bottom=rect->bottom;
	r.left=rect->left;
	r.right=rect->right;

	if(available==use)
	{
		brush.CreateSolidBrush(RGB(0x00, 0x00, 0x00));
		dc->FillRect(rect, &brush);
		brush.DeleteObject();
	}
	else
	{
		r.right=r.left+use;
		brush.CreateSolidBrush(RGB(0x00, 0x00, 0x00));
		m_pOldBrush = dc->SelectObject(&brush);
		dc->FillRect(&r, &brush);
		dc->SelectObject(m_pOldBrush);
		brush.DeleteObject();

		r.left=r.right;
		r.right=available;
		brush.CreateSolidBrush(RGB(0xCC, 0xCC, 0xCC));
		m_pOldBrush = dc->SelectObject(&brush);
		dc->FillRect(&r, &brush);
		dc->SelectObject(m_pOldBrush);
		brush.DeleteObject();
	}

	if(statistic.GetAllTimeTransferred()==0 || statistic.partTraffic==NULL)
		return true;

	double bpp=(double)fs/use;

	//--- traffigram? ---
	if(m_trafficgram)
	{
		TraffiGram(dc, rect, statistic, use, bpp);
	}

	//--- old boring bar style :) ---
	else
	{
		uint32	t;	// traffic

		for(int x=0; x<use; x++)
		{
			//--- xrmb:partprio ---
			bool	boh=statistic.fileParent->GetPartStatus(x*bpp/PARTSIZE)!=PR_PART_ON;
			//--- :xrmb ---

			//--- draw alltime parttraffic bar? ---
			if(m_display_atpte)
			{
				t=statistic.fileParent->GetTrafficPart(x*bpp, (x+1)*bpp);
				if(t)
				{
					pen.CreatePen(PS_SOLID, 0, GrayIt(boh, GetTrafficColor(t/bpp)));
					CPen *pOldPen = dc->SelectObject(&pen);
					dc->MoveTo(x, m_display_atpts);
					dc->LineTo(x, m_display_atpte);
					dc->SelectObject(pOldPen);		// FoRcHa
					pen.DeleteObject();
				}
			}

			//--- draw alltime blocktraffic bar? ---
			if(m_display_atbte)
			{
				t=statistic.fileParent->GetTrafficBlock(x*bpp, (x+1)*bpp);
				if(t)
				{
					pen.CreatePen(PS_SOLID, 0, GrayIt(boh, GetTrafficColor(t/bpp)));
					CPen *pOldPen = dc->SelectObject(&pen);
					dc->MoveTo(x, m_display_atbts);
					dc->LineTo(x, m_display_atbte);
					dc->SelectObject(pOldPen);		// FoRcHa
					pen.DeleteObject();
				}
			}

			//--- draw session blocktraffic bar? ---
			if(m_display_sbte)
			{
				t=statistic.fileParent->GetTrafficBlock(x*bpp, (x+1)*bpp, true);
				if(t)
				{
					pen.CreatePen(PS_SOLID, 0, GrayIt(boh, GetTrafficColor(t/bpp)));
					CPen *pOldPen = dc->SelectObject(&pen);
					dc->MoveTo(x, m_display_sbts);
					dc->LineTo(x, m_display_sbte);
					dc->SelectObject(pOldPen);		// FoRcHa
					pen.DeleteObject();
				}
			}
		}
	}

	return true;

	EMULE_CATCH

	return false;
} 

bool CSharedFilesCtrl::DrawStatusBarPart(CDC* dc, RECT* rect, const CFileStatistic& statistic, uint16 part)
{ 
	EMULE_TRY

	uint32 ps=statistic.fileParent->GetPartSize(part);

	RECT r;
	r.top=rect->top;
	r.bottom=rect->bottom;
	r.left=rect->left;
	r.right=rect->right;

	int use=max(1, (int)(rect->right - rect->left + 1)*((double)ps/PARTSIZE));

	if(ps!=PARTSIZE)
	{
		r.right=r.left+use;
		brush.CreateSolidBrush(RGB(0x00, 0x00, 0x00));
		m_pOldBrush = dc->SelectObject(&brush);
		dc->FillRect(&r, &brush);
		dc->SelectObject(m_pOldBrush);
		brush.DeleteObject();

		r.left=r.right;
		r.right=rect->right;
		brush.CreateSolidBrush(RGB(0xCC, 0xCC, 0xCC));
		m_pOldBrush = dc->SelectObject(&brush);
		dc->FillRect(&r, &brush);
		dc->SelectObject(m_pOldBrush);
		brush.DeleteObject();
	}
	else
	{
		brush.CreateSolidBrush(RGB(0x00, 0x00, 0x00));
		m_pOldBrush = dc->SelectObject(&brush);
		dc->FillRect(rect, &brush);
		dc->SelectObject(m_pOldBrush);
		brush.DeleteObject();
	}

	if(statistic.partTraffic==NULL || statistic.partTraffic[part]==0)
		return true;

	uint32 start=part*PARTSIZE;
	double bpp=(double)ps/use;

	//--- traffigram? ---
	if(m_trafficgram)
	{
		TraffiGram(dc, rect, statistic, use, bpp, start);
	}

	//--- old boring bar style :) ---
	else
	{
		uint32 t;

		//--- draw alltime parttraffic bar? ---
		if(m_display_atpte)
		{
			t=statistic.fileParent->GetPartTraffic(part);
			if(t)
			{
				r.top=m_display_atpts;
				r.bottom=m_display_atpte;
				r.left=rect->left;
				r.right=rect->left+use;
				brush.CreateSolidBrush(GetTrafficColor(static_cast<double>(t)/ps));
				m_pOldBrush = dc->SelectObject(&brush);
				dc->FillRect(&r, &brush);
				dc->SelectObject(m_pOldBrush);
				brush.DeleteObject();
				r.bottom=rect->bottom;
			}
		}

		for(int x=0; x<use; x++)
		{
			//--- draw alltime blocktraffic bar? ---
			if(m_display_atbte)
			{
				t=statistic.fileParent->GetTrafficBlock(start+x*bpp, start+(x+1)*bpp);
				if(t)
				{
					pen.CreatePen(PS_SOLID, 0, GetTrafficColor(t/bpp));
					CPen *pOldPen = dc->SelectObject(&pen);
					dc->MoveTo(x, m_display_atbts);
					dc->LineTo(x, m_display_atbte);
					dc->SelectObject(pOldPen);		// FoRcHa
					pen.DeleteObject();
				}
			}

			//--- draw session blocktraffic bar? ---
			if(m_display_sbte)
			{
				t=statistic.fileParent->GetTrafficBlock(start+x*bpp, start+(x+1)*bpp, true);
				if(t)
				{
					pen.CreatePen(PS_SOLID, 0, GetTrafficColor(t/bpp));
					CPen *pOldPen = dc->SelectObject(&pen);
					dc->MoveTo(x, m_display_sbts);
					dc->LineTo(x, m_display_sbte);
					dc->SelectObject(pOldPen);		// FoRcHa
					pen.DeleteObject();
				}
			}
		}
	}

	return true;

	EMULE_CATCH

	return false;
} 

void CSharedFilesCtrl::OnDoubleClick(NMHDR* pNMHDR, LRESULT* pResult)
{
	EMULE_TRY

	NMITEMACTIVATE *i=(NMITEMACTIVATE*)pNMHDR;

    if(i->iItem == -1)
        return;

	//--- if shift+dblclk hide all no traffic parts ---
	bool	onlyWithTraffic=i->uKeyFlags & LVKF_SHIFT;
	bool	onlyWithSessionTraffic=i->uKeyFlags & LVKF_SHIFT && i->uKeyFlags & LVKF_CONTROL;

	//--- get data from double clicked item ---
	sfl_itemdata	*itemdataParent=(sfl_itemdata*)GetItemData(i->iItem);

	//--- is it a file? ---
	if(itemdataParent->isFile==false)
	{
		switch(i->iSubItem)
		{
			case SFL_COLUMN_PRIORITY:
				{
					//--- no blocking and hidding for partfiles! ---
					if(itemdataParent->knownFile->IsPartFile())
						break;

					int setTo=MP_SFL_PARTON;
					switch(itemdataParent->knownFile->GetPartStatus(itemdataParent->part))
					{
						case PR_PART_ON:
							setTo=PR_PART_HIDDEN;
							break;
						case PR_PART_HIDDEN:
							setTo=PR_PART_OFF;
							break;
						case PR_PART_OFF:
						default:
							setTo=PR_PART_ON;
							break;
					}
					itemdataParent->knownFile->SetPartStatus(itemdataParent->part, setTo);
					UpdateItem(itemdataParent->knownFile);
				}
				break;
		}
		return;
	}

	CKnownFile	*file=itemdataParent->knownFile;

	//--- toggle open ---
	itemdataParent->isOpen=!itemdataParent->isOpen;

	//--- is this file already open? ---
	//!!! ATTN i toggled isOpen already... you will not understand why I did this :) ---
	if(itemdataParent->isOpen==false)
	{
		SetRedraw(false);

		//--- delete all part-childs ---
		for(uint16 part=0; part<itemdataParent->parts; part++)
		{
			sfl_itemdata *itemdata=(sfl_itemdata*)GetItemData(i->iItem+1);
			if (itemdata->isFile) break;	//Cax2 14/01/03	bugfix
			SetItemData(i->iItem+1, NULL);
			DeleteItem(i->iItem+1);
			if(itemdata) delete itemdata;
		}

		SetRedraw(true);
	}

	//--- it is not open ---
	else
	{
		if(g_eMuleApp.m_pGlobPrefs->DoUsePT() && file->GetPartCount()>1)	//Cax2 05/01/03
		{
			CString	buffer;
			uint16	parts=0;
			
			SetRedraw(false);

			for(uint16 part=0; part<file->GetPartCount(); part++)
			{
				//--- no no traffic items? ---
				if(onlyWithTraffic && file->GetPartTraffic(part, onlyWithSessionTraffic)==0)
					continue;

				parts++;

				sfl_itemdata	*itemdata=new sfl_itemdata;
				itemdata->isFile=false;
				itemdata->isOpen=false;
				itemdata->knownFile=file;
				itemdata->part=part;
				itemdata->parts=0;

				buffer.Format(_T("%i"), part);
				InsertItem(LVIF_TEXT|LVIF_PARAM, i->iItem+parts, buffer, 0, 0, 0, (LPARAM)itemdata);
			}

			SetRedraw(true);

			itemdataParent->parts=parts;

			//--- no parts added? then we can close it ---
			if(parts==0)
				itemdataParent->isOpen=false;

			//--- ok, thats why i toggled the isOpen before :) ---
			UpdateFile(file, i->iItem);
		}
	}

	*pResult=0;

	EMULE_CATCH
}

void CSharedFilesCtrl::SetColoring(uint8 mode)
{
	EMULE_TRY

	switch(mode)
	{
	case 0:
		GetTrafficColor=&GetTrafficColor0;
		break;

	case 1:
		GetTrafficColor=&GetTrafficColor1;
		break;

	case 2:
		GetTrafficColor=&GetTrafficColor2;
		break;

	case 3:
		GetTrafficColor=&GetTrafficColor3;
		break;

	default:
		GetTrafficColor=&GetTrafficColor0;
	}

	EMULE_CATCH
}

void CSharedFilesCtrl::SetDisplay(uint8 mode, bool redraw)	
{
	EMULE_TRY

	m_display=mode; 

	//--- should be 17 pixel high, i hope that never changes, but i try to save cpu where i can ---

	switch(m_display)
	{
	case 1:
		m_display_atpts	= 0;
		m_display_atpte	= 4;
		m_display_atbts	= 5;
		m_display_atbte	= 16;
		m_display_sbts	= 0;
		m_display_sbte	= 0;
		m_trafficgram	= false;
		break;

	case 2:
		m_display_atpts	= 0;
		m_display_atpte	= 4;
		m_display_atbts	= 5;
		m_display_atbte	= 11;
		m_display_sbts	= 12;
		m_display_sbte	= 16;
		m_trafficgram	= false;
		break;

	case 3:	// traffigram
		m_trafficgram=true;
		break;

	case 0:
	default:
		m_display_atpts	= 0;
		m_display_atpte	= 16;
		m_display_atbts	= 0;
		m_display_atbte	= 0;
		m_display_sbts	= 0;
		m_display_sbte	= 0;

		m_trafficgram	= false;
	}

	if(redraw) 
		RedrawItems(0, GetItemCount());

	EMULE_CATCH
}

void CSharedFilesCtrl::TraffiGram(CDC* dc, RECT* rect, const CFileStatistic& statistic, int use, double bpp, uint32 start)
{
	EMULE_TRY

	uint32 tt=0;
	//--- needs highest value! ---
	for(int x=0; x<use; x++)
	{
		tt=max(tt, statistic.fileParent->GetTrafficBlock(start+x*bpp, start+(x+1)*bpp));
	}

	int h=rect->bottom-rect->top+1;	// height
	int	lh=0;		// last height
	int	ch=0;		// current height
	uint32	lt=0;	// last traffic
	uint32	tph=tt/h;	// traffic per height pixel
	uint32	t;
	for(int x=0; x<use; x++)
	{
		t=statistic.fileParent->GetTrafficBlock(start+x*bpp, start+(x+1)*bpp);
		ch=h-static_cast<int>(h*static_cast<double>(t)/tt+0.5);
		if(t) 
			dc->SetPixel(x, ch, GetTrafficColor(t/bpp));

		//--- fill space between last and now ---
		if(x && lh!=ch)
		{
			int d=1;
			if(lh>ch)
				d=-1;
			
			for(int i=1; i<abs(lh-ch)/2+1; i++)
			{
				dc->SetPixel(x-1,	lh+i*d, GetTrafficColor((tt-tph*(lh+i*d))/bpp));
				dc->SetPixel(x,		ch-i*d, GetTrafficColor((tt-tph*(ch-i*d))/bpp));
			}
		}

		lh=ch;
		lt=t;
	}

	EMULE_CATCH
}

COLORREF GetTrafficColor0(double f)
{
	//--- COLORING MODE 1 --- RAINBOW ---
	//--- 0..1   black to red ---
	if(f<1)
		return RGB((BYTE)(255*f), 0, 0);
	
	//--- 1..3   red to yellow ---
	if(f<3)
		return RGB(255, (uint8)(255*(f-1)/2.0), 0);

	//--- 3..6   yellow to green ---
	if(f<6)
		return RGB((uint8)(255*((6-f)/3.0)), 255, 0);

	//--- 6..10   green to cyan ---
	if(f<10)
		return RGB(0, 255, (uint8)(255*((f-6)/4.0)));

	//--- 10..15   cyan to blue ---
	if(f<15)
		return RGB(0, (uint8)(255*((15-f)/5.0)), 255);

	//--- 15..21   blue to pink ---
	if(f<21)
		return RGB((uint8)(255*((f-15)/6.0)), 0, 255);

	//--- 21..28   pink to white ---
	if(f<28)
		return RGB(255, (uint8)(255*((28-f)/7.0)), 255);

	return RGB(255, 255, 255);
}

COLORREF GetTrafficColor1(double f)
{
	//--- COLORING MODE 1 --- RAINBOW ---
	//--- 0..1   black to red ---
	if(f<1)
		return RGB((BYTE)(255*f), 0, 0);
	
	//--- 1..2   red to yellow ---
	if(f<2)
		return RGB(255, (uint8)(255*(f-1)), 0);

	//--- 2..3   yellow to green ---
	if(f<3)
		return RGB((uint8)(255*((3-f))), 255, 0);

	//--- 3..4   green to cyan ---
	if(f<4)
		return RGB(0, 255, (uint8)(255*((f-3))));

	//--- 4..5   cyan to blue ---
	if(f<5)
		return RGB(0, (uint8)(255*((5-f))), 255);

	//--- 5..6   blue to pink ---
	if(f<6)
		return RGB((uint8)(255*((f-5))), 0, 255);

	//--- 6..7   pink to white ---
	if(f<7)
		return RGB(255, (uint8)(255*((7-f))), 255);

	return RGB(255, 255, 255);
}

COLORREF GetTrafficColor2(double f)
{
	//--- COLORING MODE 2 --- like in download ---
	return RGB(0, (210-(22*(f-1)) <  0)? 0:210-(22*(f-1)), 255);	
}

COLORREF GetTrafficColor3(double f)
{
	//--- girlie mode ---
	return RGB(255, 0, (210-(22*(f-1)) <  0)? 0:210-(22*(f-1)));	
}
//--- :xrmb ---

void CSharedFilesCtrl::ShowFilesCount() {
	CString counter;
	counter.Format(_T(" (%i)"),GetItemCount() );
	g_eMuleApp.m_pdlgEmule->m_wndSharedFiles.GetDlgItem(IDC_TRAFFIC_TEXT)->SetWindowText(GetResString(IDS_SF_FILES)+counter  );
}

double CSharedFilesCtrl::CompleteSourcesCmpValue(CKnownFile* item, bool second)
{
	uint16 nCountLo, nCountHi;
	bool bPartFile= item->IsPartFile();

	if (bPartFile)
		((CPartFile*)item)->GetCompleteSourcesRange(&nCountLo, &nCountHi);
	else
		item->GetCompleteSourcesRange(&nCountLo, &nCountHi);

	return ((nCountLo == 0) ? ((nCountHi == 0) ? ((bPartFile) ? 2.0 : 0.0) : (2.0 - (1.0 / static_cast<double>(nCountHi)))) : (second) ? static_cast<double>(nCountHi) + 3.0 - (1.0 / static_cast<double>(nCountLo)) : static_cast<double>(nCountLo) + 3.0 - (1.0 / static_cast<double>(nCountHi)));
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSharedFilesCtrl::UpdateOfferedItems()
{
	EMULE_TRY

#ifdef _SHOW_UNOFFERED_FILES_
	if (GetItemCount())
		RedrawItems(0, GetItemCount()-1);
#endif

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSharedFilesCtrl::OnGetDispInfo(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);

	if (g_eMuleApp.m_pdlgEmule->IsRunning()){
		// Although we have an owner drawn listview control we store the text for the primary item in the listview, to be
		// capable of quick searching those items via the keyboard. Because our listview items may change their contents,
		// we do this via a text callback function. The listview control will send us the LVN_DISPINFO notification if
		// it needs to know the contents of the primary item.
		//
		// But, the listview control sends this notification all the time, even if we do not search for an item. At least
		// this notification is only sent for the visible items and not for all items in the list. Though, because this
		// function is invoked *very* often, no *NOT* put any time consuming code here in.

		if (pDispInfo->item.mask & (LVIF_TEXT | LVIF_PARAM)){
			sfl_itemdata* pData = reinterpret_cast<sfl_itemdata*>(pDispInfo->item.lParam);
			if(pData)
			{
				const CKnownFile* pFile = pData->knownFile;
				if (pFile != NULL){
					switch (pDispInfo->item.iSubItem){
						case 0:
							if (pDispInfo->item.cchTextMax > 0){
								_tcsncpy(pDispInfo->item.pszText, pFile->GetFileName(), pDispInfo->item.cchTextMax);
								pDispInfo->item.pszText[pDispInfo->item.cchTextMax-1] = _T('\0');
							}
							break;
						default:
							// shouldn't happen
							pDispInfo->item.pszText[0] = _T('\0');
							break;
					}
				}
			}
		}
	}
	*pResult = 0;
	EMULE_CATCH
}

BOOL CSharedFilesCtrl::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN || pMsg->message == WM_SYSKEYDOWN)
	{
		int iMessage = 0;
		short nCode = GetCodeFromPressedKeys(pMsg);
		bool bJustOne  = (GetSelectedCount() == 1);
		int iSel = GetSelectionMark();
		
		if (iSel == -1)
			return __super::PreTranslateMessage(pMsg);

		sfl_itemdata *pItemData = reinterpret_cast<sfl_itemdata*>(GetItemData(iSel));

		if ( nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexShOpenFolder) &&
			 !(pItemData->knownFile->IsPartFile()) && bJustOne )
		{
			iMessage = MP_OPENFOLDER;
		}
		else if (nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexShComments) && bJustOne)
		{
			iMessage = MP_CMT;
		}
		else if (nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexShED2KLink))
		{
			iMessage = MP_GETED2KLINK;
		}
		else if (nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexShED2kLinkHtml))
		{
			iMessage = MP_GETHTMLED2KLINK;
		}
		else if (nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexShED2kLinkSource))
		{
			iMessage = MP_GETSOURCEED2KLINK;
		}

		if (iMessage > 0)
		{
			PostMessage(WM_COMMAND, iMessage);
			return TRUE;
		}
	}

	return __super::PreTranslateMessage(pMsg);
}
